/*
    `impl-AsynchronousFlashReadout-DualRail.v'
    Balsa Verilog netlist file
    Created: Mon Jul 20 04:11:42 CEST 2015
    By: sokh@bushmills.nvlsi.no (Linux)
    With net-verilog (balsa-netlist) version: 4.0
    Using technology: BorealisTech/dual_b/sim=modelsim
    Command line : (balsa-netlist --technology BorealisTech/dual_b/sim=modelsim -I . -l impl-AsynchronousFlashReadout-DualRail.lst -L impl-AsynchronousFlashReadout-DualRail.log --simulation-initialise --basename impl-AsynchronousFlashReadout-DualRail [AsynchronousFlashReadout])

    Using `simulation-initialise'
    You must set the following preprocessor directives to use this file:
        balsa_simulate: set if you wish to initialise signal values during sim.
        balsa_init_time: duration of forced initialisation

    Using `propagate-globals'
    The design contains the following global nets
		global-signal:  initialise input 1
*/

`timescale 1ns/1ps

module MC2X2_ES34 (
  Z,
  A,
  B,
  initialise
);
  output Z;
  input A;
  input B;
  input initialise;
  wire nReset;
  MC2CNX2_ES34 I0 (Z, A, B, nReset);
  INVD0BWP7T I1 (initialise, nReset);
endmodule

module dr_ao21 (
  a0,
  a1,
  b0,
  b1,
  c0,
  c1,
  q0,
  q1,
  initialise
);
  input a0;
  input a1;
  input b0;
  input b1;
  input c0;
  input c1;
  output q0;
  output q1;
  input initialise;
  wire [17:0] internal_0n;
  wire [7:0] minterm_0n;
  MC2X2_ES34 I0 (minterm_0n[0], internal_0n[0], internal_0n[1], initialise);
  BUFFD1BWP7T I1 (c0, internal_0n[1]);
  MC2X2_ES34 I2 (internal_0n[0], a0, b0, initialise);
  MC2X2_ES34 I3 (minterm_0n[1], internal_0n[2], internal_0n[3], initialise);
  BUFFD1BWP7T I4 (c1, internal_0n[3]);
  MC2X2_ES34 I5 (internal_0n[2], a0, b0, initialise);
  MC2X2_ES34 I6 (minterm_0n[2], internal_0n[4], internal_0n[5], initialise);
  BUFFD1BWP7T I7 (c0, internal_0n[5]);
  MC2X2_ES34 I8 (internal_0n[4], a0, b1, initialise);
  MC2X2_ES34 I9 (minterm_0n[3], internal_0n[6], internal_0n[7], initialise);
  BUFFD1BWP7T I10 (c1, internal_0n[7]);
  MC2X2_ES34 I11 (internal_0n[6], a0, b1, initialise);
  MC2X2_ES34 I12 (minterm_0n[4], internal_0n[8], internal_0n[9], initialise);
  BUFFD1BWP7T I13 (c0, internal_0n[9]);
  MC2X2_ES34 I14 (internal_0n[8], a1, b0, initialise);
  MC2X2_ES34 I15 (minterm_0n[5], internal_0n[10], internal_0n[11], initialise);
  BUFFD1BWP7T I16 (c1, internal_0n[11]);
  MC2X2_ES34 I17 (internal_0n[10], a1, b0, initialise);
  MC2X2_ES34 I18 (minterm_0n[6], internal_0n[12], internal_0n[13], initialise);
  BUFFD1BWP7T I19 (c0, internal_0n[13]);
  MC2X2_ES34 I20 (internal_0n[12], a1, b1, initialise);
  MC2X2_ES34 I21 (minterm_0n[7], internal_0n[14], internal_0n[15], initialise);
  BUFFD1BWP7T I22 (c1, internal_0n[15]);
  MC2X2_ES34 I23 (internal_0n[14], a1, b1, initialise);
  OR3D1BWP7T I24 (minterm_0n[0], minterm_0n[2], minterm_0n[4], q0);
  ND2D1BWP7T I25 (internal_0n[16], internal_0n[17], q1);
  NR2D1BWP7T I26 (minterm_0n[6], minterm_0n[7], internal_0n[17]);
  NR3D1BWP7T I27 (minterm_0n[1], minterm_0n[3], minterm_0n[5], internal_0n[16]);
endmodule

module dr_and2 (
  i0_0,
  i0_1,
  i1_0,
  i1_1,
  q_0,
  q_1,
  initialise
);
  input i0_0;
  input i0_1;
  input i1_0;
  input i1_1;
  output q_0;
  output q_1;
  input initialise;
  wire n0_0n;
  wire n1_0n;
  wire n2_0n;
  OR3D1BWP7T I0 (n0_0n, n1_0n, n2_0n, q_0);
  MC2X2_ES34 I1 (n0_0n, i0_0, i1_0, initialise);
  MC2X2_ES34 I2 (n1_0n, i0_0, i1_1, initialise);
  MC2X2_ES34 I3 (n2_0n, i0_1, i1_0, initialise);
  MC2X2_ES34 I4 (q_1, i0_1, i1_1, initialise);
endmodule

module dr_ineq_comp (
  i0_0,
  i0_1,
  i1_0,
  i1_1,
  i2_0,
  i2_1,
  i3_0,
  i3_1,
  q0_0,
  q0_1,
  q1_0,
  q1_1,
  initialise
);
  input i0_0;
  input i0_1;
  input i1_0;
  input i1_1;
  input i2_0;
  input i2_1;
  input i3_0;
  input i3_1;
  output q0_0;
  output q0_1;
  output q1_0;
  output q1_1;
  input initialise;
  dr_ao21 I0 (i2_0, i2_1, i1_0, i1_1, i0_0, i0_1, q0_0, q0_1, initialise);
  dr_and2 I1 (i1_0, i1_1, i3_0, i3_1, q1_0, q1_1, initialise);
endmodule

module BrzBinaryFuncConstR_1_4_3_s8_LessThan_s5_f_m5m (
  out_0r, out_0a0d, out_0a1d,
  inpA_0r, inpA_0a0d, inpA_0a1d,
  initialise
);
  input out_0r;
  output out_0a0d;
  output out_0a1d;
  output inpA_0r;
  input [3:0] inpA_0a0d;
  input [3:0] inpA_0a1d;
  input initialise;
  wire [3:0] a1_0n;
  wire [3:0] a0_0n;
  wire [3:0] compOut1_0n;
  wire [3:0] compOut0_0n;
  wire [2:0] c1_0n;
  wire [2:0] c0_0n;
  wire [2:0] internalA1_0n;
  wire [2:0] internalA0_0n;
  wire [2:0] internalB1_0n;
  wire [2:0] internalB0_0n;
  supply0 gnd;
  BUFFD1BWP7T I0 (internalA1_0n[0], out_0a1d);
  BUFFD1BWP7T I1 (internalA0_0n[0], out_0a0d);
  dr_ineq_comp I2 (compOut0_0n[3], compOut1_0n[3], c0_0n[2], c1_0n[2], compOut0_0n[2], compOut1_0n[2], c0_0n[1], c1_0n[1], internalA0_0n[2], internalA1_0n[2], internalB0_0n[0], internalB1_0n[0], initialise);
  dr_ao21 I3 (compOut0_0n[0], compOut1_0n[0], c0_0n[0], c1_0n[0], compOut0_0n[1], compOut1_0n[1], internalA0_0n[1], internalA1_0n[1], initialise);
  dr_ao21 I4 (internalA0_0n[1], internalA1_0n[1], internalB0_0n[0], internalB1_0n[0], internalA0_0n[2], internalA1_0n[2], internalA0_0n[0], internalA1_0n[0], initialise);
  BUFFD1BWP7T I5 (a1_0n[3], c1_0n[2]);
  BUFFD1BWP7T I6 (a0_0n[3], c0_0n[2]);
  BUFFD1BWP7T I7 (out_0r, compOut0_0n[3]);
  BUFFD1BWP7T I8 (gnd, compOut1_0n[3]);
  BUFFD1BWP7T I9 (a1_0n[1], c1_0n[0]);
  BUFFD1BWP7T I10 (a0_0n[1], c0_0n[0]);
  BUFFD1BWP7T I11 (out_0r, compOut0_0n[1]);
  BUFFD1BWP7T I12 (gnd, compOut1_0n[1]);
  BUFFD1BWP7T I13 (a1_0n[2], c0_0n[1]);
  BUFFD1BWP7T I14 (a0_0n[2], c1_0n[1]);
  BUFFD1BWP7T I15 (a1_0n[2], compOut1_0n[2]);
  BUFFD1BWP7T I16 (a0_0n[2], compOut0_0n[2]);
  BUFFD1BWP7T I17 (out_0r, compOut0_0n[0]);
  BUFFD1BWP7T I18 (gnd, compOut1_0n[0]);
  BUFFD1BWP7T I19 (inpA_0a0d[0], a1_0n[0]);
  BUFFD1BWP7T I20 (inpA_0a0d[1], a1_0n[1]);
  BUFFD1BWP7T I21 (inpA_0a0d[2], a1_0n[2]);
  BUFFD1BWP7T I22 (inpA_0a0d[3], a1_0n[3]);
  BUFFD1BWP7T I23 (inpA_0a1d[0], a0_0n[0]);
  BUFFD1BWP7T I24 (inpA_0a1d[1], a0_0n[1]);
  BUFFD1BWP7T I25 (inpA_0a1d[2], a0_0n[2]);
  BUFFD1BWP7T I26 (inpA_0a1d[3], a0_0n[3]);
  BUFFD1BWP7T I27 (out_0r, inpA_0r);
endmodule

module dr_fa_p (
  a_0,
  a_1,
  b_0,
  b_1,
  co_0,
  co_1,
  sum_0,
  sum_1,
  initialise
);
  input a_0;
  input a_1;
  input b_0;
  input b_1;
  output co_0;
  output co_1;
  output sum_0;
  output sum_1;
  input initialise;
  wire n0_0n;
  wire n1_0n;
  wire n2_0n;
  wire n3_0n;
  AN2D1BWP7T I0 (a_0, b_0, co_0);
  AO21D1BWP7T I1 (a_0, b_1, a_1, co_1);
  OR2D1BWP7T I2 (n1_0n, n2_0n, sum_0);
  OR2D1BWP7T I3 (n0_0n, n3_0n, sum_1);
  MC2X2_ES34 I4 (n3_0n, a_1, b_1, initialise);
  MC2X2_ES34 I5 (n2_0n, a_1, b_0, initialise);
  MC2X2_ES34 I6 (n1_0n, a_0, b_1, initialise);
  MC2X2_ES34 I7 (n0_0n, a_0, b_0, initialise);
endmodule

module dr_xor2 (
  i0_0,
  i0_1,
  i1_0,
  i1_1,
  q_0,
  q_1,
  initialise
);
  input i0_0;
  input i0_1;
  input i1_0;
  input i1_1;
  output q_0;
  output q_1;
  input initialise;
  wire n0_0n;
  wire n1_0n;
  wire n2_0n;
  wire n3_0n;
  OR2D1BWP7T I0 (n0_0n, n3_0n, q_0);
  MC2X2_ES34 I1 (n3_0n, i0_1, i1_1, initialise);
  MC2X2_ES34 I2 (n0_0n, i0_0, i1_0, initialise);
  OR2D1BWP7T I3 (n1_0n, n2_0n, q_1);
  MC2X2_ES34 I4 (n1_0n, i0_0, i1_1, initialise);
  MC2X2_ES34 I5 (n2_0n, i0_1, i1_0, initialise);
endmodule

module BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m (
  out_0r, out_0a0d, out_0a1d,
  inpA_0r, inpA_0a0d, inpA_0a1d,
  initialise
);
  input out_0r;
  output [1:0] out_0a0d;
  output [1:0] out_0a1d;
  output inpA_0r;
  input [1:0] inpA_0a0d;
  input [1:0] inpA_0a1d;
  input initialise;
  wire [1:0] a1_0n;
  wire [1:0] a0_0n;
  wire [1:0] c1_0n;
  wire [1:0] c0_0n;
  supply0 gnd;
  BUFFD1BWP7T I0 (out_0r, c0_0n[0]);
  BUFFD1BWP7T I1 (gnd, c1_0n[0]);
  dr_xor2 I2 (a0_0n[1], a1_0n[1], c0_0n[1], c1_0n[1], out_0a0d[1], out_0a1d[1], initialise);
  dr_fa_p I3 (a0_0n[0], a1_0n[0], c0_0n[0], c1_0n[0], c0_0n[1], c1_0n[1], out_0a0d[0], out_0a1d[0], initialise);
  BUFFD1BWP7T I4 (inpA_0a0d[0], a0_0n[0]);
  BUFFD1BWP7T I5 (inpA_0a0d[1], a0_0n[1]);
  BUFFD1BWP7T I6 (inpA_0a1d[0], a1_0n[0]);
  BUFFD1BWP7T I7 (inpA_0a1d[1], a1_0n[1]);
  BUFFD1BWP7T I8 (out_0r, inpA_0r);
endmodule

module dr_ha (
  a_0,
  a_1,
  b_0,
  b_1,
  co_0,
  co_1,
  sum_0,
  sum_1,
  initialise
);
  input a_0;
  input a_1;
  input b_0;
  input b_1;
  output co_0;
  output co_1;
  output sum_0;
  output sum_1;
  input initialise;
  wire n0_0n;
  wire n1_0n;
  wire n2_0n;
  wire n3_0n;
  AN2D1BWP7T I0 (a_1, b_1, co_1);
  AO21D1BWP7T I1 (a_1, b_0, a_0, co_0);
  OR2D1BWP7T I2 (n1_0n, n2_0n, sum_1);
  OR2D1BWP7T I3 (n0_0n, n3_0n, sum_0);
  MC2X2_ES34 I4 (n3_0n, a_1, b_1, initialise);
  MC2X2_ES34 I5 (n2_0n, a_1, b_0, initialise);
  MC2X2_ES34 I6 (n1_0n, a_0, b_1, initialise);
  MC2X2_ES34 I7 (n0_0n, a_0, b_0, initialise);
endmodule

module BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m (
  out_0r, out_0a0d, out_0a1d,
  inpA_0r, inpA_0a0d, inpA_0a1d,
  initialise
);
  input out_0r;
  output [3:0] out_0a0d;
  output [3:0] out_0a1d;
  output inpA_0r;
  input [3:0] inpA_0a0d;
  input [3:0] inpA_0a1d;
  input initialise;
  wire [3:0] a1_0n;
  wire [3:0] a0_0n;
  wire [3:0] c1_0n;
  wire [3:0] c0_0n;
  supply0 gnd;
  BUFFD1BWP7T I0 (out_0r, c0_0n[0]);
  BUFFD1BWP7T I1 (gnd, c1_0n[0]);
  dr_xor2 I2 (a0_0n[3], a1_0n[3], c0_0n[3], c1_0n[3], out_0a0d[3], out_0a1d[3], initialise);
  dr_ha I3 (a0_0n[1], a1_0n[1], c0_0n[1], c1_0n[1], c0_0n[2], c1_0n[2], out_0a0d[1], out_0a1d[1], initialise);
  dr_ha I4 (a0_0n[2], a1_0n[2], c0_0n[2], c1_0n[2], c0_0n[3], c1_0n[3], out_0a0d[2], out_0a1d[2], initialise);
  dr_fa_p I5 (a0_0n[0], a1_0n[0], c0_0n[0], c1_0n[0], c0_0n[1], c1_0n[1], out_0a0d[0], out_0a1d[0], initialise);
  BUFFD1BWP7T I6 (inpA_0a0d[0], a0_0n[0]);
  BUFFD1BWP7T I7 (inpA_0a0d[1], a0_0n[1]);
  BUFFD1BWP7T I8 (inpA_0a0d[2], a0_0n[2]);
  BUFFD1BWP7T I9 (inpA_0a0d[3], a0_0n[3]);
  BUFFD1BWP7T I10 (inpA_0a1d[0], a1_0n[0]);
  BUFFD1BWP7T I11 (inpA_0a1d[1], a1_0n[1]);
  BUFFD1BWP7T I12 (inpA_0a1d[2], a1_0n[2]);
  BUFFD1BWP7T I13 (inpA_0a1d[3], a1_0n[3]);
  BUFFD1BWP7T I14 (out_0r, inpA_0r);
endmodule

module BrzCase_2_4_s13_0_3b1_3b2_3b3 (
  inp_0r0d, inp_0r1d, inp_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  initialise
);
  input [1:0] inp_0r0d;
  input [1:0] inp_0r1d;
  output inp_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  input initialise;
  wire [1:0] internal_0n;
  wire elseAck_0n;
  wire [1:0] inpComplete_0n;
  wire inpDone_0n;
  wire outDone_0n;
  wire [3:0] int0_0n;
  MC2X2_ES34 I0 (inp_0a, outDone_0n, inpDone_0n, initialise);
  NR2D1BWP7T I1 (activateOut_0a, activateOut_1a, internal_0n[0]);
  NR2D1BWP7T I2 (activateOut_2a, activateOut_3a, internal_0n[1]);
  ND2D1BWP7T I3 (internal_0n[0], internal_0n[1], outDone_0n);
  MC2X2_ES34 I4 (int0_0n[0], inp_0r0d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I5 (int0_0n[1], inp_0r0d[1], inp_0r1d[0], initialise);
  MC2X2_ES34 I6 (int0_0n[2], inp_0r1d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I7 (int0_0n[3], inp_0r1d[1], inp_0r1d[0], initialise);
  BUFFD1BWP7T I8 (int0_0n[3], activateOut_3r);
  BUFFD1BWP7T I9 (int0_0n[2], activateOut_2r);
  BUFFD1BWP7T I10 (int0_0n[1], activateOut_1r);
  BUFFD1BWP7T I11 (int0_0n[0], activateOut_0r);
  MC2X2_ES34 I12 (inpDone_0n, inpComplete_0n[0], inpComplete_0n[1], initialise);
  OR2D1BWP7T I13 (inp_0r0d[0], inp_0r1d[0], inpComplete_0n[0]);
  OR2D1BWP7T I14 (inp_0r0d[1], inp_0r1d[1], inpComplete_0n[1]);
endmodule

module BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m (
  inp_0r0d, inp_0r1d, inp_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a,
  initialise
);
  input [3:0] inp_0r0d;
  input [3:0] inp_0r1d;
  output inp_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  input initialise;
  wire [30:0] internal_0n;
  wire elseAck_0n;
  wire [3:0] inpComplete_0n;
  wire inpDone_0n;
  wire outDone_0n;
  wire [11:0] int0_0n;
  MC2X2_ES34 I0 (inp_0a, outDone_0n, inpDone_0n, initialise);
  NR3D1BWP7T I1 (activateOut_0a, activateOut_1a, activateOut_2a, internal_0n[0]);
  NR2D1BWP7T I2 (activateOut_3a, activateOut_4a, internal_0n[1]);
  ND2D1BWP7T I3 (internal_0n[0], internal_0n[1], outDone_0n);
  MC2X2_ES34 I4 (internal_0n[2], inp_0r1d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I5 (internal_0n[3], inp_0r1d[1], inp_0r1d[0], initialise);
  MC2X2_ES34 I6 (int0_0n[0], internal_0n[2], internal_0n[3], initialise);
  MC2X2_ES34 I7 (internal_0n[4], inp_0r1d[2], inp_0r1d[1], initialise);
  BUFFD1BWP7T I8 (inp_0r1d[0], internal_0n[5]);
  MC2X2_ES34 I9 (int0_0n[1], internal_0n[4], internal_0n[5], initialise);
  MC2X2_ES34 I10 (internal_0n[6], inp_0r1d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I11 (internal_0n[7], inp_0r0d[1], inp_0r1d[0], initialise);
  MC2X2_ES34 I12 (int0_0n[2], internal_0n[6], internal_0n[7], initialise);
  MC2X2_ES34 I13 (internal_0n[8], inp_0r1d[2], inp_0r0d[1], initialise);
  BUFFD1BWP7T I14 (inp_0r1d[0], internal_0n[9]);
  MC2X2_ES34 I15 (int0_0n[3], internal_0n[8], internal_0n[9], initialise);
  MC2X2_ES34 I16 (internal_0n[10], inp_0r1d[2], inp_0r1d[1], initialise);
  BUFFD1BWP7T I17 (inp_0r0d[0], internal_0n[11]);
  MC2X2_ES34 I18 (int0_0n[4], internal_0n[10], internal_0n[11], initialise);
  MC2X2_ES34 I19 (internal_0n[12], inp_0r1d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I20 (internal_0n[13], inp_0r1d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I21 (int0_0n[5], internal_0n[12], internal_0n[13], initialise);
  MC2X2_ES34 I22 (internal_0n[14], inp_0r0d[2], inp_0r0d[1], initialise);
  BUFFD1BWP7T I23 (inp_0r0d[0], internal_0n[15]);
  MC2X2_ES34 I24 (int0_0n[6], internal_0n[14], internal_0n[15], initialise);
  MC2X2_ES34 I25 (internal_0n[16], inp_0r1d[3], inp_0r1d[2], initialise);
  MC2X2_ES34 I26 (internal_0n[17], inp_0r0d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I27 (int0_0n[7], internal_0n[16], internal_0n[17], initialise);
  MC2X2_ES34 I28 (internal_0n[18], inp_0r0d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I29 (internal_0n[19], inp_0r0d[1], inp_0r1d[0], initialise);
  MC2X2_ES34 I30 (int0_0n[8], internal_0n[18], internal_0n[19], initialise);
  MC2X2_ES34 I31 (internal_0n[20], inp_0r0d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I32 (internal_0n[21], inp_0r1d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I33 (int0_0n[9], internal_0n[20], internal_0n[21], initialise);
  MC2X2_ES34 I34 (internal_0n[22], inp_0r0d[3], inp_0r0d[2], initialise);
  MC2X2_ES34 I35 (internal_0n[23], inp_0r1d[1], inp_0r1d[0], initialise);
  MC2X2_ES34 I36 (int0_0n[10], internal_0n[22], internal_0n[23], initialise);
  MC2X2_ES34 I37 (internal_0n[24], inp_0r0d[3], inp_0r1d[2], initialise);
  MC2X2_ES34 I38 (internal_0n[25], inp_0r0d[1], inp_0r0d[0], initialise);
  MC2X2_ES34 I39 (int0_0n[11], internal_0n[24], internal_0n[25], initialise);
  BUFFD1BWP7T I40 (int0_0n[11], activateOut_4r);
  BUFFD1BWP7T I41 (int0_0n[10], activateOut_3r);
  BUFFD1BWP7T I42 (int0_0n[9], activateOut_2r);
  BUFFD1BWP7T I43 (int0_0n[8], activateOut_1r);
  NR3D1BWP7T I44 (int0_0n[0], int0_0n[1], int0_0n[2], internal_0n[26]);
  NR3D1BWP7T I45 (int0_0n[3], int0_0n[4], int0_0n[5], internal_0n[27]);
  NR2D1BWP7T I46 (int0_0n[6], int0_0n[7], internal_0n[28]);
  ND3D1BWP7T I47 (internal_0n[26], internal_0n[27], internal_0n[28], activateOut_0r);
  MC2X2_ES34 I48 (internal_0n[29], inpComplete_0n[0], inpComplete_0n[1], initialise);
  MC2X2_ES34 I49 (internal_0n[30], inpComplete_0n[2], inpComplete_0n[3], initialise);
  MC2X2_ES34 I50 (inpDone_0n, internal_0n[29], internal_0n[30], initialise);
  OR2D1BWP7T I51 (inp_0r0d[0], inp_0r1d[0], inpComplete_0n[0]);
  OR2D1BWP7T I52 (inp_0r0d[1], inp_0r1d[1], inpComplete_0n[1]);
  OR2D1BWP7T I53 (inp_0r0d[2], inp_0r1d[2], inpComplete_0n[2]);
  OR2D1BWP7T I54 (inp_0r0d[3], inp_0r1d[3], inpComplete_0n[3]);
endmodule

module acu0d1 (
  q,
  i0,
  i1
);
  output q;
  input i0;
  input i1;
  wire int_0n;
  OR2D1BWP7T I0 (i0, int_0n, q);
  AN2D1BWP7T I1 (i1, q, int_0n);
endmodule

module telem (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s_0n;
  acu0d1 I0 (Aa, Ba, Ar);
  INVD1BWP7T I1 (Aa, s_0n);
  AN2D1BWP7T I2 (Ar, s_0n, Br);
endmodule

module BrzConcur_3 (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  input initialise;
  wire [1:0] internal_0n;
  wire [2:0] acks_0n;
  MC2X2_ES34 I0 (internal_0n[0], acks_0n[0], acks_0n[1], initialise);
  BUFFD1BWP7T I1 (acks_0n[2], internal_0n[1]);
  MC2X2_ES34 I2 (activate_0a, internal_0n[0], internal_0n[1], initialise);
  telem I3 (activate_0r, acks_0n[0], activateOut_0r, activateOut_0a);
  telem I4 (activate_0r, acks_0n[1], activateOut_1r, activateOut_1a);
  telem I5 (activate_0r, acks_0n[2], activateOut_2r, activateOut_2a);
endmodule

module BrzContinue (
  inp_0r, inp_0a
);
  input inp_0r;
  output inp_0a;
  BUFFD1BWP7T I0 (inp_0r, inp_0a);
endmodule

module BrzDecisionWait_1 (
  activate_0r, activate_0a,
  inp_0r, inp_0a,
  out_0r, out_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  input initialise;
  BUFFD1BWP7T I0 (out_0a, activate_0a);
  MC2X2_ES34 I1 (out_0r, inp_0r, activate_0r, initialise);
  BUFFD1BWP7T I2 (out_0a, inp_0a);
endmodule

module BrzEncode_1_2_s5_1_3b0 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  out_0r0d, out_0r1d, out_0a,
  initialise
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  output out_0r0d;
  output out_0r1d;
  input out_0a;
  input initialise;
  wire [1:0] data_0n;
  wire [1:0] int1_0n;
  wire [1:0] int0_0n;
  MC2X2_ES34 I0 (inp_0a, data_0n[0], out_0a, initialise);
  MC2X2_ES34 I1 (inp_1a, data_0n[1], out_0a, initialise);
  BUFFD1BWP7T I2 (data_0n[0], int1_0n[0]);
  BUFFD1BWP7T I3 (data_0n[1], int1_0n[1]);
  BUFFD1BWP7T I4 (int1_0n[1], out_0r0d);
  BUFFD1BWP7T I5 (data_0n[0], int0_0n[0]);
  BUFFD1BWP7T I6 (data_0n[1], int0_0n[1]);
  BUFFD1BWP7T I7 (int0_0n[0], out_0r1d);
  BUFFD1BWP7T I8 (inp_0r, data_0n[0]);
  BUFFD1BWP7T I9 (inp_1r, data_0n[1]);
endmodule

module BrzEncode_8_4_s15_16_3b12_3b8_3b4 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  inp_2r, inp_2a,
  inp_3r, inp_3a,
  out_0r0d, out_0r1d, out_0a,
  initialise
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  input inp_2r;
  output inp_2a;
  input inp_3r;
  output inp_3a;
  output [7:0] out_0r0d;
  output [7:0] out_0r1d;
  input out_0a;
  input initialise;
  wire [9:0] internal_0n;
  wire [3:0] data_0n;
  wire [3:0] int1_0n;
  wire [3:0] int0_0n;
  supply0 gnd;
  MC2X2_ES34 I0 (inp_0a, data_0n[0], out_0a, initialise);
  MC2X2_ES34 I1 (inp_1a, data_0n[1], out_0a, initialise);
  MC2X2_ES34 I2 (inp_2a, data_0n[2], out_0a, initialise);
  MC2X2_ES34 I3 (inp_3a, data_0n[3], out_0a, initialise);
  BUFFD1BWP7T I4 (data_0n[0], int1_0n[0]);
  BUFFD1BWP7T I5 (data_0n[1], int1_0n[1]);
  BUFFD1BWP7T I6 (data_0n[2], int1_0n[2]);
  BUFFD1BWP7T I7 (data_0n[3], int1_0n[3]);
  NR2D1BWP7T I8 (int1_0n[0], int1_0n[1], internal_0n[0]);
  NR2D1BWP7T I9 (int1_0n[2], int1_0n[3], internal_0n[1]);
  ND2D1BWP7T I10 (internal_0n[0], internal_0n[1], out_0r0d[7]);
  NR2D1BWP7T I11 (int1_0n[0], int1_0n[1], internal_0n[2]);
  NR2D1BWP7T I12 (int1_0n[2], int1_0n[3], internal_0n[3]);
  ND2D1BWP7T I13 (internal_0n[2], internal_0n[3], out_0r0d[6]);
  NR2D1BWP7T I14 (int1_0n[0], int1_0n[1], internal_0n[4]);
  NR2D1BWP7T I15 (int1_0n[2], int1_0n[3], internal_0n[5]);
  ND2D1BWP7T I16 (internal_0n[4], internal_0n[5], out_0r0d[5]);
  OR3D1BWP7T I17 (int1_0n[1], int1_0n[2], int1_0n[3], out_0r0d[4]);
  OR2D1BWP7T I18 (int1_0n[0], int1_0n[3], out_0r0d[3]);
  OR2D1BWP7T I19 (int1_0n[0], int1_0n[2], out_0r0d[2]);
  NR2D1BWP7T I20 (int1_0n[0], int1_0n[1], internal_0n[6]);
  NR2D1BWP7T I21 (int1_0n[2], int1_0n[3], internal_0n[7]);
  ND2D1BWP7T I22 (internal_0n[6], internal_0n[7], out_0r0d[1]);
  NR2D1BWP7T I23 (int1_0n[0], int1_0n[1], internal_0n[8]);
  NR2D1BWP7T I24 (int1_0n[2], int1_0n[3], internal_0n[9]);
  ND2D1BWP7T I25 (internal_0n[8], internal_0n[9], out_0r0d[0]);
  BUFFD1BWP7T I26 (data_0n[0], int0_0n[0]);
  BUFFD1BWP7T I27 (data_0n[1], int0_0n[1]);
  BUFFD1BWP7T I28 (data_0n[2], int0_0n[2]);
  BUFFD1BWP7T I29 (data_0n[3], int0_0n[3]);
  BUFFD1BWP7T I30 (gnd, out_0r1d[7]);
  BUFFD1BWP7T I31 (gnd, out_0r1d[6]);
  BUFFD1BWP7T I32 (gnd, out_0r1d[5]);
  BUFFD1BWP7T I33 (int0_0n[0], out_0r1d[4]);
  OR2D1BWP7T I34 (int0_0n[1], int0_0n[2], out_0r1d[3]);
  OR2D1BWP7T I35 (int0_0n[1], int0_0n[3], out_0r1d[2]);
  BUFFD1BWP7T I36 (gnd, out_0r1d[1]);
  BUFFD1BWP7T I37 (gnd, out_0r1d[0]);
  BUFFD1BWP7T I38 (inp_0r, data_0n[0]);
  BUFFD1BWP7T I39 (inp_1r, data_0n[1]);
  BUFFD1BWP7T I40 (inp_2r, data_0n[2]);
  BUFFD1BWP7T I41 (inp_3r, data_0n[3]);
endmodule

module BrzFalseVariable_4_1_s0_ (
  write_0r0d, write_0r1d, write_0a,
  signal_0r, signal_0a,
  read_0r, read_0a0d, read_0a1d,
  initialise
);
  input [3:0] write_0r0d;
  input [3:0] write_0r1d;
  output write_0a;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output [3:0] read_0a0d;
  output [3:0] read_0a1d;
  input initialise;
  wire [1:0] internal_0n;
  wire cd_0n;
  wire [3:0] partCD_0n;
  wire [3:0] store_0n;
  wire [3:0] store_1n;
  wire readReq_0n;
  wire sigAck_0n;
  wire writeAck_0n;
  wire rReqOr_0n;
  AN2D1BWP7T I0 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I2 (store_1n[2], readReq_0n, read_0a1d[2]);
  AN2D1BWP7T I3 (store_1n[3], readReq_0n, read_0a1d[3]);
  AN2D1BWP7T I4 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I5 (store_0n[1], readReq_0n, read_0a0d[1]);
  AN2D1BWP7T I6 (store_0n[2], readReq_0n, read_0a0d[2]);
  AN2D1BWP7T I7 (store_0n[3], readReq_0n, read_0a0d[3]);
  BUFFD1BWP7T I8 (read_0r, readReq_0n);
  BUFFD1BWP7T I9 (write_0r1d[0], store_1n[0]);
  BUFFD1BWP7T I10 (write_0r1d[1], store_1n[1]);
  BUFFD1BWP7T I11 (write_0r1d[2], store_1n[2]);
  BUFFD1BWP7T I12 (write_0r1d[3], store_1n[3]);
  BUFFD1BWP7T I13 (write_0r0d[0], store_0n[0]);
  BUFFD1BWP7T I14 (write_0r0d[1], store_0n[1]);
  BUFFD1BWP7T I15 (write_0r0d[2], store_0n[2]);
  BUFFD1BWP7T I16 (write_0r0d[3], store_0n[3]);
  AN2D1BWP7T I17 (sigAck_0n, rReqOr_0n, writeAck_0n);
  INVD1BWP7T I18 (readReq_0n, rReqOr_0n);
  telem I19 (partCD_0n[0], sigAck_0n, signal_0r, signal_0a);
  MC2X2_ES34 I20 (write_0a, writeAck_0n, cd_0n, initialise);
  MC2X2_ES34 I21 (internal_0n[0], partCD_0n[1], partCD_0n[2], initialise);
  BUFFD1BWP7T I22 (partCD_0n[3], internal_0n[1]);
  MC2X2_ES34 I23 (cd_0n, internal_0n[0], internal_0n[1], initialise);
  OR2D1BWP7T I24 (store_0n[0], store_1n[0], partCD_0n[0]);
  OR2D1BWP7T I25 (store_0n[1], store_1n[1], partCD_0n[1]);
  OR2D1BWP7T I26 (store_0n[2], store_1n[2], partCD_0n[2]);
  OR2D1BWP7T I27 (store_0n[3], store_1n[3], partCD_0n[3]);
endmodule

module BrzFalseVariable_8_1_s0_ (
  write_0r0d, write_0r1d, write_0a,
  signal_0r, signal_0a,
  read_0r, read_0a0d, read_0a1d,
  initialise
);
  input [7:0] write_0r0d;
  input [7:0] write_0r1d;
  output write_0a;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output [7:0] read_0a0d;
  output [7:0] read_0a1d;
  input initialise;
  wire [5:0] internal_0n;
  wire cd_0n;
  wire [7:0] partCD_0n;
  wire [7:0] store_0n;
  wire [7:0] store_1n;
  wire readReq_0n;
  wire sigAck_0n;
  wire writeAck_0n;
  wire rReqOr_0n;
  AN2D1BWP7T I0 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I2 (store_1n[2], readReq_0n, read_0a1d[2]);
  AN2D1BWP7T I3 (store_1n[3], readReq_0n, read_0a1d[3]);
  AN2D1BWP7T I4 (store_1n[4], readReq_0n, read_0a1d[4]);
  AN2D1BWP7T I5 (store_1n[5], readReq_0n, read_0a1d[5]);
  AN2D1BWP7T I6 (store_1n[6], readReq_0n, read_0a1d[6]);
  AN2D1BWP7T I7 (store_1n[7], readReq_0n, read_0a1d[7]);
  AN2D1BWP7T I8 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I9 (store_0n[1], readReq_0n, read_0a0d[1]);
  AN2D1BWP7T I10 (store_0n[2], readReq_0n, read_0a0d[2]);
  AN2D1BWP7T I11 (store_0n[3], readReq_0n, read_0a0d[3]);
  AN2D1BWP7T I12 (store_0n[4], readReq_0n, read_0a0d[4]);
  AN2D1BWP7T I13 (store_0n[5], readReq_0n, read_0a0d[5]);
  AN2D1BWP7T I14 (store_0n[6], readReq_0n, read_0a0d[6]);
  AN2D1BWP7T I15 (store_0n[7], readReq_0n, read_0a0d[7]);
  BUFFD1BWP7T I16 (read_0r, readReq_0n);
  BUFFD1BWP7T I17 (write_0r1d[0], store_1n[0]);
  BUFFD1BWP7T I18 (write_0r1d[1], store_1n[1]);
  BUFFD1BWP7T I19 (write_0r1d[2], store_1n[2]);
  BUFFD1BWP7T I20 (write_0r1d[3], store_1n[3]);
  BUFFD1BWP7T I21 (write_0r1d[4], store_1n[4]);
  BUFFD1BWP7T I22 (write_0r1d[5], store_1n[5]);
  BUFFD1BWP7T I23 (write_0r1d[6], store_1n[6]);
  BUFFD1BWP7T I24 (write_0r1d[7], store_1n[7]);
  BUFFD1BWP7T I25 (write_0r0d[0], store_0n[0]);
  BUFFD1BWP7T I26 (write_0r0d[1], store_0n[1]);
  BUFFD1BWP7T I27 (write_0r0d[2], store_0n[2]);
  BUFFD1BWP7T I28 (write_0r0d[3], store_0n[3]);
  BUFFD1BWP7T I29 (write_0r0d[4], store_0n[4]);
  BUFFD1BWP7T I30 (write_0r0d[5], store_0n[5]);
  BUFFD1BWP7T I31 (write_0r0d[6], store_0n[6]);
  BUFFD1BWP7T I32 (write_0r0d[7], store_0n[7]);
  AN2D1BWP7T I33 (sigAck_0n, rReqOr_0n, writeAck_0n);
  INVD1BWP7T I34 (readReq_0n, rReqOr_0n);
  telem I35 (partCD_0n[0], sigAck_0n, signal_0r, signal_0a);
  MC2X2_ES34 I36 (write_0a, writeAck_0n, cd_0n, initialise);
  MC2X2_ES34 I37 (internal_0n[0], partCD_0n[1], partCD_0n[2], initialise);
  MC2X2_ES34 I38 (internal_0n[1], partCD_0n[3], partCD_0n[4], initialise);
  MC2X2_ES34 I39 (internal_0n[2], partCD_0n[5], partCD_0n[6], initialise);
  BUFFD1BWP7T I40 (partCD_0n[7], internal_0n[3]);
  MC2X2_ES34 I41 (internal_0n[4], internal_0n[0], internal_0n[1], initialise);
  MC2X2_ES34 I42 (internal_0n[5], internal_0n[2], internal_0n[3], initialise);
  MC2X2_ES34 I43 (cd_0n, internal_0n[4], internal_0n[5], initialise);
  OR2D1BWP7T I44 (store_0n[0], store_1n[0], partCD_0n[0]);
  OR2D1BWP7T I45 (store_0n[1], store_1n[1], partCD_0n[1]);
  OR2D1BWP7T I46 (store_0n[2], store_1n[2], partCD_0n[2]);
  OR2D1BWP7T I47 (store_0n[3], store_1n[3], partCD_0n[3]);
  OR2D1BWP7T I48 (store_0n[4], store_1n[4], partCD_0n[4]);
  OR2D1BWP7T I49 (store_0n[5], store_1n[5], partCD_0n[5]);
  OR2D1BWP7T I50 (store_0n[6], store_1n[6], partCD_0n[6]);
  OR2D1BWP7T I51 (store_0n[7], store_1n[7], partCD_0n[7]);
endmodule

module BrzFetch_2_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a0d, inp_0a1d,
  out_0r0d, out_0r1d, out_0a
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input [1:0] inp_0a0d;
  input [1:0] inp_0a1d;
  output [1:0] out_0r0d;
  output [1:0] out_0r1d;
  input out_0a;
  BUFFD1BWP7T I0 (activate_0r, inp_0r);
  BUFFD1BWP7T I1 (inp_0a0d[0], out_0r0d[0]);
  BUFFD1BWP7T I2 (inp_0a0d[1], out_0r0d[1]);
  BUFFD1BWP7T I3 (inp_0a1d[0], out_0r1d[0]);
  BUFFD1BWP7T I4 (inp_0a1d[1], out_0r1d[1]);
  BUFFD1BWP7T I5 (out_0a, activate_0a);
endmodule

module BrzFetch_4_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a0d, inp_0a1d,
  out_0r0d, out_0r1d, out_0a
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input [3:0] inp_0a0d;
  input [3:0] inp_0a1d;
  output [3:0] out_0r0d;
  output [3:0] out_0r1d;
  input out_0a;
  BUFFD1BWP7T I0 (activate_0r, inp_0r);
  BUFFD1BWP7T I1 (inp_0a0d[0], out_0r0d[0]);
  BUFFD1BWP7T I2 (inp_0a0d[1], out_0r0d[1]);
  BUFFD1BWP7T I3 (inp_0a0d[2], out_0r0d[2]);
  BUFFD1BWP7T I4 (inp_0a0d[3], out_0r0d[3]);
  BUFFD1BWP7T I5 (inp_0a1d[0], out_0r1d[0]);
  BUFFD1BWP7T I6 (inp_0a1d[1], out_0r1d[1]);
  BUFFD1BWP7T I7 (inp_0a1d[2], out_0r1d[2]);
  BUFFD1BWP7T I8 (inp_0a1d[3], out_0r1d[3]);
  BUFFD1BWP7T I9 (out_0a, activate_0a);
endmodule

module BrzFetch_8_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a0d, inp_0a1d,
  out_0r0d, out_0r1d, out_0a
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input [7:0] inp_0a0d;
  input [7:0] inp_0a1d;
  output [7:0] out_0r0d;
  output [7:0] out_0r1d;
  input out_0a;
  BUFFD1BWP7T I0 (activate_0r, inp_0r);
  BUFFD1BWP7T I1 (inp_0a0d[0], out_0r0d[0]);
  BUFFD1BWP7T I2 (inp_0a0d[1], out_0r0d[1]);
  BUFFD1BWP7T I3 (inp_0a0d[2], out_0r0d[2]);
  BUFFD1BWP7T I4 (inp_0a0d[3], out_0r0d[3]);
  BUFFD1BWP7T I5 (inp_0a0d[4], out_0r0d[4]);
  BUFFD1BWP7T I6 (inp_0a0d[5], out_0r0d[5]);
  BUFFD1BWP7T I7 (inp_0a0d[6], out_0r0d[6]);
  BUFFD1BWP7T I8 (inp_0a0d[7], out_0r0d[7]);
  BUFFD1BWP7T I9 (inp_0a1d[0], out_0r1d[0]);
  BUFFD1BWP7T I10 (inp_0a1d[1], out_0r1d[1]);
  BUFFD1BWP7T I11 (inp_0a1d[2], out_0r1d[2]);
  BUFFD1BWP7T I12 (inp_0a1d[3], out_0r1d[3]);
  BUFFD1BWP7T I13 (inp_0a1d[4], out_0r1d[4]);
  BUFFD1BWP7T I14 (inp_0a1d[5], out_0r1d[5]);
  BUFFD1BWP7T I15 (inp_0a1d[6], out_0r1d[6]);
  BUFFD1BWP7T I16 (inp_0a1d[7], out_0r1d[7]);
  BUFFD1BWP7T I17 (out_0a, activate_0a);
endmodule

module BrzLoop (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  wire nReq_0n;
  supply0 gnd;
  INVD1BWP7T I0 (activate_0r, nReq_0n);
  NR2D1BWP7T I1 (nReq_0n, activateOut_0a, activateOut_0r);
  BUFFD1BWP7T I2 (gnd, activate_0a);
endmodule

module BrzPassivatorPush_8_1 (
  out_0r, out_0a0d, out_0a1d,
  inp_0r0d, inp_0r1d, inp_0a,
  initialise
);
  input out_0r;
  output [7:0] out_0a0d;
  output [7:0] out_0a1d;
  input [7:0] inp_0r0d;
  input [7:0] inp_0r1d;
  output inp_0a;
  input initialise;
  wire [5:0] internal_0n;
  wire poutReq_0n;
  wire poutReqB_0n;
  wire [7:0] outComplete_0n;
  wire [7:0] outData_0n;
  wire [7:0] outData_1n;
  BUFFD1BWP7T I0 (outData_1n[0], out_0a1d[0]);
  BUFFD1BWP7T I1 (outData_1n[1], out_0a1d[1]);
  BUFFD1BWP7T I2 (outData_1n[2], out_0a1d[2]);
  BUFFD1BWP7T I3 (outData_1n[3], out_0a1d[3]);
  BUFFD1BWP7T I4 (outData_1n[4], out_0a1d[4]);
  BUFFD1BWP7T I5 (outData_1n[5], out_0a1d[5]);
  BUFFD1BWP7T I6 (outData_1n[6], out_0a1d[6]);
  BUFFD1BWP7T I7 (outData_1n[7], out_0a1d[7]);
  BUFFD1BWP7T I8 (outData_0n[0], out_0a0d[0]);
  BUFFD1BWP7T I9 (outData_0n[1], out_0a0d[1]);
  BUFFD1BWP7T I10 (outData_0n[2], out_0a0d[2]);
  BUFFD1BWP7T I11 (outData_0n[3], out_0a0d[3]);
  BUFFD1BWP7T I12 (outData_0n[4], out_0a0d[4]);
  BUFFD1BWP7T I13 (outData_0n[5], out_0a0d[5]);
  BUFFD1BWP7T I14 (outData_0n[6], out_0a0d[6]);
  BUFFD1BWP7T I15 (outData_0n[7], out_0a0d[7]);
  MC2X2_ES34 I16 (internal_0n[0], outComplete_0n[0], outComplete_0n[1], initialise);
  MC2X2_ES34 I17 (internal_0n[1], outComplete_0n[2], outComplete_0n[3], initialise);
  MC2X2_ES34 I18 (internal_0n[2], outComplete_0n[4], outComplete_0n[5], initialise);
  MC2X2_ES34 I19 (internal_0n[3], outComplete_0n[6], outComplete_0n[7], initialise);
  MC2X2_ES34 I20 (internal_0n[4], internal_0n[0], internal_0n[1], initialise);
  MC2X2_ES34 I21 (internal_0n[5], internal_0n[2], internal_0n[3], initialise);
  MC2X2_ES34 I22 (inp_0a, internal_0n[4], internal_0n[5], initialise);
  OR2D1BWP7T I23 (outData_0n[0], outData_1n[0], outComplete_0n[0]);
  OR2D1BWP7T I24 (outData_0n[1], outData_1n[1], outComplete_0n[1]);
  OR2D1BWP7T I25 (outData_0n[2], outData_1n[2], outComplete_0n[2]);
  OR2D1BWP7T I26 (outData_0n[3], outData_1n[3], outComplete_0n[3]);
  OR2D1BWP7T I27 (outData_0n[4], outData_1n[4], outComplete_0n[4]);
  OR2D1BWP7T I28 (outData_0n[5], outData_1n[5], outComplete_0n[5]);
  OR2D1BWP7T I29 (outData_0n[6], outData_1n[6], outComplete_0n[6]);
  OR2D1BWP7T I30 (outData_0n[7], outData_1n[7], outComplete_0n[7]);
  MC2X2_ES34 I31 (outData_1n[0], inp_0r1d[0], poutReqB_0n, initialise);
  MC2X2_ES34 I32 (outData_1n[1], inp_0r1d[1], poutReqB_0n, initialise);
  MC2X2_ES34 I33 (outData_1n[2], inp_0r1d[2], poutReqB_0n, initialise);
  MC2X2_ES34 I34 (outData_1n[3], inp_0r1d[3], poutReqB_0n, initialise);
  MC2X2_ES34 I35 (outData_1n[4], inp_0r1d[4], poutReqB_0n, initialise);
  MC2X2_ES34 I36 (outData_1n[5], inp_0r1d[5], poutReqB_0n, initialise);
  MC2X2_ES34 I37 (outData_1n[6], inp_0r1d[6], poutReqB_0n, initialise);
  MC2X2_ES34 I38 (outData_1n[7], inp_0r1d[7], poutReqB_0n, initialise);
  MC2X2_ES34 I39 (outData_0n[0], inp_0r0d[0], poutReqB_0n, initialise);
  MC2X2_ES34 I40 (outData_0n[1], inp_0r0d[1], poutReqB_0n, initialise);
  MC2X2_ES34 I41 (outData_0n[2], inp_0r0d[2], poutReqB_0n, initialise);
  MC2X2_ES34 I42 (outData_0n[3], inp_0r0d[3], poutReqB_0n, initialise);
  MC2X2_ES34 I43 (outData_0n[4], inp_0r0d[4], poutReqB_0n, initialise);
  MC2X2_ES34 I44 (outData_0n[5], inp_0r0d[5], poutReqB_0n, initialise);
  MC2X2_ES34 I45 (outData_0n[6], inp_0r0d[6], poutReqB_0n, initialise);
  MC2X2_ES34 I46 (outData_0n[7], inp_0r0d[7], poutReqB_0n, initialise);
  BUFFD1BWP7T I47 (out_0r, poutReq_0n);
  BUFFD1BWP7T I48 (poutReq_0n, poutReqB_0n);
endmodule

module nc2p (
  q,
  i0,
  i1
);
  output q;
  input i0;
  input i1;
  wire nq_0n;
  AOI22D1BWP7T I0 (i0, i1, i0, nq_0n, q);
  INVD1BWP7T I1 (q, nq_0n);
endmodule

module selem (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s_0n;
  nc2p I0 (s_0n, Ar, Ba);
  NR2D1BWP7T I1 (Ba, s_0n, Aa);
  AN2D1BWP7T I2 (Ar, s_0n, Br);
endmodule

module BrzSequence_3_s2_SS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  wire [2:0] sreq_0n;
  BUFFD1BWP7T I0 (activateOut_2a, activate_0a);
  BUFFD1BWP7T I1 (sreq_0n[2], activateOut_2r);
  BUFFD1BWP7T I2 (activate_0r, sreq_0n[0]);
  selem I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  selem I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module telemr (
  Ar,
  Aa,
  Br,
  Ba,
  initialise
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  input initialise;
  wire s_0n;
  wire nreset_0n;
  MC2CNX2_ES34 I0 (Aa, Ba, Ar, nreset);
  INVD1BWP7T I1 (initialise, nreset);
  INVD1BWP7T I2 (Aa, s_0n);
  AN2D1BWP7T I3 (Ar, s_0n, Br);
endmodule

module BrzSequence_3_s2_ST (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  input initialise;
  wire [2:0] sreq_0n;
  BUFFD1BWP7T I0 (activateOut_2a, activate_0a);
  BUFFD1BWP7T I1 (sreq_0n[2], activateOut_2r);
  BUFFD1BWP7T I2 (activate_0r, sreq_0n[0]);
  telemr I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a, initialise);
  selem I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzSequence_5_s4_SSSS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  wire [4:0] sreq_0n;
  BUFFD1BWP7T I0 (activateOut_4a, activate_0a);
  BUFFD1BWP7T I1 (sreq_0n[4], activateOut_4r);
  BUFFD1BWP7T I2 (activate_0r, sreq_0n[0]);
  selem I3 (sreq_0n[3], sreq_0n[4], activateOut_3r, activateOut_3a);
  selem I4 (sreq_0n[2], sreq_0n[3], activateOut_2r, activateOut_2a);
  selem I5 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  selem I6 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module dualrail_latch (
  in_0,
  in_1,
  in_a,
  out_0,
  out_1,
  initialise
);
  input in_0;
  input in_1;
  output in_a;
  output out_0;
  output out_1;
  input initialise;
  wire clr;
  RSLATX1 I0 (out_1, out_0, clr, in_1);
  AO22D0BWP7T I1 (in_0, out_0, in_1, out_1, in_a);
  OR2D1BWP7T I2 (in_0, initialise, clr);
endmodule

module BrzVariable_2_1_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  initialise
);
  input [1:0] write_0r0d;
  input [1:0] write_0r1d;
  output write_0a;
  input read_0r;
  output [1:0] read_0a0d;
  output [1:0] read_0a1d;
  input initialise;
  wire [1:0] store_0n;
  wire [1:0] store_1n;
  wire [1:0] ldata_0n;
  wire [1:0] ldata_1n;
  wire [1:0] wack_0n;
  wire readReq_0n;
  AN2D1BWP7T I0 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I2 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I3 (store_0n[1], readReq_0n, read_0a0d[1]);
  BUFFD1BWP7T I4 (read_0r, readReq_0n);
  BUFFD1BWP7T I5 (ldata_0n[0], store_0n[0]);
  BUFFD1BWP7T I6 (ldata_0n[1], store_0n[1]);
  BUFFD1BWP7T I7 (ldata_1n[0], store_1n[0]);
  BUFFD1BWP7T I8 (ldata_1n[1], store_1n[1]);
  MC2X2_ES34 I9 (write_0a, wack_0n[0], wack_0n[1], initialise);
  dualrail_latch I10 (write_0r0d[0], write_0r1d[0], wack_0n[0], ldata_0n[0], ldata_1n[0], initialise);
  dualrail_latch I11 (write_0r0d[1], write_0r1d[1], wack_0n[1], ldata_0n[1], ldata_1n[1], initialise);
endmodule

module BrzVariable_2_2_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  read_1r, read_1a0d, read_1a1d,
  initialise
);
  input [1:0] write_0r0d;
  input [1:0] write_0r1d;
  output write_0a;
  input read_0r;
  output [1:0] read_0a0d;
  output [1:0] read_0a1d;
  input read_1r;
  output [1:0] read_1a0d;
  output [1:0] read_1a1d;
  input initialise;
  wire [1:0] store_0n;
  wire [1:0] store_1n;
  wire [1:0] ldata_0n;
  wire [1:0] ldata_1n;
  wire [1:0] wack_0n;
  wire readReq_0n;
  wire readReq_1n;
  AN2D1BWP7T I0 (store_1n[0], readReq_1n, read_1a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_1n, read_1a1d[1]);
  AN2D1BWP7T I2 (store_0n[0], readReq_1n, read_1a0d[0]);
  AN2D1BWP7T I3 (store_0n[1], readReq_1n, read_1a0d[1]);
  AN2D1BWP7T I4 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I5 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I6 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I7 (store_0n[1], readReq_0n, read_0a0d[1]);
  BUFFD1BWP7T I8 (read_0r, readReq_0n);
  BUFFD1BWP7T I9 (read_1r, readReq_1n);
  BUFFD1BWP7T I10 (ldata_0n[0], store_0n[0]);
  BUFFD1BWP7T I11 (ldata_0n[1], store_0n[1]);
  BUFFD1BWP7T I12 (ldata_1n[0], store_1n[0]);
  BUFFD1BWP7T I13 (ldata_1n[1], store_1n[1]);
  MC2X2_ES34 I14 (write_0a, wack_0n[0], wack_0n[1], initialise);
  dualrail_latch I15 (write_0r0d[0], write_0r1d[0], wack_0n[0], ldata_0n[0], ldata_1n[0], initialise);
  dualrail_latch I16 (write_0r0d[1], write_0r1d[1], wack_0n[1], ldata_0n[1], ldata_1n[1], initialise);
endmodule

module BrzVariable_4_1_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  initialise
);
  input [3:0] write_0r0d;
  input [3:0] write_0r1d;
  output write_0a;
  input read_0r;
  output [3:0] read_0a0d;
  output [3:0] read_0a1d;
  input initialise;
  wire [1:0] internal_0n;
  wire [3:0] store_0n;
  wire [3:0] store_1n;
  wire [3:0] ldata_0n;
  wire [3:0] ldata_1n;
  wire [3:0] wack_0n;
  wire readReq_0n;
  AN2D1BWP7T I0 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I2 (store_1n[2], readReq_0n, read_0a1d[2]);
  AN2D1BWP7T I3 (store_1n[3], readReq_0n, read_0a1d[3]);
  AN2D1BWP7T I4 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I5 (store_0n[1], readReq_0n, read_0a0d[1]);
  AN2D1BWP7T I6 (store_0n[2], readReq_0n, read_0a0d[2]);
  AN2D1BWP7T I7 (store_0n[3], readReq_0n, read_0a0d[3]);
  BUFFD1BWP7T I8 (read_0r, readReq_0n);
  BUFFD1BWP7T I9 (ldata_0n[0], store_0n[0]);
  BUFFD1BWP7T I10 (ldata_0n[1], store_0n[1]);
  BUFFD1BWP7T I11 (ldata_0n[2], store_0n[2]);
  BUFFD1BWP7T I12 (ldata_0n[3], store_0n[3]);
  BUFFD1BWP7T I13 (ldata_1n[0], store_1n[0]);
  BUFFD1BWP7T I14 (ldata_1n[1], store_1n[1]);
  BUFFD1BWP7T I15 (ldata_1n[2], store_1n[2]);
  BUFFD1BWP7T I16 (ldata_1n[3], store_1n[3]);
  MC2X2_ES34 I17 (internal_0n[0], wack_0n[0], wack_0n[1], initialise);
  MC2X2_ES34 I18 (internal_0n[1], wack_0n[2], wack_0n[3], initialise);
  MC2X2_ES34 I19 (write_0a, internal_0n[0], internal_0n[1], initialise);
  dualrail_latch I20 (write_0r0d[0], write_0r1d[0], wack_0n[0], ldata_0n[0], ldata_1n[0], initialise);
  dualrail_latch I21 (write_0r0d[1], write_0r1d[1], wack_0n[1], ldata_0n[1], ldata_1n[1], initialise);
  dualrail_latch I22 (write_0r0d[2], write_0r1d[2], wack_0n[2], ldata_0n[2], ldata_1n[2], initialise);
  dualrail_latch I23 (write_0r0d[3], write_0r1d[3], wack_0n[3], ldata_0n[3], ldata_1n[3], initialise);
endmodule

module BrzVariable_4_3_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  read_1r, read_1a0d, read_1a1d,
  read_2r, read_2a0d, read_2a1d,
  initialise
);
  input [3:0] write_0r0d;
  input [3:0] write_0r1d;
  output write_0a;
  input read_0r;
  output [3:0] read_0a0d;
  output [3:0] read_0a1d;
  input read_1r;
  output [3:0] read_1a0d;
  output [3:0] read_1a1d;
  input read_2r;
  output [3:0] read_2a0d;
  output [3:0] read_2a1d;
  input initialise;
  wire [1:0] internal_0n;
  wire [3:0] store_0n;
  wire [3:0] store_1n;
  wire [3:0] ldata_0n;
  wire [3:0] ldata_1n;
  wire [3:0] wack_0n;
  wire readReq_0n;
  wire readReq_1n;
  wire readReq_2n;
  AN2D1BWP7T I0 (store_1n[0], readReq_2n, read_2a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_2n, read_2a1d[1]);
  AN2D1BWP7T I2 (store_1n[2], readReq_2n, read_2a1d[2]);
  AN2D1BWP7T I3 (store_1n[3], readReq_2n, read_2a1d[3]);
  AN2D1BWP7T I4 (store_0n[0], readReq_2n, read_2a0d[0]);
  AN2D1BWP7T I5 (store_0n[1], readReq_2n, read_2a0d[1]);
  AN2D1BWP7T I6 (store_0n[2], readReq_2n, read_2a0d[2]);
  AN2D1BWP7T I7 (store_0n[3], readReq_2n, read_2a0d[3]);
  AN2D1BWP7T I8 (store_1n[0], readReq_1n, read_1a1d[0]);
  AN2D1BWP7T I9 (store_1n[1], readReq_1n, read_1a1d[1]);
  AN2D1BWP7T I10 (store_1n[2], readReq_1n, read_1a1d[2]);
  AN2D1BWP7T I11 (store_1n[3], readReq_1n, read_1a1d[3]);
  AN2D1BWP7T I12 (store_0n[0], readReq_1n, read_1a0d[0]);
  AN2D1BWP7T I13 (store_0n[1], readReq_1n, read_1a0d[1]);
  AN2D1BWP7T I14 (store_0n[2], readReq_1n, read_1a0d[2]);
  AN2D1BWP7T I15 (store_0n[3], readReq_1n, read_1a0d[3]);
  AN2D1BWP7T I16 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I17 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I18 (store_1n[2], readReq_0n, read_0a1d[2]);
  AN2D1BWP7T I19 (store_1n[3], readReq_0n, read_0a1d[3]);
  AN2D1BWP7T I20 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I21 (store_0n[1], readReq_0n, read_0a0d[1]);
  AN2D1BWP7T I22 (store_0n[2], readReq_0n, read_0a0d[2]);
  AN2D1BWP7T I23 (store_0n[3], readReq_0n, read_0a0d[3]);
  BUFFD1BWP7T I24 (read_0r, readReq_0n);
  BUFFD1BWP7T I25 (read_1r, readReq_1n);
  BUFFD1BWP7T I26 (read_2r, readReq_2n);
  BUFFD1BWP7T I27 (ldata_0n[0], store_0n[0]);
  BUFFD1BWP7T I28 (ldata_0n[1], store_0n[1]);
  BUFFD1BWP7T I29 (ldata_0n[2], store_0n[2]);
  BUFFD1BWP7T I30 (ldata_0n[3], store_0n[3]);
  BUFFD1BWP7T I31 (ldata_1n[0], store_1n[0]);
  BUFFD1BWP7T I32 (ldata_1n[1], store_1n[1]);
  BUFFD1BWP7T I33 (ldata_1n[2], store_1n[2]);
  BUFFD1BWP7T I34 (ldata_1n[3], store_1n[3]);
  MC2X2_ES34 I35 (internal_0n[0], wack_0n[0], wack_0n[1], initialise);
  MC2X2_ES34 I36 (internal_0n[1], wack_0n[2], wack_0n[3], initialise);
  MC2X2_ES34 I37 (write_0a, internal_0n[0], internal_0n[1], initialise);
  dualrail_latch I38 (write_0r0d[0], write_0r1d[0], wack_0n[0], ldata_0n[0], ldata_1n[0], initialise);
  dualrail_latch I39 (write_0r0d[1], write_0r1d[1], wack_0n[1], ldata_0n[1], ldata_1n[1], initialise);
  dualrail_latch I40 (write_0r0d[2], write_0r1d[2], wack_0n[2], ldata_0n[2], ldata_1n[2], initialise);
  dualrail_latch I41 (write_0r0d[3], write_0r1d[3], wack_0n[3], ldata_0n[3], ldata_1n[3], initialise);
endmodule

module BrzVariable_8_4_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  read_1r, read_1a0d, read_1a1d,
  read_2r, read_2a0d, read_2a1d,
  read_3r, read_3a0d, read_3a1d,
  initialise
);
  input [7:0] write_0r0d;
  input [7:0] write_0r1d;
  output write_0a;
  input read_0r;
  output [7:0] read_0a0d;
  output [7:0] read_0a1d;
  input read_1r;
  output [7:0] read_1a0d;
  output [7:0] read_1a1d;
  input read_2r;
  output [7:0] read_2a0d;
  output [7:0] read_2a1d;
  input read_3r;
  output [7:0] read_3a0d;
  output [7:0] read_3a1d;
  input initialise;
  wire [5:0] internal_0n;
  wire [7:0] store_0n;
  wire [7:0] store_1n;
  wire [7:0] ldata_0n;
  wire [7:0] ldata_1n;
  wire [7:0] wack_0n;
  wire readReq_0n;
  wire readReq_1n;
  wire readReq_2n;
  wire readReq_3n;
  AN2D1BWP7T I0 (store_1n[0], readReq_3n, read_3a1d[0]);
  AN2D1BWP7T I1 (store_1n[1], readReq_3n, read_3a1d[1]);
  AN2D1BWP7T I2 (store_1n[2], readReq_3n, read_3a1d[2]);
  AN2D1BWP7T I3 (store_1n[3], readReq_3n, read_3a1d[3]);
  AN2D1BWP7T I4 (store_1n[4], readReq_3n, read_3a1d[4]);
  AN2D1BWP7T I5 (store_1n[5], readReq_3n, read_3a1d[5]);
  AN2D1BWP7T I6 (store_1n[6], readReq_3n, read_3a1d[6]);
  AN2D1BWP7T I7 (store_1n[7], readReq_3n, read_3a1d[7]);
  AN2D1BWP7T I8 (store_0n[0], readReq_3n, read_3a0d[0]);
  AN2D1BWP7T I9 (store_0n[1], readReq_3n, read_3a0d[1]);
  AN2D1BWP7T I10 (store_0n[2], readReq_3n, read_3a0d[2]);
  AN2D1BWP7T I11 (store_0n[3], readReq_3n, read_3a0d[3]);
  AN2D1BWP7T I12 (store_0n[4], readReq_3n, read_3a0d[4]);
  AN2D1BWP7T I13 (store_0n[5], readReq_3n, read_3a0d[5]);
  AN2D1BWP7T I14 (store_0n[6], readReq_3n, read_3a0d[6]);
  AN2D1BWP7T I15 (store_0n[7], readReq_3n, read_3a0d[7]);
  AN2D1BWP7T I16 (store_1n[0], readReq_2n, read_2a1d[0]);
  AN2D1BWP7T I17 (store_1n[1], readReq_2n, read_2a1d[1]);
  AN2D1BWP7T I18 (store_1n[2], readReq_2n, read_2a1d[2]);
  AN2D1BWP7T I19 (store_1n[3], readReq_2n, read_2a1d[3]);
  AN2D1BWP7T I20 (store_1n[4], readReq_2n, read_2a1d[4]);
  AN2D1BWP7T I21 (store_1n[5], readReq_2n, read_2a1d[5]);
  AN2D1BWP7T I22 (store_1n[6], readReq_2n, read_2a1d[6]);
  AN2D1BWP7T I23 (store_1n[7], readReq_2n, read_2a1d[7]);
  AN2D1BWP7T I24 (store_0n[0], readReq_2n, read_2a0d[0]);
  AN2D1BWP7T I25 (store_0n[1], readReq_2n, read_2a0d[1]);
  AN2D1BWP7T I26 (store_0n[2], readReq_2n, read_2a0d[2]);
  AN2D1BWP7T I27 (store_0n[3], readReq_2n, read_2a0d[3]);
  AN2D1BWP7T I28 (store_0n[4], readReq_2n, read_2a0d[4]);
  AN2D1BWP7T I29 (store_0n[5], readReq_2n, read_2a0d[5]);
  AN2D1BWP7T I30 (store_0n[6], readReq_2n, read_2a0d[6]);
  AN2D1BWP7T I31 (store_0n[7], readReq_2n, read_2a0d[7]);
  AN2D1BWP7T I32 (store_1n[0], readReq_1n, read_1a1d[0]);
  AN2D1BWP7T I33 (store_1n[1], readReq_1n, read_1a1d[1]);
  AN2D1BWP7T I34 (store_1n[2], readReq_1n, read_1a1d[2]);
  AN2D1BWP7T I35 (store_1n[3], readReq_1n, read_1a1d[3]);
  AN2D1BWP7T I36 (store_1n[4], readReq_1n, read_1a1d[4]);
  AN2D1BWP7T I37 (store_1n[5], readReq_1n, read_1a1d[5]);
  AN2D1BWP7T I38 (store_1n[6], readReq_1n, read_1a1d[6]);
  AN2D1BWP7T I39 (store_1n[7], readReq_1n, read_1a1d[7]);
  AN2D1BWP7T I40 (store_0n[0], readReq_1n, read_1a0d[0]);
  AN2D1BWP7T I41 (store_0n[1], readReq_1n, read_1a0d[1]);
  AN2D1BWP7T I42 (store_0n[2], readReq_1n, read_1a0d[2]);
  AN2D1BWP7T I43 (store_0n[3], readReq_1n, read_1a0d[3]);
  AN2D1BWP7T I44 (store_0n[4], readReq_1n, read_1a0d[4]);
  AN2D1BWP7T I45 (store_0n[5], readReq_1n, read_1a0d[5]);
  AN2D1BWP7T I46 (store_0n[6], readReq_1n, read_1a0d[6]);
  AN2D1BWP7T I47 (store_0n[7], readReq_1n, read_1a0d[7]);
  AN2D1BWP7T I48 (store_1n[0], readReq_0n, read_0a1d[0]);
  AN2D1BWP7T I49 (store_1n[1], readReq_0n, read_0a1d[1]);
  AN2D1BWP7T I50 (store_1n[2], readReq_0n, read_0a1d[2]);
  AN2D1BWP7T I51 (store_1n[3], readReq_0n, read_0a1d[3]);
  AN2D1BWP7T I52 (store_1n[4], readReq_0n, read_0a1d[4]);
  AN2D1BWP7T I53 (store_1n[5], readReq_0n, read_0a1d[5]);
  AN2D1BWP7T I54 (store_1n[6], readReq_0n, read_0a1d[6]);
  AN2D1BWP7T I55 (store_1n[7], readReq_0n, read_0a1d[7]);
  AN2D1BWP7T I56 (store_0n[0], readReq_0n, read_0a0d[0]);
  AN2D1BWP7T I57 (store_0n[1], readReq_0n, read_0a0d[1]);
  AN2D1BWP7T I58 (store_0n[2], readReq_0n, read_0a0d[2]);
  AN2D1BWP7T I59 (store_0n[3], readReq_0n, read_0a0d[3]);
  AN2D1BWP7T I60 (store_0n[4], readReq_0n, read_0a0d[4]);
  AN2D1BWP7T I61 (store_0n[5], readReq_0n, read_0a0d[5]);
  AN2D1BWP7T I62 (store_0n[6], readReq_0n, read_0a0d[6]);
  AN2D1BWP7T I63 (store_0n[7], readReq_0n, read_0a0d[7]);
  BUFFD1BWP7T I64 (read_0r, readReq_0n);
  BUFFD1BWP7T I65 (read_1r, readReq_1n);
  BUFFD1BWP7T I66 (read_2r, readReq_2n);
  BUFFD1BWP7T I67 (read_3r, readReq_3n);
  BUFFD1BWP7T I68 (ldata_0n[0], store_0n[0]);
  BUFFD1BWP7T I69 (ldata_0n[1], store_0n[1]);
  BUFFD1BWP7T I70 (ldata_0n[2], store_0n[2]);
  BUFFD1BWP7T I71 (ldata_0n[3], store_0n[3]);
  BUFFD1BWP7T I72 (ldata_0n[4], store_0n[4]);
  BUFFD1BWP7T I73 (ldata_0n[5], store_0n[5]);
  BUFFD1BWP7T I74 (ldata_0n[6], store_0n[6]);
  BUFFD1BWP7T I75 (ldata_0n[7], store_0n[7]);
  BUFFD1BWP7T I76 (ldata_1n[0], store_1n[0]);
  BUFFD1BWP7T I77 (ldata_1n[1], store_1n[1]);
  BUFFD1BWP7T I78 (ldata_1n[2], store_1n[2]);
  BUFFD1BWP7T I79 (ldata_1n[3], store_1n[3]);
  BUFFD1BWP7T I80 (ldata_1n[4], store_1n[4]);
  BUFFD1BWP7T I81 (ldata_1n[5], store_1n[5]);
  BUFFD1BWP7T I82 (ldata_1n[6], store_1n[6]);
  BUFFD1BWP7T I83 (ldata_1n[7], store_1n[7]);
  MC2X2_ES34 I84 (internal_0n[0], wack_0n[0], wack_0n[1], initialise);
  MC2X2_ES34 I85 (internal_0n[1], wack_0n[2], wack_0n[3], initialise);
  MC2X2_ES34 I86 (internal_0n[2], wack_0n[4], wack_0n[5], initialise);
  MC2X2_ES34 I87 (internal_0n[3], wack_0n[6], wack_0n[7], initialise);
  MC2X2_ES34 I88 (internal_0n[4], internal_0n[0], internal_0n[1], initialise);
  MC2X2_ES34 I89 (internal_0n[5], internal_0n[2], internal_0n[3], initialise);
  MC2X2_ES34 I90 (write_0a, internal_0n[4], internal_0n[5], initialise);
  dualrail_latch I91 (write_0r0d[0], write_0r1d[0], wack_0n[0], ldata_0n[0], ldata_1n[0], initialise);
  dualrail_latch I92 (write_0r0d[1], write_0r1d[1], wack_0n[1], ldata_0n[1], ldata_1n[1], initialise);
  dualrail_latch I93 (write_0r0d[2], write_0r1d[2], wack_0n[2], ldata_0n[2], ldata_1n[2], initialise);
  dualrail_latch I94 (write_0r0d[3], write_0r1d[3], wack_0n[3], ldata_0n[3], ldata_1n[3], initialise);
  dualrail_latch I95 (write_0r0d[4], write_0r1d[4], wack_0n[4], ldata_0n[4], ldata_1n[4], initialise);
  dualrail_latch I96 (write_0r0d[5], write_0r1d[5], wack_0n[5], ldata_0n[5], ldata_1n[5], initialise);
  dualrail_latch I97 (write_0r0d[6], write_0r1d[6], wack_0n[6], ldata_0n[6], ldata_1n[6], initialise);
  dualrail_latch I98 (write_0r0d[7], write_0r1d[7], wack_0n[7], ldata_0n[7], ldata_1n[7], initialise);
endmodule

module BrzWhile (
  activate_0r, activate_0a,
  guard_0r, guard_0a0d, guard_0a1d,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output guard_0r;
  input guard_0a0d;
  input guard_0a1d;
  output activateOut_0r;
  input activateOut_0a;
  wire guardReq_0n;
  wire nReq_0n;
  selem I0 (guardReq_0n, activateOut_0r, guard_0r, guard_0a1d);
  INVD1BWP7T I1 (activate_0r, nReq_0n);
  NR2D1BWP7T I2 (nReq_0n, activateOut_0a, guardReq_0n);
  BUFFD1BWP7T I3 (guard_0a0d, activate_0a);
endmodule

module BrzWireFork_2 (
  inp_0r, inp_0a,
  out_0r, out_0a,
  out_1r, out_1a
);
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  output out_1r;
  input out_1a;
  supply0 gnd;
  BUFFD1BWP7T I0 (gnd, inp_0a);
  BUFFD1BWP7T I1 (inp_0r, out_0r);
  BUFFD1BWP7T I2 (inp_0r, out_1r);
endmodule

module Balsa_FlashControl (
  activate_0r, activate_0a,
  count_0r0d, count_0r1d, count_0a,
  adr_0r0d, adr_0r1d, adr_0a,
  SE_0r, SE_0a0d, SE_0a1d,
  dataRead__0_0r0d, dataRead__0_0r1d, dataRead__0_0a,
  dataRead__1_0r0d, dataRead__1_0r1d, dataRead__1_0a,
  dataRead__2_0r0d, dataRead__2_0r1d, dataRead__2_0a,
  dataRead__3_0r0d, dataRead__3_0r1d, dataRead__3_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input [3:0] count_0r0d;
  input [3:0] count_0r1d;
  output count_0a;
  output [7:0] adr_0r0d;
  output [7:0] adr_0r1d;
  input adr_0a;
  output SE_0r;
  input [7:0] SE_0a0d;
  input [7:0] SE_0a1d;
  output [7:0] dataRead__0_0r0d;
  output [7:0] dataRead__0_0r1d;
  input dataRead__0_0a;
  output [7:0] dataRead__1_0r0d;
  output [7:0] dataRead__1_0r1d;
  input dataRead__1_0a;
  output [7:0] dataRead__2_0r0d;
  output [7:0] dataRead__2_0r1d;
  input dataRead__2_0a;
  output [7:0] dataRead__3_0r0d;
  output [7:0] dataRead__3_0r1d;
  input dataRead__3_0a;
  input initialise;
  wire c47_r;
  wire c47_a;
  wire c46_r;
  wire c46_a;
  wire c45_r;
  wire c45_a;
  wire [3:0] c44_r0d;
  wire [3:0] c44_r1d;
  wire c44_a;
  wire c43_r;
  wire c43_a;
  wire c42_r;
  wire [3:0] c42_a0d;
  wire [3:0] c42_a1d;
  wire [7:0] c41_r0d;
  wire [7:0] c41_r1d;
  wire c41_a;
  wire c40_r;
  wire c40_a;
  wire c39_r;
  wire c39_a;
  wire c38_r;
  wire c38_a;
  wire c37_r;
  wire c37_a;
  wire c36_r;
  wire c36_a;
  wire c35_r;
  wire c35_a;
  wire c34_r;
  wire c34_a;
  wire [7:0] c33_r0d;
  wire [7:0] c33_r1d;
  wire c33_a;
  wire c32_r;
  wire c32_a;
  wire c31_r;
  wire c31_a;
  wire c30_r;
  wire [7:0] c30_a0d;
  wire [7:0] c30_a1d;
  wire c29_r;
  wire c29_a;
  wire [7:0] c28_r0d;
  wire [7:0] c28_r1d;
  wire c28_a;
  wire [1:0] c27_r0d;
  wire [1:0] c27_r1d;
  wire c27_a;
  wire c26_r;
  wire c26_a;
  wire c25_r;
  wire [1:0] c25_a0d;
  wire [1:0] c25_a1d;
  wire c24_r;
  wire c24_a;
  wire c23_r;
  wire [7:0] c23_a0d;
  wire [7:0] c23_a1d;
  wire c22_r;
  wire c22_a;
  wire c21_r;
  wire [7:0] c21_a0d;
  wire [7:0] c21_a1d;
  wire c20_r;
  wire c20_a;
  wire c19_r;
  wire [7:0] c19_a0d;
  wire [7:0] c19_a1d;
  wire c18_r;
  wire c18_a;
  wire c17_r;
  wire [7:0] c17_a0d;
  wire [7:0] c17_a1d;
  wire c16_r;
  wire [1:0] c16_a0d;
  wire [1:0] c16_a1d;
  wire [1:0] c15_r0d;
  wire [1:0] c15_r1d;
  wire c15_a;
  wire c14_r;
  wire c14_a;
  wire c13_r;
  wire c13_a;
  wire [1:0] c12_r0d;
  wire [1:0] c12_r1d;
  wire c12_a;
  wire c11_r;
  wire [1:0] c11_a0d;
  wire [1:0] c11_a1d;
  wire c10_r;
  wire [1:0] c10_a0d;
  wire [1:0] c10_a1d;
  wire c9_r;
  wire [7:0] c9_a0d;
  wire [7:0] c9_a1d;
  BrzVariable_8_4_s0_ I0 (c28_r0d, c28_r1d, c28_a, c23_r, c23_a0d, c23_a1d, c21_r, c21_a0d, c21_a1d, c19_r, c19_a0d, c19_a1d, c17_r, c17_a0d, c17_a1d, initialise);
  BrzVariable_2_2_s0_ I1 (c12_r0d, c12_r1d, c12_a, c25_r, c25_a0d, c25_a1d, c10_r, c10_a0d, c10_a1d, initialise);
  BrzWireFork_2 I2 (activate_0r, activate_0a, c47_r, c47_a, c35_r, c35_a);
  BrzPassivatorPush_8_1 I3 (c9_r, c9_a0d, c9_a1d, c41_r0d, c41_r1d, c41_a, initialise);
  BrzLoop I4 (c47_r, c47_a, c46_r, c46_a);
  BrzDecisionWait_1 I5 (c46_r, c46_a, c45_r, c45_a, c43_r, c43_a, initialise);
  BrzFalseVariable_4_1_s0_ I6 (count_0r0d, count_0r1d, count_0a, c45_r, c45_a, c42_r, c42_a0d, c42_a1d, initialise);
  BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m I7 (c44_r0d, c44_r1d, c44_a, c36_r, c36_a, c37_r, c37_a, c38_r, c38_a, c39_r, c39_a, c40_r, c40_a, initialise);
  BrzFetch_4_s5_false I8 (c43_r, c43_a, c42_r, c42_a0d, c42_a1d, c44_r0d, c44_r1d, c44_a);
  BrzContinue I9 (c36_r, c36_a);
  BrzLoop I10 (c35_r, c35_a, c32_r, c32_a);
  BrzFalseVariable_8_1_s0_ I11 (c33_r0d, c33_r1d, c33_a, c34_r, c34_a, c30_r, c30_a0d, c30_a1d, initialise);
  BrzFetch_8_s5_false I12 (c32_r, c32_a, c9_r, c9_a0d, c9_a1d, c33_r0d, c33_r1d, c33_a);
  BrzSequence_5_s4_SSSS I13 (c34_r, c34_a, c31_r, c31_a, c29_r, c29_a, c26_r, c26_a, c13_r, c13_a, c14_r, c14_a);
  BrzFetch_8_s5_false I14 (c31_r, c31_a, c30_r, c30_a0d, c30_a1d, adr_0r0d, adr_0r1d, adr_0a);
  BrzFetch_8_s5_false I15 (c29_r, c29_a, SE_0r, SE_0a0d, SE_0a1d, c28_r0d, c28_r1d, c28_a);
  BrzCase_2_4_s13_0_3b1_3b2_3b3 I16 (c27_r0d, c27_r1d, c27_a, c18_r, c18_a, c20_r, c20_a, c22_r, c22_a, c24_r, c24_a, initialise);
  BrzFetch_2_s5_false I17 (c26_r, c26_a, c25_r, c25_a0d, c25_a1d, c27_r0d, c27_r1d, c27_a);
  BrzFetch_8_s5_false I18 (c24_r, c24_a, c23_r, c23_a0d, c23_a1d, dataRead__3_0r0d, dataRead__3_0r1d, dataRead__3_0a);
  BrzFetch_8_s5_false I19 (c22_r, c22_a, c21_r, c21_a0d, c21_a1d, dataRead__2_0r0d, dataRead__2_0r1d, dataRead__2_0a);
  BrzFetch_8_s5_false I20 (c20_r, c20_a, c19_r, c19_a0d, c19_a1d, dataRead__1_0r0d, dataRead__1_0r1d, dataRead__1_0a);
  BrzFetch_8_s5_false I21 (c18_r, c18_a, c17_r, c17_a0d, c17_a1d, dataRead__0_0r0d, dataRead__0_0r1d, dataRead__0_0a);
  BrzFetch_2_s5_false I22 (c13_r, c13_a, c11_r, c11_a0d, c11_a1d, c15_r0d, c15_r1d, c15_a);
  BrzFetch_2_s5_false I23 (c14_r, c14_a, c16_r, c16_a0d, c16_a1d, c12_r0d, c12_r1d, c12_a);
  BrzVariable_2_1_s0_ I24 (c15_r0d, c15_r1d, c15_a, c16_r, c16_a0d, c16_a1d, initialise);
  BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m I25 (c11_r, c11_a0d, c11_a1d, c10_r, c10_a0d, c10_a1d, initialise);
  BrzEncode_8_4_s15_16_3b12_3b8_3b4 I26 (c40_r, c40_a, c39_r, c39_a, c38_r, c38_a, c37_r, c37_a, c41_r0d, c41_r1d, c41_a, initialise);
endmodule

module Balsa_Counter (
  activate_0r, activate_0a,
  start_0r, start_0a,
  count_0r0d, count_0r1d, count_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output [3:0] count_0r0d;
  output [3:0] count_0r1d;
  input count_0a;
  input initialise;
  wire c16_r;
  wire c16_a;
  wire c15_r;
  wire c15_a0d;
  wire c15_a1d;
  wire c14_r;
  wire [3:0] c14_a0d;
  wire [3:0] c14_a1d;
  wire c13_r;
  wire c13_a;
  wire c12_r;
  wire c12_a;
  wire [3:0] c11_r0d;
  wire [3:0] c11_r1d;
  wire c11_a;
  wire c10_r;
  wire [3:0] c10_a0d;
  wire [3:0] c10_a1d;
  wire c9_r;
  wire [3:0] c9_a0d;
  wire [3:0] c9_a1d;
  wire c8_r;
  wire c8_a;
  wire [3:0] c7_r0d;
  wire [3:0] c7_r1d;
  wire c7_a;
  wire c6_r;
  wire [3:0] c6_a0d;
  wire [3:0] c6_a1d;
  wire c5_r;
  wire c5_a;
  wire c4_r;
  wire [3:0] c4_a0d;
  wire [3:0] c4_a1d;
  BrzVariable_4_1_s0_ I0 (c11_r0d, c11_r1d, c11_a, c6_r, c6_a0d, c6_a1d, initialise);
  BrzVariable_4_3_s0_ I1 (c7_r0d, c7_r1d, c7_a, c14_r, c14_a0d, c14_a1d, c9_r, c9_a0d, c9_a1d, c4_r, c4_a0d, c4_a1d, initialise);
  BrzDecisionWait_1 I2 (activate_0r, activate_0a, start_0r, start_0a, c16_r, c16_a, initialise);
  BrzWhile I3 (c16_r, c16_a, c15_r, c15_a0d, c15_a1d, c13_r, c13_a);
  BrzBinaryFuncConstR_1_4_3_s8_LessThan_s5_f_m5m I4 (c15_r, c15_a0d, c15_a1d, c14_r, c14_a0d, c14_a1d, initialise);
  BrzSequence_3_s2_ST I5 (c13_r, c13_a, c12_r, c12_a, c8_r, c8_a, c5_r, c5_a, initialise);
  BrzFetch_4_s5_false I6 (c12_r, c12_a, c10_r, c10_a0d, c10_a1d, c11_r0d, c11_r1d, c11_a);
  BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m I7 (c10_r, c10_a0d, c10_a1d, c9_r, c9_a0d, c9_a1d, initialise);
  BrzFetch_4_s5_false I8 (c8_r, c8_a, c6_r, c6_a0d, c6_a1d, c7_r0d, c7_r1d, c7_a);
  BrzFetch_4_s5_false I9 (c5_r, c5_a, c4_r, c4_a0d, c4_a1d, count_0r0d, count_0r1d, count_0a);
endmodule

module Balsa_InitialSetup (
  activate_0r, activate_0a,
  start_0r, start_0a,
  startCounter_0r, startCounter_0a,
  controlFlash_0r0d, controlFlash_0r1d, controlFlash_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output startCounter_0r;
  input startCounter_0a;
  output controlFlash_0r0d;
  output controlFlash_0r1d;
  input controlFlash_0a;
  input initialise;
  wire c8_r;
  wire c8_a;
  wire c7_r;
  wire c7_a;
  wire c6_r;
  wire c6_a;
  wire c5_r;
  wire c5_a;
  BrzLoop I0 (activate_0r, activate_0a, c8_r, c8_a);
  BrzDecisionWait_1 I1 (c8_r, c8_a, start_0r, start_0a, c7_r, c7_a, initialise);
  BrzSequence_3_s2_SS I2 (c7_r, c7_a, c6_r, c6_a, startCounter_0r, startCounter_0a, c5_r, c5_a);
  BrzEncode_1_2_s5_1_3b0 I3 (c6_r, c6_a, c5_r, c5_a, controlFlash_0r0d, controlFlash_0r1d, controlFlash_0a, initialise);
endmodule

module Balsa_AsynchronousFlashReadout (
  activate_0r, activate_0a,
  start_0r, start_0a,
  controlFlash_0r0d, controlFlash_0r1d, controlFlash_0a,
  SE_0r, SE_0a0d, SE_0a1d,
  adr_0r0d, adr_0r1d, adr_0a,
  dataRead__0_0r0d, dataRead__0_0r1d, dataRead__0_0a,
  dataRead__1_0r0d, dataRead__1_0r1d, dataRead__1_0a,
  dataRead__2_0r0d, dataRead__2_0r1d, dataRead__2_0a,
  dataRead__3_0r0d, dataRead__3_0r1d, dataRead__3_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output controlFlash_0r0d;
  output controlFlash_0r1d;
  input controlFlash_0a;
  output SE_0r;
  input [7:0] SE_0a0d;
  input [7:0] SE_0a1d;
  output [7:0] adr_0r0d;
  output [7:0] adr_0r1d;
  input adr_0a;
  output [7:0] dataRead__0_0r0d;
  output [7:0] dataRead__0_0r1d;
  input dataRead__0_0a;
  output [7:0] dataRead__1_0r0d;
  output [7:0] dataRead__1_0r1d;
  input dataRead__1_0a;
  output [7:0] dataRead__2_0r0d;
  output [7:0] dataRead__2_0r1d;
  input dataRead__2_0a;
  output [7:0] dataRead__3_0r0d;
  output [7:0] dataRead__3_0r1d;
  input dataRead__3_0a;
  input initialise;
  wire c14_r;
  wire c14_a;
  wire c13_r;
  wire c13_a;
  wire c12_r;
  wire c12_a;
  wire c11_r;
  wire c11_a;
  wire [3:0] c10_r0d;
  wire [3:0] c10_r1d;
  wire c10_a;
  BrzConcur_3 I0 (activate_0r, activate_0a, c14_r, c14_a, c13_r, c13_a, c11_r, c11_a, initialise);
  Balsa_InitialSetup I1 (c14_r, c14_a, start_0r, start_0a, c12_r, c12_a, controlFlash_0r0d, controlFlash_0r1d, controlFlash_0a, initialise);
  Balsa_Counter I2 (c13_r, c13_a, c12_r, c12_a, c10_r0d, c10_r1d, c10_a, initialise);
  Balsa_FlashControl I3 (c11_r, c11_a, c10_r0d, c10_r1d, c10_a, adr_0r0d, adr_0r1d, adr_0a, SE_0r, SE_0a0d, SE_0a1d, dataRead__0_0r0d, dataRead__0_0r1d, dataRead__0_0a, dataRead__1_0r0d, dataRead__1_0r1d, dataRead__1_0a, dataRead__2_0r0d, dataRead__2_0r1d, dataRead__2_0a, dataRead__3_0r0d, dataRead__3_0r1d, dataRead__3_0a, initialise);
endmodule

