/*
    `impl-AsynchronousFlashReadout-FlashReadout.v'
    Balsa Verilog netlist file
    Created: Sun Jul 12 10:40:27 CEST 2015
    By: sokh@bushmills.nvlsi.no (Linux)
    With net-verilog (balsa-netlist) version: 4.0
    Using technology: example/four_b_rb
    Command line : (balsa-netlist --technology example/four_b_rb/ -I . -l impl-AsynchronousFlashReadout-FlashReadout.lst -L impl-AsynchronousFlashReadout-FlashReadout.log --simulation-initialise --basename impl-AsynchronousFlashReadout-FlashReadout [AsynchronousFlashReadout])

    Using `simulation-initialise'
    You must set the following preprocessor directives to use this file:
        balsa_simulate: set if you wish to initialise signal values during sim.
        balsa_init_time: duration of forced initialisation

    Using `propagate-globals'
    The design contains the following global nets
		global-signal:  initialise input 1
*/

`timescale 1ns/1ps

module BALSA_FA (
  nStart,
  A,
  B,
  nCVi,
  Ci,
  nCVo,
  Co,
  sum
);
  input nStart;
  input A;
  input B;
  input nCVi;
  input Ci;
  output nCVo;
  output Co;
  output sum;
  wire start;
  wire ha;
  wire cv;
  INV I0 (start, nStart);
  NOR2 I1 (cv, nStart, nCVi);
  NMUX2 I2 (nCVo, start, cv, ha);
  MUX2 I3 (Co, A, Ci, ha);
  XOR2 I4 (ha, A, B);
  XOR2 I5 (sum, ha, Ci);
endmodule

module BrzBinaryFuncConstR_1_4_32_s8_LessThan_s5__m1m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output out_0d;
  output inpA_0r;
  input inpA_0a;
  input [3:0] inpA_0d;
  wire start_0n;
  wire nStart_0n;
  wire [33:0] nCv_0n;
  wire [33:0] c_0n;
  wire [32:0] eq_0n;
  wire [32:0] addOut_0n;
  wire [32:0] w_0n;
  wire [32:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  INV I0 (out_0d, c_0n[33]);
  INV I1 (done_0n, nCv_0n[33]);
  BALSA_FA I2 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I3 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  BALSA_FA I4 (nStart_0n, n_0n[2], w_0n[2], nCv_0n[2], c_0n[2], nCv_0n[3], c_0n[3], addOut_0n[2]);
  BALSA_FA I5 (nStart_0n, n_0n[3], w_0n[3], nCv_0n[3], c_0n[3], nCv_0n[4], c_0n[4], addOut_0n[3]);
  BALSA_FA I6 (nStart_0n, n_0n[4], w_0n[4], nCv_0n[4], c_0n[4], nCv_0n[5], c_0n[5], addOut_0n[4]);
  BALSA_FA I7 (nStart_0n, n_0n[5], w_0n[5], nCv_0n[5], c_0n[5], nCv_0n[6], c_0n[6], addOut_0n[5]);
  BALSA_FA I8 (nStart_0n, n_0n[6], w_0n[6], nCv_0n[6], c_0n[6], nCv_0n[7], c_0n[7], addOut_0n[6]);
  BALSA_FA I9 (nStart_0n, n_0n[7], w_0n[7], nCv_0n[7], c_0n[7], nCv_0n[8], c_0n[8], addOut_0n[7]);
  BALSA_FA I10 (nStart_0n, n_0n[8], w_0n[8], nCv_0n[8], c_0n[8], nCv_0n[9], c_0n[9], addOut_0n[8]);
  BALSA_FA I11 (nStart_0n, n_0n[9], w_0n[9], nCv_0n[9], c_0n[9], nCv_0n[10], c_0n[10], addOut_0n[9]);
  BALSA_FA I12 (nStart_0n, n_0n[10], w_0n[10], nCv_0n[10], c_0n[10], nCv_0n[11], c_0n[11], addOut_0n[10]);
  BALSA_FA I13 (nStart_0n, n_0n[11], w_0n[11], nCv_0n[11], c_0n[11], nCv_0n[12], c_0n[12], addOut_0n[11]);
  BALSA_FA I14 (nStart_0n, n_0n[12], w_0n[12], nCv_0n[12], c_0n[12], nCv_0n[13], c_0n[13], addOut_0n[12]);
  BALSA_FA I15 (nStart_0n, n_0n[13], w_0n[13], nCv_0n[13], c_0n[13], nCv_0n[14], c_0n[14], addOut_0n[13]);
  BALSA_FA I16 (nStart_0n, n_0n[14], w_0n[14], nCv_0n[14], c_0n[14], nCv_0n[15], c_0n[15], addOut_0n[14]);
  BALSA_FA I17 (nStart_0n, n_0n[15], w_0n[15], nCv_0n[15], c_0n[15], nCv_0n[16], c_0n[16], addOut_0n[15]);
  BALSA_FA I18 (nStart_0n, n_0n[16], w_0n[16], nCv_0n[16], c_0n[16], nCv_0n[17], c_0n[17], addOut_0n[16]);
  BALSA_FA I19 (nStart_0n, n_0n[17], w_0n[17], nCv_0n[17], c_0n[17], nCv_0n[18], c_0n[18], addOut_0n[17]);
  BALSA_FA I20 (nStart_0n, n_0n[18], w_0n[18], nCv_0n[18], c_0n[18], nCv_0n[19], c_0n[19], addOut_0n[18]);
  BALSA_FA I21 (nStart_0n, n_0n[19], w_0n[19], nCv_0n[19], c_0n[19], nCv_0n[20], c_0n[20], addOut_0n[19]);
  BALSA_FA I22 (nStart_0n, n_0n[20], w_0n[20], nCv_0n[20], c_0n[20], nCv_0n[21], c_0n[21], addOut_0n[20]);
  BALSA_FA I23 (nStart_0n, n_0n[21], w_0n[21], nCv_0n[21], c_0n[21], nCv_0n[22], c_0n[22], addOut_0n[21]);
  BALSA_FA I24 (nStart_0n, n_0n[22], w_0n[22], nCv_0n[22], c_0n[22], nCv_0n[23], c_0n[23], addOut_0n[22]);
  BALSA_FA I25 (nStart_0n, n_0n[23], w_0n[23], nCv_0n[23], c_0n[23], nCv_0n[24], c_0n[24], addOut_0n[23]);
  BALSA_FA I26 (nStart_0n, n_0n[24], w_0n[24], nCv_0n[24], c_0n[24], nCv_0n[25], c_0n[25], addOut_0n[24]);
  BALSA_FA I27 (nStart_0n, n_0n[25], w_0n[25], nCv_0n[25], c_0n[25], nCv_0n[26], c_0n[26], addOut_0n[25]);
  BALSA_FA I28 (nStart_0n, n_0n[26], w_0n[26], nCv_0n[26], c_0n[26], nCv_0n[27], c_0n[27], addOut_0n[26]);
  BALSA_FA I29 (nStart_0n, n_0n[27], w_0n[27], nCv_0n[27], c_0n[27], nCv_0n[28], c_0n[28], addOut_0n[27]);
  BALSA_FA I30 (nStart_0n, n_0n[28], w_0n[28], nCv_0n[28], c_0n[28], nCv_0n[29], c_0n[29], addOut_0n[28]);
  BALSA_FA I31 (nStart_0n, n_0n[29], w_0n[29], nCv_0n[29], c_0n[29], nCv_0n[30], c_0n[30], addOut_0n[29]);
  BALSA_FA I32 (nStart_0n, n_0n[30], w_0n[30], nCv_0n[30], c_0n[30], nCv_0n[31], c_0n[31], addOut_0n[30]);
  BALSA_FA I33 (nStart_0n, n_0n[31], w_0n[31], nCv_0n[31], c_0n[31], nCv_0n[32], c_0n[32], addOut_0n[31]);
  BALSA_FA I34 (nStart_0n, n_0n[32], w_0n[32], nCv_0n[32], c_0n[32], nCv_0n[33], c_0n[33], addOut_0n[32]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = vdd;
  INV I37 (nStart_0n, start_0n);
  assign n_0n[4] = gnd;
  assign n_0n[5] = gnd;
  assign n_0n[6] = gnd;
  assign n_0n[7] = gnd;
  assign n_0n[8] = gnd;
  assign n_0n[9] = gnd;
  assign n_0n[10] = gnd;
  assign n_0n[11] = gnd;
  assign n_0n[12] = gnd;
  assign n_0n[13] = gnd;
  assign n_0n[14] = gnd;
  assign n_0n[15] = gnd;
  assign n_0n[16] = gnd;
  assign n_0n[17] = gnd;
  assign n_0n[18] = gnd;
  assign n_0n[19] = gnd;
  assign n_0n[20] = gnd;
  assign n_0n[21] = gnd;
  assign n_0n[22] = gnd;
  assign n_0n[23] = gnd;
  assign n_0n[24] = gnd;
  assign n_0n[25] = gnd;
  assign n_0n[26] = gnd;
  assign n_0n[27] = gnd;
  assign n_0n[28] = gnd;
  assign n_0n[29] = gnd;
  assign n_0n[30] = gnd;
  assign n_0n[31] = gnd;
  assign n_0n[32] = gnd;
  assign n_0n[0] = inpA_0d[0];
  assign n_0n[1] = inpA_0d[1];
  assign n_0n[2] = inpA_0d[2];
  assign n_0n[3] = inpA_0d[3];
  assign w_0n[0] = vdd;
  assign w_0n[1] = vdd;
  assign w_0n[2] = gnd;
  assign w_0n[3] = vdd;
  assign w_0n[4] = vdd;
  assign w_0n[5] = vdd;
  assign w_0n[6] = vdd;
  assign w_0n[7] = vdd;
  assign w_0n[8] = vdd;
  assign w_0n[9] = vdd;
  assign w_0n[10] = vdd;
  assign w_0n[11] = vdd;
  assign w_0n[12] = vdd;
  assign w_0n[13] = vdd;
  assign w_0n[14] = vdd;
  assign w_0n[15] = vdd;
  assign w_0n[16] = vdd;
  assign w_0n[17] = vdd;
  assign w_0n[18] = vdd;
  assign w_0n[19] = vdd;
  assign w_0n[20] = vdd;
  assign w_0n[21] = vdd;
  assign w_0n[22] = vdd;
  assign w_0n[23] = vdd;
  assign w_0n[24] = vdd;
  assign w_0n[25] = vdd;
  assign w_0n[26] = vdd;
  assign w_0n[27] = vdd;
  assign w_0n[28] = vdd;
  assign w_0n[29] = vdd;
  assign w_0n[30] = vdd;
  assign w_0n[31] = vdd;
  assign w_0n[32] = vdd;
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output [1:0] out_0d;
  output inpA_0r;
  input inpA_0a;
  input [1:0] inpA_0d;
  wire start_0n;
  wire nStart_0n;
  wire [2:0] nCv_0n;
  wire [2:0] c_0n;
  wire [1:0] eq_0n;
  wire [1:0] addOut_0n;
  wire [1:0] w_0n;
  wire [1:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  NOR2 I0 (done_0n, nCv_0n[1], nCv_0n[2]);
  assign out_0d[0] = addOut_0n[0];
  assign out_0d[1] = addOut_0n[1];
  BALSA_FA I3 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I4 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = gnd;
  INV I7 (nStart_0n, start_0n);
  assign n_0n[1] = gnd;
  assign n_0n[0] = vdd;
  assign w_0n[0] = inpA_0d[0];
  assign w_0n[1] = inpA_0d[1];
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output [3:0] out_0d;
  output inpA_0r;
  input inpA_0a;
  input [3:0] inpA_0d;
  wire [1:0] internal_0n;
  wire start_0n;
  wire nStart_0n;
  wire [4:0] nCv_0n;
  wire [4:0] c_0n;
  wire [3:0] eq_0n;
  wire [3:0] addOut_0n;
  wire [3:0] w_0n;
  wire [3:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  NOR2 I0 (internal_0n[0], nCv_0n[1], nCv_0n[2]);
  NOR2 I1 (internal_0n[1], nCv_0n[3], nCv_0n[4]);
  AND2 I2 (done_0n, internal_0n[0], internal_0n[1]);
  assign out_0d[0] = addOut_0n[0];
  assign out_0d[1] = addOut_0n[1];
  assign out_0d[2] = addOut_0n[2];
  assign out_0d[3] = addOut_0n[3];
  BALSA_FA I7 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I8 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  BALSA_FA I9 (nStart_0n, n_0n[2], w_0n[2], nCv_0n[2], c_0n[2], nCv_0n[3], c_0n[3], addOut_0n[2]);
  BALSA_FA I10 (nStart_0n, n_0n[3], w_0n[3], nCv_0n[3], c_0n[3], nCv_0n[4], c_0n[4], addOut_0n[3]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = gnd;
  INV I13 (nStart_0n, start_0n);
  assign n_0n[1] = gnd;
  assign n_0n[2] = gnd;
  assign n_0n[3] = gnd;
  assign n_0n[0] = vdd;
  assign w_0n[0] = inpA_0d[0];
  assign w_0n[1] = inpA_0d[1];
  assign w_0n[2] = inpA_0d[2];
  assign w_0n[3] = inpA_0d[3];
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzCase_2_4_s13_0_3b1_3b2_3b3 (
  inp_0r, inp_0a, inp_0d,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a
);
  input inp_0r;
  output inp_0a;
  input [1:0] inp_0d;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  wire [1:0] internal_0n;
  wire [1:0] t_0n;
  wire [1:0] c_0n;
  wire elseAck_0n;
  wire [3:0] int0_0n;
  NOR2 I0 (internal_0n[0], activateOut_0a, activateOut_1a);
  NOR2 I1 (internal_0n[1], activateOut_2a, activateOut_3a);
  NAND2 I2 (inp_0a, internal_0n[0], internal_0n[1]);
  AND2 I3 (int0_0n[0], c_0n[1], c_0n[0]);
  AND2 I4 (int0_0n[1], c_0n[1], t_0n[0]);
  AND2 I5 (int0_0n[2], t_0n[1], c_0n[0]);
  AND2 I6 (int0_0n[3], t_0n[1], t_0n[0]);
  assign activateOut_3r = int0_0n[3];
  assign activateOut_2r = int0_0n[2];
  assign activateOut_1r = int0_0n[1];
  assign activateOut_0r = int0_0n[0];
  DEMUX2 I11 (inp_0r, c_0n[0], t_0n[0], inp_0d[0]);
  DEMUX2 I12 (inp_0r, c_0n[1], t_0n[1], inp_0d[1]);
endmodule

module BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m (
  inp_0r, inp_0a, inp_0d,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a
);
  input inp_0r;
  output inp_0a;
  input [3:0] inp_0d;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  wire [20:0] internal_0n;
  wire [3:0] t_0n;
  wire [3:0] c_0n;
  wire elseAck_0n;
  wire [11:0] int0_0n;
  NOR3 I0 (internal_0n[0], activateOut_0a, activateOut_1a, activateOut_2a);
  NOR2 I1 (internal_0n[1], activateOut_3a, activateOut_4a);
  NAND2 I2 (inp_0a, internal_0n[0], internal_0n[1]);
  NAND2 I3 (internal_0n[2], t_0n[3], c_0n[2]);
  NAND2 I4 (internal_0n[3], t_0n[1], t_0n[0]);
  NOR2 I5 (int0_0n[0], internal_0n[2], internal_0n[3]);
  AND3 I6 (int0_0n[1], t_0n[2], t_0n[1], t_0n[0]);
  NAND2 I7 (internal_0n[4], t_0n[3], c_0n[2]);
  NAND2 I8 (internal_0n[5], c_0n[1], t_0n[0]);
  NOR2 I9 (int0_0n[2], internal_0n[4], internal_0n[5]);
  AND3 I10 (int0_0n[3], t_0n[2], c_0n[1], t_0n[0]);
  AND3 I11 (int0_0n[4], t_0n[2], t_0n[1], c_0n[0]);
  NAND2 I12 (internal_0n[6], t_0n[3], c_0n[2]);
  NAND2 I13 (internal_0n[7], t_0n[1], c_0n[0]);
  NOR2 I14 (int0_0n[5], internal_0n[6], internal_0n[7]);
  AND3 I15 (int0_0n[6], c_0n[2], c_0n[1], c_0n[0]);
  NAND2 I16 (internal_0n[8], t_0n[3], t_0n[2]);
  NAND2 I17 (internal_0n[9], c_0n[1], c_0n[0]);
  NOR2 I18 (int0_0n[7], internal_0n[8], internal_0n[9]);
  NAND2 I19 (internal_0n[10], c_0n[3], c_0n[2]);
  NAND2 I20 (internal_0n[11], c_0n[1], t_0n[0]);
  NOR2 I21 (int0_0n[8], internal_0n[10], internal_0n[11]);
  NAND2 I22 (internal_0n[12], c_0n[3], c_0n[2]);
  NAND2 I23 (internal_0n[13], t_0n[1], c_0n[0]);
  NOR2 I24 (int0_0n[9], internal_0n[12], internal_0n[13]);
  NAND2 I25 (internal_0n[14], c_0n[3], c_0n[2]);
  NAND2 I26 (internal_0n[15], t_0n[1], t_0n[0]);
  NOR2 I27 (int0_0n[10], internal_0n[14], internal_0n[15]);
  NAND2 I28 (internal_0n[16], c_0n[3], t_0n[2]);
  NAND2 I29 (internal_0n[17], c_0n[1], c_0n[0]);
  NOR2 I30 (int0_0n[11], internal_0n[16], internal_0n[17]);
  assign activateOut_4r = int0_0n[11];
  assign activateOut_3r = int0_0n[10];
  assign activateOut_2r = int0_0n[9];
  assign activateOut_1r = int0_0n[8];
  NOR3 I35 (internal_0n[18], int0_0n[0], int0_0n[1], int0_0n[2]);
  NOR3 I36 (internal_0n[19], int0_0n[3], int0_0n[4], int0_0n[5]);
  NOR2 I37 (internal_0n[20], int0_0n[6], int0_0n[7]);
  NAND3 I38 (activateOut_0r, internal_0n[18], internal_0n[19], internal_0n[20]);
  DEMUX2 I39 (inp_0r, c_0n[0], t_0n[0], inp_0d[0]);
  DEMUX2 I40 (inp_0r, c_0n[1], t_0n[1], inp_0d[1]);
  DEMUX2 I41 (inp_0r, c_0n[2], t_0n[2], inp_0d[2]);
  DEMUX2 I42 (inp_0r, c_0n[3], t_0n[3], inp_0d[3]);
endmodule

module BALSA_TELEM (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s;
  AND2 I0 (Br, Ar, s);
  INV I1 (s, Aa);
  C2N I2 (Aa, Ba, Ar);
endmodule

module BrzConcur_3 (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  wire [2:0] acks_0n;
  C3 I0 (activate_0a, acks_0n[0], acks_0n[1], acks_0n[2]);
  BALSA_TELEM I1 (activate_0r, acks_0n[0], activateOut_0r, activateOut_0a);
  BALSA_TELEM I2 (activate_0r, acks_0n[1], activateOut_1r, activateOut_1a);
  BALSA_TELEM I3 (activate_0r, acks_0n[2], activateOut_2r, activateOut_2a);
endmodule

module BrzContinue (
  inp_0r, inp_0a
);
  input inp_0r;
  output inp_0a;
  assign inp_0a = inp_0r;
endmodule

module BrzDecisionWait_1 (
  activate_0r, activate_0a,
  inp_0r, inp_0a,
  out_0r, out_0a
);
  input activate_0r;
  output activate_0a;
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  assign activate_0a = out_0a;
  C2 I1 (out_0r, inp_0r, activate_0r);
  assign inp_0a = out_0a;
endmodule

module BrzEncode_1_2_s5_1_3b0 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  out_0r, out_0a, out_0d
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  output out_0r;
  input out_0a;
  output out_0d;
  wire [1:0] c_0n;
  wire [1:0] t_0n;
  wire [1:0] int0_0n;
  OR2 I0 (out_0r, inp_0r, inp_1r);
  C2 I1 (inp_0a, inp_0r, out_0a);
  C2 I2 (inp_1a, inp_1r, out_0a);
  assign int0_0n[0] = t_0n[0];
  assign int0_0n[1] = t_0n[1];
  assign out_0d = int0_0n[0];
  INV I6 (t_0n[0], c_0n[0]);
  INV I7 (t_0n[1], c_0n[1]);
  NOR2 I8 (c_0n[0], inp_0r, inp_0a);
  NOR2 I9 (c_0n[1], inp_1r, inp_1a);
endmodule

module BrzEncode_8_4_s15_16_3b12_3b8_3b4 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  inp_2r, inp_2a,
  inp_3r, inp_3a,
  out_0r, out_0a, out_0d
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  input inp_2r;
  output inp_2a;
  input inp_3r;
  output inp_3a;
  output out_0r;
  input out_0a;
  output [7:0] out_0d;
  wire [1:0] internal_0n;
  wire [3:0] c_0n;
  wire [3:0] t_0n;
  wire [3:0] int0_0n;
  supply0 gnd;
  NOR2 I0 (internal_0n[0], inp_0r, inp_1r);
  NOR2 I1 (internal_0n[1], inp_2r, inp_3r);
  NAND2 I2 (out_0r, internal_0n[0], internal_0n[1]);
  C2 I3 (inp_0a, inp_0r, out_0a);
  C2 I4 (inp_1a, inp_1r, out_0a);
  C2 I5 (inp_2a, inp_2r, out_0a);
  C2 I6 (inp_3a, inp_3r, out_0a);
  assign int0_0n[0] = t_0n[0];
  assign int0_0n[1] = t_0n[1];
  assign int0_0n[2] = t_0n[2];
  assign int0_0n[3] = t_0n[3];
  assign out_0d[7] = gnd;
  assign out_0d[6] = gnd;
  assign out_0d[5] = gnd;
  assign out_0d[4] = int0_0n[0];
  OR2 I15 (out_0d[3], int0_0n[1], int0_0n[2]);
  OR2 I16 (out_0d[2], int0_0n[1], int0_0n[3]);
  assign out_0d[1] = gnd;
  assign out_0d[0] = gnd;
  INV I19 (t_0n[0], c_0n[0]);
  INV I20 (t_0n[1], c_0n[1]);
  INV I21 (t_0n[2], c_0n[2]);
  INV I22 (t_0n[3], c_0n[3]);
  NOR2 I23 (c_0n[0], inp_0r, inp_0a);
  NOR2 I24 (c_0n[1], inp_1r, inp_1a);
  NOR2 I25 (c_0n[2], inp_2r, inp_2a);
  NOR2 I26 (c_0n[3], inp_3r, inp_3a);
endmodule

module BrzFalseVariable_4_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  wire [3:0] data_0n;
  assign read_0a = read_0r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  BALSA_TELEM I9 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFalseVariable_8_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [7:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [7:0] read_0d;
  wire [7:0] data_0n;
  assign read_0a = read_0r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign data_0n[4] = write_0d[4];
  assign data_0n[5] = write_0d[5];
  assign data_0n[6] = write_0d[6];
  assign data_0n[7] = write_0d[7];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  BALSA_TELEM I17 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFetch_2_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [1:0] inp_0d;
  output out_0r;
  input out_0a;
  output [1:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
endmodule

module BrzFetch_4_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [3:0] inp_0d;
  output out_0r;
  input out_0a;
  output [3:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
  assign out_0d[2] = inp_0d[2];
  assign out_0d[3] = inp_0d[3];
endmodule

module BrzFetch_8_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [7:0] inp_0d;
  output out_0r;
  input out_0a;
  output [7:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
  assign out_0d[2] = inp_0d[2];
  assign out_0d[3] = inp_0d[3];
  assign out_0d[4] = inp_0d[4];
  assign out_0d[5] = inp_0d[5];
  assign out_0d[6] = inp_0d[6];
  assign out_0d[7] = inp_0d[7];
endmodule

module BrzLoop (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  wire nReq_0n;
  supply0 gnd;
  INV I0 (nReq_0n, activate_0r);
  NOR2 I1 (activateOut_0r, nReq_0n, activateOut_0a);
  assign activate_0a = gnd;
endmodule

module BrzPassivatorPush_8_1 (
  out_0r, out_0a, out_0d,
  inp_0r, inp_0a, inp_0d
);
  input out_0r;
  output out_0a;
  output [7:0] out_0d;
  input inp_0r;
  output inp_0a;
  input [7:0] inp_0d;
  wire stl_0n;
  wire lti_0n;
  wire brin_0n;
  wire lrin_0n;
  wire [7:0] ldata_0n;
  assign out_0a = stl_0n;
  assign out_0d[0] = ldata_0n[0];
  assign out_0d[1] = ldata_0n[1];
  assign out_0d[2] = ldata_0n[2];
  assign out_0d[3] = ldata_0n[3];
  assign out_0d[4] = ldata_0n[4];
  assign out_0d[5] = ldata_0n[5];
  assign out_0d[6] = ldata_0n[6];
  assign out_0d[7] = ldata_0n[7];
  AND2 I9 (stl_0n, lrin_0n, brin_0n);
  OR2 I10 (inp_0a, lrin_0n, brin_0n);
  C2 I11 (lrin_0n, brin_0n, lti_0n);
  C2 I12 (brin_0n, inp_0r, lti_0n);
  LATCH I13 (lti_0n, inp_0d[0], ldata_0n[0]);
  LATCH I14 (lti_0n, inp_0d[1], ldata_0n[1]);
  LATCH I15 (lti_0n, inp_0d[2], ldata_0n[2]);
  LATCH I16 (lti_0n, inp_0d[3], ldata_0n[3]);
  LATCH I17 (lti_0n, inp_0d[4], ldata_0n[4]);
  LATCH I18 (lti_0n, inp_0d[5], ldata_0n[5]);
  LATCH I19 (lti_0n, inp_0d[6], ldata_0n[6]);
  LATCH I20 (lti_0n, inp_0d[7], ldata_0n[7]);
  assign lti_0n = out_0r;
endmodule

module BALSA_SELEM (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s;
  AND2 I0 (Br, Ar, s);
  NOR2 I1 (Aa, Ba, s);
  NC2P I2 (s, Ar, Ba);
endmodule

module BrzSequence_3_s2_SS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  wire [2:0] sreq_0n;
  assign activate_0a = activateOut_2a;
  assign activateOut_2r = sreq_0n[2];
  assign sreq_0n[0] = activate_0r;
  BALSA_SELEM I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  BALSA_SELEM I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BALSA_TELEMR (
  Ar,
  Aa,
  Br,
  Ba,
  initialise
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  input initialise;
  wire s;
  AND2 I0 (Br, Ar, s);
  INV I1 (s, Aa);
  C2R I2 (Aa, Ba, Ar, initialise);
endmodule

module BrzSequence_3_s2_ST (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  input initialise;
  wire [2:0] sreq_0n;
  assign activate_0a = activateOut_2a;
  assign activateOut_2r = sreq_0n[2];
  assign sreq_0n[0] = activate_0r;
  BALSA_TELEMR I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a, initialise);
  BALSA_SELEM I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzSequence_5_s4_SSSS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  wire [4:0] sreq_0n;
  assign activate_0a = activateOut_4a;
  assign activateOut_4r = sreq_0n[4];
  assign sreq_0n[0] = activate_0r;
  BALSA_SELEM I3 (sreq_0n[3], sreq_0n[4], activateOut_3r, activateOut_3a);
  BALSA_SELEM I4 (sreq_0n[2], sreq_0n[3], activateOut_2r, activateOut_2a);
  BALSA_SELEM I5 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  BALSA_SELEM I6 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzVariable_2_1_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [1:0] write_0d;
  input read_0r;
  output read_0a;
  output [1:0] read_0d;
  wire [1:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  LATCH I3 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I4 (bWriteReq_0n, write_0d[1], data_0n[1]);
  INV I5 (write_0a, nbWriteReq_0n);
  INV I6 (nbWriteReq_0n, bWriteReq_0n);
  INV I7 (bWriteReq_0n, nWriteReq_0n);
  INV I8 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_2_2_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d
);
  input write_0r;
  output write_0a;
  input [1:0] write_0d;
  input read_0r;
  output read_0a;
  output [1:0] read_0d;
  input read_1r;
  output read_1a;
  output [1:0] read_1d;
  wire [1:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  LATCH I6 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I7 (bWriteReq_0n, write_0d[1], data_0n[1]);
  INV I8 (write_0a, nbWriteReq_0n);
  INV I9 (nbWriteReq_0n, bWriteReq_0n);
  INV I10 (bWriteReq_0n, nWriteReq_0n);
  INV I11 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_4_1_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  wire [3:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  LATCH I5 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I6 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I7 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I8 (bWriteReq_0n, write_0d[3], data_0n[3]);
  INV I9 (write_0a, nbWriteReq_0n);
  INV I10 (nbWriteReq_0n, bWriteReq_0n);
  INV I11 (bWriteReq_0n, nWriteReq_0n);
  INV I12 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_4_3_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d,
  read_2r, read_2a, read_2d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  input read_1r;
  output read_1a;
  output [3:0] read_1d;
  input read_2r;
  output read_2a;
  output [3:0] read_2d;
  wire [3:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_2a = read_2r;
  assign read_2d[0] = data_0n[0];
  assign read_2d[1] = data_0n[1];
  assign read_2d[2] = data_0n[2];
  assign read_2d[3] = data_0n[3];
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_1d[2] = data_0n[2];
  assign read_1d[3] = data_0n[3];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  LATCH I15 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I16 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I17 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I18 (bWriteReq_0n, write_0d[3], data_0n[3]);
  INV I19 (write_0a, nbWriteReq_0n);
  INV I20 (nbWriteReq_0n, bWriteReq_0n);
  INV I21 (bWriteReq_0n, nWriteReq_0n);
  INV I22 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_8_4_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d,
  read_2r, read_2a, read_2d,
  read_3r, read_3a, read_3d
);
  input write_0r;
  output write_0a;
  input [7:0] write_0d;
  input read_0r;
  output read_0a;
  output [7:0] read_0d;
  input read_1r;
  output read_1a;
  output [7:0] read_1d;
  input read_2r;
  output read_2a;
  output [7:0] read_2d;
  input read_3r;
  output read_3a;
  output [7:0] read_3d;
  wire [7:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_2a = read_2r;
  assign read_3a = read_3r;
  assign read_3d[0] = data_0n[0];
  assign read_3d[1] = data_0n[1];
  assign read_3d[2] = data_0n[2];
  assign read_3d[3] = data_0n[3];
  assign read_3d[4] = data_0n[4];
  assign read_3d[5] = data_0n[5];
  assign read_3d[6] = data_0n[6];
  assign read_3d[7] = data_0n[7];
  assign read_2d[0] = data_0n[0];
  assign read_2d[1] = data_0n[1];
  assign read_2d[2] = data_0n[2];
  assign read_2d[3] = data_0n[3];
  assign read_2d[4] = data_0n[4];
  assign read_2d[5] = data_0n[5];
  assign read_2d[6] = data_0n[6];
  assign read_2d[7] = data_0n[7];
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_1d[2] = data_0n[2];
  assign read_1d[3] = data_0n[3];
  assign read_1d[4] = data_0n[4];
  assign read_1d[5] = data_0n[5];
  assign read_1d[6] = data_0n[6];
  assign read_1d[7] = data_0n[7];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  LATCH I36 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I37 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I38 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I39 (bWriteReq_0n, write_0d[3], data_0n[3]);
  LATCH I40 (bWriteReq_0n, write_0d[4], data_0n[4]);
  LATCH I41 (bWriteReq_0n, write_0d[5], data_0n[5]);
  LATCH I42 (bWriteReq_0n, write_0d[6], data_0n[6]);
  LATCH I43 (bWriteReq_0n, write_0d[7], data_0n[7]);
  INV I44 (write_0a, nbWriteReq_0n);
  INV I45 (nbWriteReq_0n, bWriteReq_0n);
  INV I46 (bWriteReq_0n, nWriteReq_0n);
  INV I47 (nWriteReq_0n, write_0r);
endmodule

module BrzWhile (
  activate_0r, activate_0a,
  guard_0r, guard_0a, guard_0d,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output guard_0r;
  input guard_0a;
  input guard_0d;
  output activateOut_0r;
  input activateOut_0a;
  wire guardReq_0n;
  wire guardAck_0n;
  wire nReq_0n;
  DEMUX2 I0 (guard_0a, activate_0a, guardAck_0n, guard_0d);
  BALSA_SELEM I1 (guardReq_0n, activateOut_0r, guard_0r, guardAck_0n);
  INV I2 (nReq_0n, activate_0r);
  NOR2 I3 (guardReq_0n, nReq_0n, activateOut_0a);
endmodule

module BrzWireFork_2 (
  inp_0r, inp_0a,
  out_0r, out_0a,
  out_1r, out_1a
);
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  output out_1r;
  input out_1a;
  supply0 gnd;
  assign inp_0a = gnd;
  assign out_0r = inp_0r;
  assign out_1r = inp_0r;
endmodule

module Balsa_InitialSetup (
  activate_0r, activate_0a,
  start_0r, start_0a,
  startCounter_0r, startCounter_0a,
  controlFlash_0r, controlFlash_0a, controlFlash_0d
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output startCounter_0r;
  input startCounter_0a;
  output controlFlash_0r;
  input controlFlash_0a;
  output controlFlash_0d;
  wire c8_r;
  wire c8_a;
  wire c7_r;
  wire c7_a;
  wire c6_r;
  wire c6_a;
  wire c5_r;
  wire c5_a;
  BrzLoop I0 (activate_0r, activate_0a, c8_r, c8_a);
  BrzDecisionWait_1 I1 (c8_r, c8_a, start_0r, start_0a, c7_r, c7_a);
  BrzSequence_3_s2_SS I2 (c7_r, c7_a, c6_r, c6_a, startCounter_0r, startCounter_0a, c5_r, c5_a);
  BrzEncode_1_2_s5_1_3b0 I3 (c6_r, c6_a, c5_r, c5_a, controlFlash_0r, controlFlash_0a, controlFlash_0d);
endmodule

module Balsa_AsynchronousFlashReadout (
  activate_0r, activate_0a,
  start_0r, start_0a,
  controlFlash_0r, controlFlash_0a, controlFlash_0d,
  SE_0r, SE_0a, SE_0d,
  adr_0r, adr_0a, adr_0d,
  dataRead__0_0r, dataRead__0_0a, dataRead__0_0d,
  dataRead__1_0r, dataRead__1_0a, dataRead__1_0d,
  dataRead__2_0r, dataRead__2_0a, dataRead__2_0d,
  dataRead__3_0r, dataRead__3_0a, dataRead__3_0d,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output controlFlash_0r;
  input controlFlash_0a;
  output controlFlash_0d;
  output SE_0r;
  input SE_0a;
  input [7:0] SE_0d;
  output adr_0r;
  input adr_0a;
  output [7:0] adr_0d;
  output dataRead__0_0r;
  input dataRead__0_0a;
  output [7:0] dataRead__0_0d;
  output dataRead__1_0r;
  input dataRead__1_0a;
  output [7:0] dataRead__1_0d;
  output dataRead__2_0r;
  input dataRead__2_0a;
  output [7:0] dataRead__2_0d;
  output dataRead__3_0r;
  input dataRead__3_0a;
  output [7:0] dataRead__3_0d;
  input initialise;
  wire c66_r;
  wire c66_a;
  wire c65_r;
  wire c65_a;
  wire c64_r;
  wire c64_a;
  wire c64_d;
  wire c63_r;
  wire c63_a;
  wire [3:0] c63_d;
  wire c62_r;
  wire c62_a;
  wire c61_r;
  wire c61_a;
  wire c60_r;
  wire c60_a;
  wire [3:0] c60_d;
  wire c59_r;
  wire c59_a;
  wire [3:0] c59_d;
  wire c58_r;
  wire c58_a;
  wire [3:0] c58_d;
  wire c57_r;
  wire c57_a;
  wire c56_r;
  wire c56_a;
  wire [3:0] c56_d;
  wire c55_r;
  wire c55_a;
  wire [3:0] c55_d;
  wire c54_r;
  wire c54_a;
  wire c53_r;
  wire c53_a;
  wire [3:0] c53_d;
  wire c52_r;
  wire c52_a;
  wire c51_r;
  wire c51_a;
  wire c50_r;
  wire c50_a;
  wire c49_r;
  wire c49_a;
  wire c48_r;
  wire c48_a;
  wire c47_r;
  wire c47_a;
  wire [3:0] c47_d;
  wire c46_r;
  wire c46_a;
  wire c45_r;
  wire c45_a;
  wire [3:0] c45_d;
  wire c44_r;
  wire c44_a;
  wire [7:0] c44_d;
  wire c43_r;
  wire c43_a;
  wire c42_r;
  wire c42_a;
  wire c41_r;
  wire c41_a;
  wire c40_r;
  wire c40_a;
  wire c39_r;
  wire c39_a;
  wire c38_r;
  wire c38_a;
  wire c37_r;
  wire c37_a;
  wire c36_r;
  wire c36_a;
  wire [7:0] c36_d;
  wire c35_r;
  wire c35_a;
  wire c34_r;
  wire c34_a;
  wire c33_r;
  wire c33_a;
  wire [7:0] c33_d;
  wire c32_r;
  wire c32_a;
  wire c31_r;
  wire c31_a;
  wire [7:0] c31_d;
  wire c30_r;
  wire c30_a;
  wire [1:0] c30_d;
  wire c29_r;
  wire c29_a;
  wire c28_r;
  wire c28_a;
  wire [1:0] c28_d;
  wire c27_r;
  wire c27_a;
  wire c26_r;
  wire c26_a;
  wire [7:0] c26_d;
  wire c25_r;
  wire c25_a;
  wire c24_r;
  wire c24_a;
  wire [7:0] c24_d;
  wire c23_r;
  wire c23_a;
  wire c22_r;
  wire c22_a;
  wire [7:0] c22_d;
  wire c21_r;
  wire c21_a;
  wire c20_r;
  wire c20_a;
  wire [7:0] c20_d;
  wire c19_r;
  wire c19_a;
  wire [1:0] c19_d;
  wire c18_r;
  wire c18_a;
  wire [1:0] c18_d;
  wire c17_r;
  wire c17_a;
  wire c16_r;
  wire c16_a;
  wire c15_r;
  wire c15_a;
  wire [1:0] c15_d;
  wire c14_r;
  wire c14_a;
  wire [1:0] c14_d;
  wire c13_r;
  wire c13_a;
  wire [1:0] c13_d;
  wire c12_r;
  wire c12_a;
  wire [7:0] c12_d;
  wire c11_r;
  wire c11_a;
  wire c10_r;
  wire c10_a;
  wire [3:0] c10_d;
  BrzConcur_3 I0 (activate_0r, activate_0a, c66_r, c66_a, c52_r, c52_a, c11_r, c11_a);
  Balsa_InitialSetup I1 (c66_r, c66_a, start_0r, start_0a, c51_r, c51_a, controlFlash_0r, controlFlash_0a, controlFlash_0d);
  BrzVariable_4_1_s0_ I2 (c60_r, c60_a, c60_d, c55_r, c55_a, c55_d);
  BrzVariable_4_3_s0_ I3 (c56_r, c56_a, c56_d, c63_r, c63_a, c63_d, c58_r, c58_a, c58_d, c53_r, c53_a, c53_d);
  BrzDecisionWait_1 I4 (c52_r, c52_a, c51_r, c51_a, c65_r, c65_a);
  BrzWhile I5 (c65_r, c65_a, c64_r, c64_a, c64_d, c62_r, c62_a);
  BrzBinaryFuncConstR_1_4_32_s8_LessThan_s5__m1m I6 (c64_r, c64_a, c64_d, c63_r, c63_a, c63_d);
  BrzSequence_3_s2_ST I7 (c62_r, c62_a, c61_r, c61_a, c57_r, c57_a, c54_r, c54_a, initialise);
  BrzFetch_4_s5_false I8 (c61_r, c61_a, c59_r, c59_a, c59_d, c60_r, c60_a, c60_d);
  BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m I9 (c59_r, c59_a, c59_d, c58_r, c58_a, c58_d);
  BrzFetch_4_s5_false I10 (c57_r, c57_a, c55_r, c55_a, c55_d, c56_r, c56_a, c56_d);
  BrzFetch_4_s5_false I11 (c54_r, c54_a, c53_r, c53_a, c53_d, c10_r, c10_a, c10_d);
  BrzVariable_8_4_s0_ I12 (c31_r, c31_a, c31_d, c26_r, c26_a, c26_d, c24_r, c24_a, c24_d, c22_r, c22_a, c22_d, c20_r, c20_a, c20_d);
  BrzVariable_2_2_s0_ I13 (c15_r, c15_a, c15_d, c28_r, c28_a, c28_d, c13_r, c13_a, c13_d);
  BrzWireFork_2 I14 (c11_r, c11_a, c50_r, c50_a, c38_r, c38_a);
  BrzPassivatorPush_8_1 I15 (c12_r, c12_a, c12_d, c44_r, c44_a, c44_d);
  BrzLoop I16 (c50_r, c50_a, c49_r, c49_a);
  BrzDecisionWait_1 I17 (c49_r, c49_a, c48_r, c48_a, c46_r, c46_a);
  BrzFalseVariable_4_1_s0_ I18 (c10_r, c10_a, c10_d, c48_r, c48_a, c45_r, c45_a, c45_d);
  BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m I19 (c47_r, c47_a, c47_d, c39_r, c39_a, c40_r, c40_a, c41_r, c41_a, c42_r, c42_a, c43_r, c43_a);
  BrzFetch_4_s5_false I20 (c46_r, c46_a, c45_r, c45_a, c45_d, c47_r, c47_a, c47_d);
  BrzContinue I21 (c39_r, c39_a);
  BrzLoop I22 (c38_r, c38_a, c35_r, c35_a);
  BrzFalseVariable_8_1_s0_ I23 (c36_r, c36_a, c36_d, c37_r, c37_a, c33_r, c33_a, c33_d);
  BrzFetch_8_s5_false I24 (c35_r, c35_a, c12_r, c12_a, c12_d, c36_r, c36_a, c36_d);
  BrzSequence_5_s4_SSSS I25 (c37_r, c37_a, c34_r, c34_a, c32_r, c32_a, c29_r, c29_a, c16_r, c16_a, c17_r, c17_a);
  BrzFetch_8_s5_false I26 (c34_r, c34_a, c33_r, c33_a, c33_d, adr_0r, adr_0a, adr_0d);
  BrzFetch_8_s5_false I27 (c32_r, c32_a, SE_0r, SE_0a, SE_0d, c31_r, c31_a, c31_d);
  BrzCase_2_4_s13_0_3b1_3b2_3b3 I28 (c30_r, c30_a, c30_d, c21_r, c21_a, c23_r, c23_a, c25_r, c25_a, c27_r, c27_a);
  BrzFetch_2_s5_false I29 (c29_r, c29_a, c28_r, c28_a, c28_d, c30_r, c30_a, c30_d);
  BrzFetch_8_s5_false I30 (c27_r, c27_a, c26_r, c26_a, c26_d, dataRead__3_0r, dataRead__3_0a, dataRead__3_0d);
  BrzFetch_8_s5_false I31 (c25_r, c25_a, c24_r, c24_a, c24_d, dataRead__2_0r, dataRead__2_0a, dataRead__2_0d);
  BrzFetch_8_s5_false I32 (c23_r, c23_a, c22_r, c22_a, c22_d, dataRead__1_0r, dataRead__1_0a, dataRead__1_0d);
  BrzFetch_8_s5_false I33 (c21_r, c21_a, c20_r, c20_a, c20_d, dataRead__0_0r, dataRead__0_0a, dataRead__0_0d);
  BrzFetch_2_s5_false I34 (c16_r, c16_a, c14_r, c14_a, c14_d, c18_r, c18_a, c18_d);
  BrzFetch_2_s5_false I35 (c17_r, c17_a, c19_r, c19_a, c19_d, c15_r, c15_a, c15_d);
  BrzVariable_2_1_s0_ I36 (c18_r, c18_a, c18_d, c19_r, c19_a, c19_d);
  BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m I37 (c14_r, c14_a, c14_d, c13_r, c13_a, c13_d);
  BrzEncode_8_4_s15_16_3b12_3b8_3b4 I38 (c43_r, c43_a, c42_r, c42_a, c41_r, c41_a, c40_r, c40_a, c44_r, c44_a, c44_d);
endmodule

