/*
    `impl-AsynchronousFlashReadoutTb-AsyncFlashReadout.v'
    Balsa Verilog netlist file
    Created: Mon Jul 27 00:16:29 CEST 2015
    By: sokh@bushmills.nvlsi.no (Linux)
    With net-verilog (balsa-netlist) version: 4.0
    Using technology: example/four_b_rb/sim=modelsim
    Command line : (balsa-netlist --technology example/four_b_rb/sim=modelsim -I . -l impl-AsynchronousFlashReadoutTb-AsyncFlashReadout.lst -L impl-AsynchronousFlashReadoutTb-AsyncFlashReadout.log --simulation-initialise --basename impl-AsynchronousFlashReadoutTb-AsyncFlashReadout [test-AsynchronousFlashReadoutTb])

    Using `simulation-initialise'
    You must set the following preprocessor directives to use this file:
        balsa_simulate: set if you wish to initialise signal values during sim.
        balsa_init_time: duration of forced initialisation

    Using `propagate-globals'
    The design contains the following global nets
		global-signal:  initialise input 1
*/

`timescale 1ns/1ps

module BALSA_FA (
  nStart,
  A,
  B,
  nCVi,
  Ci,
  nCVo,
  Co,
  sum
);
  input nStart;
  input A;
  input B;
  input nCVi;
  input Ci;
  output nCVo;
  output Co;
  output sum;
  wire start;
  wire ha;
  wire cv;
  INV I0 (start, nStart);
  NOR2 I1 (cv, nStart, nCVi);
  NMUX2 I2 (nCVo, start, cv, ha);
  MUX2 I3 (Co, A, Ci, ha);
  XOR2 I4 (ha, A, B);
  XOR2 I5 (sum, ha, Ci);
endmodule

module BrzBinaryFuncConstR_1_4_3_s8_LessThan_s5_f_m8m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output out_0d;
  output inpA_0r;
  input inpA_0a;
  input [3:0] inpA_0d;
  wire start_0n;
  wire nStart_0n;
  wire [4:0] nCv_0n;
  wire [4:0] c_0n;
  wire [3:0] eq_0n;
  wire [3:0] addOut_0n;
  wire [3:0] w_0n;
  wire [3:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  INV I0 (out_0d, c_0n[4]);
  INV I1 (done_0n, nCv_0n[4]);
  BALSA_FA I2 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I3 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  BALSA_FA I4 (nStart_0n, n_0n[2], w_0n[2], nCv_0n[2], c_0n[2], nCv_0n[3], c_0n[3], addOut_0n[2]);
  BALSA_FA I5 (nStart_0n, n_0n[3], w_0n[3], nCv_0n[3], c_0n[3], nCv_0n[4], c_0n[4], addOut_0n[3]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = vdd;
  INV I8 (nStart_0n, start_0n);
  assign n_0n[0] = vdd;
  assign n_0n[1] = vdd;
  assign n_0n[2] = gnd;
  assign n_0n[3] = vdd;
  assign w_0n[0] = inpA_0d[0];
  assign w_0n[1] = inpA_0d[1];
  assign w_0n[2] = inpA_0d[2];
  assign w_0n[3] = inpA_0d[3];
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output [1:0] out_0d;
  output inpA_0r;
  input inpA_0a;
  input [1:0] inpA_0d;
  wire start_0n;
  wire nStart_0n;
  wire [2:0] nCv_0n;
  wire [2:0] c_0n;
  wire [1:0] eq_0n;
  wire [1:0] addOut_0n;
  wire [1:0] w_0n;
  wire [1:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  NOR2 I0 (done_0n, nCv_0n[1], nCv_0n[2]);
  assign out_0d[0] = addOut_0n[0];
  assign out_0d[1] = addOut_0n[1];
  BALSA_FA I3 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I4 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = gnd;
  INV I7 (nStart_0n, start_0n);
  assign n_0n[1] = gnd;
  assign n_0n[0] = vdd;
  assign w_0n[0] = inpA_0d[0];
  assign w_0n[1] = inpA_0d[1];
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m (
  out_0r, out_0a, out_0d,
  inpA_0r, inpA_0a, inpA_0d
);
  input out_0r;
  output out_0a;
  output [3:0] out_0d;
  output inpA_0r;
  input inpA_0a;
  input [3:0] inpA_0d;
  wire [1:0] internal_0n;
  wire start_0n;
  wire nStart_0n;
  wire [4:0] nCv_0n;
  wire [4:0] c_0n;
  wire [3:0] eq_0n;
  wire [3:0] addOut_0n;
  wire [3:0] w_0n;
  wire [3:0] n_0n;
  wire v_0n;
  wire z_0n;
  wire nz_0n;
  wire nxv_0n;
  wire done_0n;
  supply0 gnd;
  supply1 vdd;
  NOR2 I0 (internal_0n[0], nCv_0n[1], nCv_0n[2]);
  NOR2 I1 (internal_0n[1], nCv_0n[3], nCv_0n[4]);
  AND2 I2 (done_0n, internal_0n[0], internal_0n[1]);
  assign out_0d[0] = addOut_0n[0];
  assign out_0d[1] = addOut_0n[1];
  assign out_0d[2] = addOut_0n[2];
  assign out_0d[3] = addOut_0n[3];
  BALSA_FA I7 (nStart_0n, n_0n[0], w_0n[0], nCv_0n[0], c_0n[0], nCv_0n[1], c_0n[1], addOut_0n[0]);
  BALSA_FA I8 (nStart_0n, n_0n[1], w_0n[1], nCv_0n[1], c_0n[1], nCv_0n[2], c_0n[2], addOut_0n[1]);
  BALSA_FA I9 (nStart_0n, n_0n[2], w_0n[2], nCv_0n[2], c_0n[2], nCv_0n[3], c_0n[3], addOut_0n[2]);
  BALSA_FA I10 (nStart_0n, n_0n[3], w_0n[3], nCv_0n[3], c_0n[3], nCv_0n[4], c_0n[4], addOut_0n[3]);
  assign nCv_0n[0] = nStart_0n;
  assign c_0n[0] = gnd;
  INV I13 (nStart_0n, start_0n);
  assign n_0n[1] = gnd;
  assign n_0n[2] = gnd;
  assign n_0n[3] = gnd;
  assign n_0n[0] = vdd;
  assign w_0n[0] = inpA_0d[0];
  assign w_0n[1] = inpA_0d[1];
  assign w_0n[2] = inpA_0d[2];
  assign w_0n[3] = inpA_0d[3];
  assign out_0a = done_0n;
  assign start_0n = inpA_0a;
  assign inpA_0r = out_0r;
endmodule

module BrzCase_2_4_s13_0_3b1_3b2_3b3 (
  inp_0r, inp_0a, inp_0d,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a
);
  input inp_0r;
  output inp_0a;
  input [1:0] inp_0d;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  wire [1:0] internal_0n;
  wire [1:0] t_0n;
  wire [1:0] c_0n;
  wire elseAck_0n;
  wire [3:0] int0_0n;
  NOR2 I0 (internal_0n[0], activateOut_0a, activateOut_1a);
  NOR2 I1 (internal_0n[1], activateOut_2a, activateOut_3a);
  NAND2 I2 (inp_0a, internal_0n[0], internal_0n[1]);
  AND2 I3 (int0_0n[0], c_0n[1], c_0n[0]);
  AND2 I4 (int0_0n[1], c_0n[1], t_0n[0]);
  AND2 I5 (int0_0n[2], t_0n[1], c_0n[0]);
  AND2 I6 (int0_0n[3], t_0n[1], t_0n[0]);
  assign activateOut_3r = int0_0n[3];
  assign activateOut_2r = int0_0n[2];
  assign activateOut_1r = int0_0n[1];
  assign activateOut_0r = int0_0n[0];
  DEMUX2 I11 (inp_0r, c_0n[0], t_0n[0], inp_0d[0]);
  DEMUX2 I12 (inp_0r, c_0n[1], t_0n[1], inp_0d[1]);
endmodule

module BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m (
  inp_0r, inp_0a, inp_0d,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a
);
  input inp_0r;
  output inp_0a;
  input [3:0] inp_0d;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  wire [20:0] internal_0n;
  wire [3:0] t_0n;
  wire [3:0] c_0n;
  wire elseAck_0n;
  wire [11:0] int0_0n;
  NOR3 I0 (internal_0n[0], activateOut_0a, activateOut_1a, activateOut_2a);
  NOR2 I1 (internal_0n[1], activateOut_3a, activateOut_4a);
  NAND2 I2 (inp_0a, internal_0n[0], internal_0n[1]);
  NAND2 I3 (internal_0n[2], t_0n[3], c_0n[2]);
  NAND2 I4 (internal_0n[3], t_0n[1], t_0n[0]);
  NOR2 I5 (int0_0n[0], internal_0n[2], internal_0n[3]);
  AND3 I6 (int0_0n[1], t_0n[2], t_0n[1], t_0n[0]);
  NAND2 I7 (internal_0n[4], t_0n[3], c_0n[2]);
  NAND2 I8 (internal_0n[5], c_0n[1], t_0n[0]);
  NOR2 I9 (int0_0n[2], internal_0n[4], internal_0n[5]);
  AND3 I10 (int0_0n[3], t_0n[2], c_0n[1], t_0n[0]);
  AND3 I11 (int0_0n[4], t_0n[2], t_0n[1], c_0n[0]);
  NAND2 I12 (internal_0n[6], t_0n[3], c_0n[2]);
  NAND2 I13 (internal_0n[7], t_0n[1], c_0n[0]);
  NOR2 I14 (int0_0n[5], internal_0n[6], internal_0n[7]);
  AND3 I15 (int0_0n[6], c_0n[2], c_0n[1], c_0n[0]);
  NAND2 I16 (internal_0n[8], t_0n[3], t_0n[2]);
  NAND2 I17 (internal_0n[9], c_0n[1], c_0n[0]);
  NOR2 I18 (int0_0n[7], internal_0n[8], internal_0n[9]);
  NAND2 I19 (internal_0n[10], c_0n[3], c_0n[2]);
  NAND2 I20 (internal_0n[11], c_0n[1], t_0n[0]);
  NOR2 I21 (int0_0n[8], internal_0n[10], internal_0n[11]);
  NAND2 I22 (internal_0n[12], c_0n[3], c_0n[2]);
  NAND2 I23 (internal_0n[13], t_0n[1], c_0n[0]);
  NOR2 I24 (int0_0n[9], internal_0n[12], internal_0n[13]);
  NAND2 I25 (internal_0n[14], c_0n[3], c_0n[2]);
  NAND2 I26 (internal_0n[15], t_0n[1], t_0n[0]);
  NOR2 I27 (int0_0n[10], internal_0n[14], internal_0n[15]);
  NAND2 I28 (internal_0n[16], c_0n[3], t_0n[2]);
  NAND2 I29 (internal_0n[17], c_0n[1], c_0n[0]);
  NOR2 I30 (int0_0n[11], internal_0n[16], internal_0n[17]);
  assign activateOut_4r = int0_0n[11];
  assign activateOut_3r = int0_0n[10];
  assign activateOut_2r = int0_0n[9];
  assign activateOut_1r = int0_0n[8];
  NOR3 I35 (internal_0n[18], int0_0n[0], int0_0n[1], int0_0n[2]);
  NOR3 I36 (internal_0n[19], int0_0n[3], int0_0n[4], int0_0n[5]);
  NOR2 I37 (internal_0n[20], int0_0n[6], int0_0n[7]);
  NAND3 I38 (activateOut_0r, internal_0n[18], internal_0n[19], internal_0n[20]);
  DEMUX2 I39 (inp_0r, c_0n[0], t_0n[0], inp_0d[0]);
  DEMUX2 I40 (inp_0r, c_0n[1], t_0n[1], inp_0d[1]);
  DEMUX2 I41 (inp_0r, c_0n[2], t_0n[2], inp_0d[2]);
  DEMUX2 I42 (inp_0r, c_0n[3], t_0n[3], inp_0d[3]);
endmodule

module BALSA_TELEM (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s;
  AND2 I0 (Br, Ar, s);
  INV I1 (s, Aa);
  C2N I2 (Aa, Ba, Ar);
endmodule

module BrzConcur_3 (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  wire [2:0] acks_0n;
  C3 I0 (activate_0a, acks_0n[0], acks_0n[1], acks_0n[2]);
  BALSA_TELEM I1 (activate_0r, acks_0n[0], activateOut_0r, activateOut_0a);
  BALSA_TELEM I2 (activate_0r, acks_0n[1], activateOut_1r, activateOut_1a);
  BALSA_TELEM I3 (activate_0r, acks_0n[2], activateOut_2r, activateOut_2a);
endmodule

module BrzConcur_9 (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a,
  activateOut_5r, activateOut_5a,
  activateOut_6r, activateOut_6a,
  activateOut_7r, activateOut_7a,
  activateOut_8r, activateOut_8a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  output activateOut_5r;
  input activateOut_5a;
  output activateOut_6r;
  input activateOut_6a;
  output activateOut_7r;
  input activateOut_7a;
  output activateOut_8r;
  input activateOut_8a;
  wire [2:0] internal_0n;
  wire [8:0] acks_0n;
  C3 I0 (internal_0n[0], acks_0n[0], acks_0n[1], acks_0n[2]);
  C3 I1 (internal_0n[1], acks_0n[3], acks_0n[4], acks_0n[5]);
  C3 I2 (internal_0n[2], acks_0n[6], acks_0n[7], acks_0n[8]);
  C3 I3 (activate_0a, internal_0n[0], internal_0n[1], internal_0n[2]);
  BALSA_TELEM I4 (activate_0r, acks_0n[0], activateOut_0r, activateOut_0a);
  BALSA_TELEM I5 (activate_0r, acks_0n[1], activateOut_1r, activateOut_1a);
  BALSA_TELEM I6 (activate_0r, acks_0n[2], activateOut_2r, activateOut_2a);
  BALSA_TELEM I7 (activate_0r, acks_0n[3], activateOut_3r, activateOut_3a);
  BALSA_TELEM I8 (activate_0r, acks_0n[4], activateOut_4r, activateOut_4a);
  BALSA_TELEM I9 (activate_0r, acks_0n[5], activateOut_5r, activateOut_5a);
  BALSA_TELEM I10 (activate_0r, acks_0n[6], activateOut_6r, activateOut_6a);
  BALSA_TELEM I11 (activate_0r, acks_0n[7], activateOut_7r, activateOut_7a);
  BALSA_TELEM I12 (activate_0r, acks_0n[8], activateOut_8r, activateOut_8a);
endmodule

module BrzConstant_8_0 (
  out_0r, out_0a, out_0d
);
  input out_0r;
  output out_0a;
  output [7:0] out_0d;
  supply0 gnd;
  assign out_0a = out_0r;
  assign out_0d[0] = gnd;
  assign out_0d[1] = gnd;
  assign out_0d[2] = gnd;
  assign out_0d[3] = gnd;
  assign out_0d[4] = gnd;
  assign out_0d[5] = gnd;
  assign out_0d[6] = gnd;
  assign out_0d[7] = gnd;
endmodule

module BrzContinue (
  inp_0r, inp_0a
);
  input inp_0r;
  output inp_0a;
  assign inp_0a = inp_0r;
endmodule

module BrzContinuePush_1 (
  inp_0r, inp_0a, inp_0d
);
  input inp_0r;
  output inp_0a;
  input inp_0d;
  assign inp_0a = inp_0r;
endmodule

module BrzDecisionWait_1 (
  activate_0r, activate_0a,
  inp_0r, inp_0a,
  out_0r, out_0a
);
  input activate_0r;
  output activate_0a;
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  assign activate_0a = out_0a;
  C2 I1 (out_0r, inp_0r, activate_0r);
  assign inp_0a = out_0a;
endmodule

module BrzEncode_1_2_s5_1_3b0 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  out_0r, out_0a, out_0d
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  output out_0r;
  input out_0a;
  output out_0d;
  wire [1:0] c_0n;
  wire [1:0] t_0n;
  wire [1:0] int0_0n;
  OR2 I0 (out_0r, inp_0r, inp_1r);
  C2 I1 (inp_0a, inp_0r, out_0a);
  C2 I2 (inp_1a, inp_1r, out_0a);
  assign int0_0n[0] = t_0n[0];
  assign int0_0n[1] = t_0n[1];
  assign out_0d = int0_0n[0];
  INV I6 (t_0n[0], c_0n[0]);
  INV I7 (t_0n[1], c_0n[1]);
  NOR2 I8 (c_0n[0], inp_0r, inp_0a);
  NOR2 I9 (c_0n[1], inp_1r, inp_1a);
endmodule

module BrzEncode_8_4_s15_16_3b12_3b8_3b4 (
  inp_0r, inp_0a,
  inp_1r, inp_1a,
  inp_2r, inp_2a,
  inp_3r, inp_3a,
  out_0r, out_0a, out_0d
);
  input inp_0r;
  output inp_0a;
  input inp_1r;
  output inp_1a;
  input inp_2r;
  output inp_2a;
  input inp_3r;
  output inp_3a;
  output out_0r;
  input out_0a;
  output [7:0] out_0d;
  wire [1:0] internal_0n;
  wire [3:0] c_0n;
  wire [3:0] t_0n;
  wire [3:0] int0_0n;
  supply0 gnd;
  NOR2 I0 (internal_0n[0], inp_0r, inp_1r);
  NOR2 I1 (internal_0n[1], inp_2r, inp_3r);
  NAND2 I2 (out_0r, internal_0n[0], internal_0n[1]);
  C2 I3 (inp_0a, inp_0r, out_0a);
  C2 I4 (inp_1a, inp_1r, out_0a);
  C2 I5 (inp_2a, inp_2r, out_0a);
  C2 I6 (inp_3a, inp_3r, out_0a);
  assign int0_0n[0] = t_0n[0];
  assign int0_0n[1] = t_0n[1];
  assign int0_0n[2] = t_0n[2];
  assign int0_0n[3] = t_0n[3];
  assign out_0d[7] = gnd;
  assign out_0d[6] = gnd;
  assign out_0d[5] = gnd;
  assign out_0d[4] = int0_0n[0];
  OR2 I15 (out_0d[3], int0_0n[1], int0_0n[2]);
  OR2 I16 (out_0d[2], int0_0n[1], int0_0n[3]);
  assign out_0d[1] = gnd;
  assign out_0d[0] = gnd;
  INV I19 (t_0n[0], c_0n[0]);
  INV I20 (t_0n[1], c_0n[1]);
  INV I21 (t_0n[2], c_0n[2]);
  INV I22 (t_0n[3], c_0n[3]);
  NOR2 I23 (c_0n[0], inp_0r, inp_0a);
  NOR2 I24 (c_0n[1], inp_1r, inp_1a);
  NOR2 I25 (c_0n[2], inp_2r, inp_2a);
  NOR2 I26 (c_0n[3], inp_3r, inp_3a);
endmodule

module BrzFalseVariable_1_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output read_0d;
  wire data_0n;
  assign read_0a = read_0r;
  assign data_0n = write_0d;
  assign read_0d = data_0n;
  BALSA_TELEM I3 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFalseVariable_4_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  wire [3:0] data_0n;
  assign read_0a = read_0r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  BALSA_TELEM I9 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFalseVariable_8_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [7:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [7:0] read_0d;
  wire [7:0] data_0n;
  assign read_0a = read_0r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign data_0n[4] = write_0d[4];
  assign data_0n[5] = write_0d[5];
  assign data_0n[6] = write_0d[6];
  assign data_0n[7] = write_0d[7];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  BALSA_TELEM I17 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFalseVariable_8_2_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d
);
  input write_0r;
  output write_0a;
  input [7:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [7:0] read_0d;
  input read_1r;
  output read_1a;
  output [7:0] read_1d;
  wire [7:0] data_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign data_0n[4] = write_0d[4];
  assign data_0n[5] = write_0d[5];
  assign data_0n[6] = write_0d[6];
  assign data_0n[7] = write_0d[7];
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_1d[2] = data_0n[2];
  assign read_1d[3] = data_0n[3];
  assign read_1d[4] = data_0n[4];
  assign read_1d[5] = data_0n[5];
  assign read_1d[6] = data_0n[6];
  assign read_1d[7] = data_0n[7];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  BALSA_TELEM I26 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFalseVariable_64_1_s0_ (
  write_0r, write_0a, write_0d,
  signal_0r, signal_0a,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [63:0] write_0d;
  output signal_0r;
  input signal_0a;
  input read_0r;
  output read_0a;
  output [63:0] read_0d;
  wire [63:0] data_0n;
  assign read_0a = read_0r;
  assign data_0n[0] = write_0d[0];
  assign data_0n[1] = write_0d[1];
  assign data_0n[2] = write_0d[2];
  assign data_0n[3] = write_0d[3];
  assign data_0n[4] = write_0d[4];
  assign data_0n[5] = write_0d[5];
  assign data_0n[6] = write_0d[6];
  assign data_0n[7] = write_0d[7];
  assign data_0n[8] = write_0d[8];
  assign data_0n[9] = write_0d[9];
  assign data_0n[10] = write_0d[10];
  assign data_0n[11] = write_0d[11];
  assign data_0n[12] = write_0d[12];
  assign data_0n[13] = write_0d[13];
  assign data_0n[14] = write_0d[14];
  assign data_0n[15] = write_0d[15];
  assign data_0n[16] = write_0d[16];
  assign data_0n[17] = write_0d[17];
  assign data_0n[18] = write_0d[18];
  assign data_0n[19] = write_0d[19];
  assign data_0n[20] = write_0d[20];
  assign data_0n[21] = write_0d[21];
  assign data_0n[22] = write_0d[22];
  assign data_0n[23] = write_0d[23];
  assign data_0n[24] = write_0d[24];
  assign data_0n[25] = write_0d[25];
  assign data_0n[26] = write_0d[26];
  assign data_0n[27] = write_0d[27];
  assign data_0n[28] = write_0d[28];
  assign data_0n[29] = write_0d[29];
  assign data_0n[30] = write_0d[30];
  assign data_0n[31] = write_0d[31];
  assign data_0n[32] = write_0d[32];
  assign data_0n[33] = write_0d[33];
  assign data_0n[34] = write_0d[34];
  assign data_0n[35] = write_0d[35];
  assign data_0n[36] = write_0d[36];
  assign data_0n[37] = write_0d[37];
  assign data_0n[38] = write_0d[38];
  assign data_0n[39] = write_0d[39];
  assign data_0n[40] = write_0d[40];
  assign data_0n[41] = write_0d[41];
  assign data_0n[42] = write_0d[42];
  assign data_0n[43] = write_0d[43];
  assign data_0n[44] = write_0d[44];
  assign data_0n[45] = write_0d[45];
  assign data_0n[46] = write_0d[46];
  assign data_0n[47] = write_0d[47];
  assign data_0n[48] = write_0d[48];
  assign data_0n[49] = write_0d[49];
  assign data_0n[50] = write_0d[50];
  assign data_0n[51] = write_0d[51];
  assign data_0n[52] = write_0d[52];
  assign data_0n[53] = write_0d[53];
  assign data_0n[54] = write_0d[54];
  assign data_0n[55] = write_0d[55];
  assign data_0n[56] = write_0d[56];
  assign data_0n[57] = write_0d[57];
  assign data_0n[58] = write_0d[58];
  assign data_0n[59] = write_0d[59];
  assign data_0n[60] = write_0d[60];
  assign data_0n[61] = write_0d[61];
  assign data_0n[62] = write_0d[62];
  assign data_0n[63] = write_0d[63];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  assign read_0d[8] = data_0n[8];
  assign read_0d[9] = data_0n[9];
  assign read_0d[10] = data_0n[10];
  assign read_0d[11] = data_0n[11];
  assign read_0d[12] = data_0n[12];
  assign read_0d[13] = data_0n[13];
  assign read_0d[14] = data_0n[14];
  assign read_0d[15] = data_0n[15];
  assign read_0d[16] = data_0n[16];
  assign read_0d[17] = data_0n[17];
  assign read_0d[18] = data_0n[18];
  assign read_0d[19] = data_0n[19];
  assign read_0d[20] = data_0n[20];
  assign read_0d[21] = data_0n[21];
  assign read_0d[22] = data_0n[22];
  assign read_0d[23] = data_0n[23];
  assign read_0d[24] = data_0n[24];
  assign read_0d[25] = data_0n[25];
  assign read_0d[26] = data_0n[26];
  assign read_0d[27] = data_0n[27];
  assign read_0d[28] = data_0n[28];
  assign read_0d[29] = data_0n[29];
  assign read_0d[30] = data_0n[30];
  assign read_0d[31] = data_0n[31];
  assign read_0d[32] = data_0n[32];
  assign read_0d[33] = data_0n[33];
  assign read_0d[34] = data_0n[34];
  assign read_0d[35] = data_0n[35];
  assign read_0d[36] = data_0n[36];
  assign read_0d[37] = data_0n[37];
  assign read_0d[38] = data_0n[38];
  assign read_0d[39] = data_0n[39];
  assign read_0d[40] = data_0n[40];
  assign read_0d[41] = data_0n[41];
  assign read_0d[42] = data_0n[42];
  assign read_0d[43] = data_0n[43];
  assign read_0d[44] = data_0n[44];
  assign read_0d[45] = data_0n[45];
  assign read_0d[46] = data_0n[46];
  assign read_0d[47] = data_0n[47];
  assign read_0d[48] = data_0n[48];
  assign read_0d[49] = data_0n[49];
  assign read_0d[50] = data_0n[50];
  assign read_0d[51] = data_0n[51];
  assign read_0d[52] = data_0n[52];
  assign read_0d[53] = data_0n[53];
  assign read_0d[54] = data_0n[54];
  assign read_0d[55] = data_0n[55];
  assign read_0d[56] = data_0n[56];
  assign read_0d[57] = data_0n[57];
  assign read_0d[58] = data_0n[58];
  assign read_0d[59] = data_0n[59];
  assign read_0d[60] = data_0n[60];
  assign read_0d[61] = data_0n[61];
  assign read_0d[62] = data_0n[62];
  assign read_0d[63] = data_0n[63];
  BALSA_TELEM I129 (write_0r, write_0a, signal_0r, signal_0a);
endmodule

module BrzFetch_1_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input inp_0d;
  output out_0r;
  input out_0a;
  output out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d = inp_0d;
endmodule

module BrzFetch_2_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [1:0] inp_0d;
  output out_0r;
  input out_0a;
  output [1:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
endmodule

module BrzFetch_4_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [3:0] inp_0d;
  output out_0r;
  input out_0a;
  output [3:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
  assign out_0d[2] = inp_0d[2];
  assign out_0d[3] = inp_0d[3];
endmodule

module BrzFetch_8_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [7:0] inp_0d;
  output out_0r;
  input out_0a;
  output [7:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
  assign out_0d[2] = inp_0d[2];
  assign out_0d[3] = inp_0d[3];
  assign out_0d[4] = inp_0d[4];
  assign out_0d[5] = inp_0d[5];
  assign out_0d[6] = inp_0d[6];
  assign out_0d[7] = inp_0d[7];
endmodule

module BrzFetch_64_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a, inp_0d,
  out_0r, out_0a, out_0d
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a;
  input [63:0] inp_0d;
  output out_0r;
  input out_0a;
  output [63:0] out_0d;
  assign activate_0a = out_0a;
  assign out_0r = inp_0a;
  assign inp_0r = activate_0r;
  assign out_0d[0] = inp_0d[0];
  assign out_0d[1] = inp_0d[1];
  assign out_0d[2] = inp_0d[2];
  assign out_0d[3] = inp_0d[3];
  assign out_0d[4] = inp_0d[4];
  assign out_0d[5] = inp_0d[5];
  assign out_0d[6] = inp_0d[6];
  assign out_0d[7] = inp_0d[7];
  assign out_0d[8] = inp_0d[8];
  assign out_0d[9] = inp_0d[9];
  assign out_0d[10] = inp_0d[10];
  assign out_0d[11] = inp_0d[11];
  assign out_0d[12] = inp_0d[12];
  assign out_0d[13] = inp_0d[13];
  assign out_0d[14] = inp_0d[14];
  assign out_0d[15] = inp_0d[15];
  assign out_0d[16] = inp_0d[16];
  assign out_0d[17] = inp_0d[17];
  assign out_0d[18] = inp_0d[18];
  assign out_0d[19] = inp_0d[19];
  assign out_0d[20] = inp_0d[20];
  assign out_0d[21] = inp_0d[21];
  assign out_0d[22] = inp_0d[22];
  assign out_0d[23] = inp_0d[23];
  assign out_0d[24] = inp_0d[24];
  assign out_0d[25] = inp_0d[25];
  assign out_0d[26] = inp_0d[26];
  assign out_0d[27] = inp_0d[27];
  assign out_0d[28] = inp_0d[28];
  assign out_0d[29] = inp_0d[29];
  assign out_0d[30] = inp_0d[30];
  assign out_0d[31] = inp_0d[31];
  assign out_0d[32] = inp_0d[32];
  assign out_0d[33] = inp_0d[33];
  assign out_0d[34] = inp_0d[34];
  assign out_0d[35] = inp_0d[35];
  assign out_0d[36] = inp_0d[36];
  assign out_0d[37] = inp_0d[37];
  assign out_0d[38] = inp_0d[38];
  assign out_0d[39] = inp_0d[39];
  assign out_0d[40] = inp_0d[40];
  assign out_0d[41] = inp_0d[41];
  assign out_0d[42] = inp_0d[42];
  assign out_0d[43] = inp_0d[43];
  assign out_0d[44] = inp_0d[44];
  assign out_0d[45] = inp_0d[45];
  assign out_0d[46] = inp_0d[46];
  assign out_0d[47] = inp_0d[47];
  assign out_0d[48] = inp_0d[48];
  assign out_0d[49] = inp_0d[49];
  assign out_0d[50] = inp_0d[50];
  assign out_0d[51] = inp_0d[51];
  assign out_0d[52] = inp_0d[52];
  assign out_0d[53] = inp_0d[53];
  assign out_0d[54] = inp_0d[54];
  assign out_0d[55] = inp_0d[55];
  assign out_0d[56] = inp_0d[56];
  assign out_0d[57] = inp_0d[57];
  assign out_0d[58] = inp_0d[58];
  assign out_0d[59] = inp_0d[59];
  assign out_0d[60] = inp_0d[60];
  assign out_0d[61] = inp_0d[61];
  assign out_0d[62] = inp_0d[62];
  assign out_0d[63] = inp_0d[63];
endmodule

module BrzLoop (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  wire nReq_0n;
  supply0 gnd;
  INV I0 (nReq_0n, activate_0r);
  NOR2 I1 (activateOut_0r, nReq_0n, activateOut_0a);
  assign activate_0a = gnd;
endmodule

module BrzPassivatorPush_1_1 (
  out_0r, out_0a, out_0d,
  inp_0r, inp_0a, inp_0d
);
  input out_0r;
  output out_0a;
  output out_0d;
  input inp_0r;
  output inp_0a;
  input inp_0d;
  wire stl_0n;
  wire lti_0n;
  wire brin_0n;
  wire lrin_0n;
  wire ldata_0n;
  assign out_0a = stl_0n;
  assign out_0d = ldata_0n;
  AND2 I2 (stl_0n, lrin_0n, brin_0n);
  OR2 I3 (inp_0a, lrin_0n, brin_0n);
  C2 I4 (lrin_0n, brin_0n, lti_0n);
  C2 I5 (brin_0n, inp_0r, lti_0n);
  LATCH I6 (lti_0n, inp_0d, ldata_0n);
  assign lti_0n = out_0r;
endmodule

module BrzPassivatorPush_8_1 (
  out_0r, out_0a, out_0d,
  inp_0r, inp_0a, inp_0d
);
  input out_0r;
  output out_0a;
  output [7:0] out_0d;
  input inp_0r;
  output inp_0a;
  input [7:0] inp_0d;
  wire stl_0n;
  wire lti_0n;
  wire brin_0n;
  wire lrin_0n;
  wire [7:0] ldata_0n;
  assign out_0a = stl_0n;
  assign out_0d[0] = ldata_0n[0];
  assign out_0d[1] = ldata_0n[1];
  assign out_0d[2] = ldata_0n[2];
  assign out_0d[3] = ldata_0n[3];
  assign out_0d[4] = ldata_0n[4];
  assign out_0d[5] = ldata_0n[5];
  assign out_0d[6] = ldata_0n[6];
  assign out_0d[7] = ldata_0n[7];
  AND2 I9 (stl_0n, lrin_0n, brin_0n);
  OR2 I10 (inp_0a, lrin_0n, brin_0n);
  C2 I11 (lrin_0n, brin_0n, lti_0n);
  C2 I12 (brin_0n, inp_0r, lti_0n);
  LATCH I13 (lti_0n, inp_0d[0], ldata_0n[0]);
  LATCH I14 (lti_0n, inp_0d[1], ldata_0n[1]);
  LATCH I15 (lti_0n, inp_0d[2], ldata_0n[2]);
  LATCH I16 (lti_0n, inp_0d[3], ldata_0n[3]);
  LATCH I17 (lti_0n, inp_0d[4], ldata_0n[4]);
  LATCH I18 (lti_0n, inp_0d[5], ldata_0n[5]);
  LATCH I19 (lti_0n, inp_0d[6], ldata_0n[6]);
  LATCH I20 (lti_0n, inp_0d[7], ldata_0n[7]);
  assign lti_0n = out_0r;
endmodule

module BALSA_SELEM (
  Ar,
  Aa,
  Br,
  Ba
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  wire s;
  AND2 I0 (Br, Ar, s);
  NOR2 I1 (Aa, Ba, s);
  NC2P I2 (s, Ar, Ba);
endmodule

module BrzSequence_2_s1_S (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  wire [1:0] sreq_0n;
  assign activate_0a = activateOut_1a;
  assign activateOut_1r = sreq_0n[1];
  assign sreq_0n[0] = activate_0r;
  BALSA_SELEM I3 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzSequence_3_s2_SS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  wire [2:0] sreq_0n;
  assign activate_0a = activateOut_2a;
  assign activateOut_2r = sreq_0n[2];
  assign sreq_0n[0] = activate_0r;
  BALSA_SELEM I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  BALSA_SELEM I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BALSA_TELEMR (
  Ar,
  Aa,
  Br,
  Ba,
  initialise
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  input initialise;
  wire s;
  AND2 I0 (Br, Ar, s);
  INV I1 (s, Aa);
  C2R I2 (Aa, Ba, Ar, initialise);
endmodule

module BrzSequence_3_s2_ST (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  input initialise;
  wire [2:0] sreq_0n;
  assign activate_0a = activateOut_2a;
  assign activateOut_2r = sreq_0n[2];
  assign sreq_0n[0] = activate_0r;
  BALSA_TELEMR I3 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a, initialise);
  BALSA_SELEM I4 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzSequence_5_s4_SSSS (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  activateOut_2r, activateOut_2a,
  activateOut_3r, activateOut_3a,
  activateOut_4r, activateOut_4a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  output activateOut_2r;
  input activateOut_2a;
  output activateOut_3r;
  input activateOut_3a;
  output activateOut_4r;
  input activateOut_4a;
  wire [4:0] sreq_0n;
  assign activate_0a = activateOut_4a;
  assign activateOut_4r = sreq_0n[4];
  assign sreq_0n[0] = activate_0r;
  BALSA_SELEM I3 (sreq_0n[3], sreq_0n[4], activateOut_3r, activateOut_3a);
  BALSA_SELEM I4 (sreq_0n[2], sreq_0n[3], activateOut_2r, activateOut_2a);
  BALSA_SELEM I5 (sreq_0n[1], sreq_0n[2], activateOut_1r, activateOut_1a);
  BALSA_SELEM I6 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a);
endmodule

module BrzVariable_2_1_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [1:0] write_0d;
  input read_0r;
  output read_0a;
  output [1:0] read_0d;
  wire [1:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  LATCH I3 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I4 (bWriteReq_0n, write_0d[1], data_0n[1]);
  INV I5 (write_0a, nbWriteReq_0n);
  INV I6 (nbWriteReq_0n, bWriteReq_0n);
  INV I7 (bWriteReq_0n, nWriteReq_0n);
  INV I8 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_2_2_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d
);
  input write_0r;
  output write_0a;
  input [1:0] write_0d;
  input read_0r;
  output read_0a;
  output [1:0] read_0d;
  input read_1r;
  output read_1a;
  output [1:0] read_1d;
  wire [1:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  LATCH I6 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I7 (bWriteReq_0n, write_0d[1], data_0n[1]);
  INV I8 (write_0a, nbWriteReq_0n);
  INV I9 (nbWriteReq_0n, bWriteReq_0n);
  INV I10 (bWriteReq_0n, nWriteReq_0n);
  INV I11 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_4_1_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  wire [3:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  LATCH I5 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I6 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I7 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I8 (bWriteReq_0n, write_0d[3], data_0n[3]);
  INV I9 (write_0a, nbWriteReq_0n);
  INV I10 (nbWriteReq_0n, bWriteReq_0n);
  INV I11 (bWriteReq_0n, nWriteReq_0n);
  INV I12 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_4_3_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d,
  read_2r, read_2a, read_2d
);
  input write_0r;
  output write_0a;
  input [3:0] write_0d;
  input read_0r;
  output read_0a;
  output [3:0] read_0d;
  input read_1r;
  output read_1a;
  output [3:0] read_1d;
  input read_2r;
  output read_2a;
  output [3:0] read_2d;
  wire [3:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_2a = read_2r;
  assign read_2d[0] = data_0n[0];
  assign read_2d[1] = data_0n[1];
  assign read_2d[2] = data_0n[2];
  assign read_2d[3] = data_0n[3];
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_1d[2] = data_0n[2];
  assign read_1d[3] = data_0n[3];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  LATCH I15 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I16 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I17 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I18 (bWriteReq_0n, write_0d[3], data_0n[3]);
  INV I19 (write_0a, nbWriteReq_0n);
  INV I20 (nbWriteReq_0n, bWriteReq_0n);
  INV I21 (bWriteReq_0n, nWriteReq_0n);
  INV I22 (nWriteReq_0n, write_0r);
endmodule

module BrzVariable_8_4_s0_ (
  write_0r, write_0a, write_0d,
  read_0r, read_0a, read_0d,
  read_1r, read_1a, read_1d,
  read_2r, read_2a, read_2d,
  read_3r, read_3a, read_3d
);
  input write_0r;
  output write_0a;
  input [7:0] write_0d;
  input read_0r;
  output read_0a;
  output [7:0] read_0d;
  input read_1r;
  output read_1a;
  output [7:0] read_1d;
  input read_2r;
  output read_2a;
  output [7:0] read_2d;
  input read_3r;
  output read_3a;
  output [7:0] read_3d;
  wire [7:0] data_0n;
  wire nWriteReq_0n;
  wire bWriteReq_0n;
  wire nbWriteReq_0n;
  assign read_0a = read_0r;
  assign read_1a = read_1r;
  assign read_2a = read_2r;
  assign read_3a = read_3r;
  assign read_3d[0] = data_0n[0];
  assign read_3d[1] = data_0n[1];
  assign read_3d[2] = data_0n[2];
  assign read_3d[3] = data_0n[3];
  assign read_3d[4] = data_0n[4];
  assign read_3d[5] = data_0n[5];
  assign read_3d[6] = data_0n[6];
  assign read_3d[7] = data_0n[7];
  assign read_2d[0] = data_0n[0];
  assign read_2d[1] = data_0n[1];
  assign read_2d[2] = data_0n[2];
  assign read_2d[3] = data_0n[3];
  assign read_2d[4] = data_0n[4];
  assign read_2d[5] = data_0n[5];
  assign read_2d[6] = data_0n[6];
  assign read_2d[7] = data_0n[7];
  assign read_1d[0] = data_0n[0];
  assign read_1d[1] = data_0n[1];
  assign read_1d[2] = data_0n[2];
  assign read_1d[3] = data_0n[3];
  assign read_1d[4] = data_0n[4];
  assign read_1d[5] = data_0n[5];
  assign read_1d[6] = data_0n[6];
  assign read_1d[7] = data_0n[7];
  assign read_0d[0] = data_0n[0];
  assign read_0d[1] = data_0n[1];
  assign read_0d[2] = data_0n[2];
  assign read_0d[3] = data_0n[3];
  assign read_0d[4] = data_0n[4];
  assign read_0d[5] = data_0n[5];
  assign read_0d[6] = data_0n[6];
  assign read_0d[7] = data_0n[7];
  LATCH I36 (bWriteReq_0n, write_0d[0], data_0n[0]);
  LATCH I37 (bWriteReq_0n, write_0d[1], data_0n[1]);
  LATCH I38 (bWriteReq_0n, write_0d[2], data_0n[2]);
  LATCH I39 (bWriteReq_0n, write_0d[3], data_0n[3]);
  LATCH I40 (bWriteReq_0n, write_0d[4], data_0n[4]);
  LATCH I41 (bWriteReq_0n, write_0d[5], data_0n[5]);
  LATCH I42 (bWriteReq_0n, write_0d[6], data_0n[6]);
  LATCH I43 (bWriteReq_0n, write_0d[7], data_0n[7]);
  INV I44 (write_0a, nbWriteReq_0n);
  INV I45 (nbWriteReq_0n, bWriteReq_0n);
  INV I46 (bWriteReq_0n, nWriteReq_0n);
  INV I47 (nWriteReq_0n, write_0r);
endmodule

module BrzWhile (
  activate_0r, activate_0a,
  guard_0r, guard_0a, guard_0d,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output guard_0r;
  input guard_0a;
  input guard_0d;
  output activateOut_0r;
  input activateOut_0a;
  wire guardReq_0n;
  wire guardAck_0n;
  wire nReq_0n;
  DEMUX2 I0 (guard_0a, activate_0a, guardAck_0n, guard_0d);
  BALSA_SELEM I1 (guardReq_0n, activateOut_0r, guard_0r, guardAck_0n);
  INV I2 (nReq_0n, activate_0r);
  NOR2 I3 (guardReq_0n, nReq_0n, activateOut_0a);
endmodule

module BrzWireFork_2 (
  inp_0r, inp_0a,
  out_0r, out_0a,
  out_1r, out_1a
);
  input inp_0r;
  output inp_0a;
  output out_0r;
  input out_0a;
  output out_1r;
  input out_1a;
  supply0 gnd;
  assign inp_0a = gnd;
  assign out_0r = inp_0r;
  assign out_1r = inp_0r;
endmodule

module Balsa_String_s34__3a_20chan_20_27SE_27_20w_m5m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'SE' writing \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s35__3a_20chan_20_27adr_27_20_m6m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'adr' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s44__3a_20chan_20_27controlFl_m9m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'controlFlash' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s43__3a_20chan_20_27dataRead__m10m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'dataRead_0' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s43__3a_20chan_20_27dataRead__m11m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'dataRead_1' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s43__3a_20chan_20_27dataRead__m12m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'dataRead_2' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s43__3a_20chan_20_27dataRead__m13m (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": chan 'dataRead_3' reading \"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_String_s21__3a_20sync_20_27start (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "String", 1, "\": sync 'start\"", activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_ToString_l31__28numeric_2dtype_20_23_m14m (
  activate_0r, activate_0a, activate_0d,
  value_0r, value_0a, value_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  output value_0r;
  input value_0a;
  input value_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  assign value_0r = activate_0r;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "ToString", 1, "(numeric-type #f 1)", activate_0d, value_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((value_0a) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((value_0a) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_ToString_l31__28numeric_2dtype_20_23_m7m (
  activate_0r, activate_0a, activate_0d,
  value_0r, value_0a, value_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  output value_0r;
  input value_0a;
  input [7:0] value_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  assign value_0r = activate_0r;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "ToString", 1, "(numeric-type #f 8)", activate_0d, value_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((value_0a) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((value_0a) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_StringAppend (
  activate_0r, activate_0a, activate_0d,
  str1_0r, str1_0a, str1_0d,
  str2_0r, str2_0a, str2_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  output str1_0r;
  input str1_0a;
  input [63:0] str1_0d;
  output str2_0r;
  input str2_0a;
  input [63:0] str2_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  assign str1_0r = activate_0r;
  assign str2_0r = activate_0r;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "StringAppend", 0, activate_0d, str1_0d, str2_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((str1_0a & str2_0a) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((str1_0a | str2_0a) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_BalsaSimulationTime (
  activate_0r, activate_0a, activate_0d
);
  input activate_0r;
  output activate_0a;
  output [63:0] activate_0d;
  reg activate_0a;
  reg [63:0] activate_0d;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "BalsaSimulationTime", 0, activate_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((activate_0r) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((activate_0r) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_WriteMessage (
  activate_0r, activate_0a, activate_0d,
  str_0r, str_0a, str_0d
);
  input activate_0r;
  output activate_0a;
  output activate_0d;
  output str_0r;
  input str_0a;
  input [63:0] str_0d;
  reg activate_0a;
  reg activate_0d;
  assign str_0r = activate_0r;
  task builtin_task;
    input ack_state;
    $BalsaBuiltin (ack_state, "WriteMessage", 0, activate_0d, str_0d);
  endtask
  initial begin
    activate_0d = 0;
  end
  always begin
    activate_0a = 0;
    wait ((str_0a) === 1);
    #`balsa_sampling_delay;
    builtin_task (0);
    #`balsa_response_delay;
    activate_0a = 1;
    #`balsa_rtz_delay;
    wait ((str_0a) === 0);
    builtin_task (1);
  end
endmodule

module Balsa_FlashControl (
  activate_0r, activate_0a,
  count_0r, count_0a, count_0d,
  adr_0r, adr_0a, adr_0d,
  SE_0r, SE_0a, SE_0d,
  dataRead__0_0r, dataRead__0_0a, dataRead__0_0d,
  dataRead__1_0r, dataRead__1_0a, dataRead__1_0d,
  dataRead__2_0r, dataRead__2_0a, dataRead__2_0d,
  dataRead__3_0r, dataRead__3_0a, dataRead__3_0d
);
  input activate_0r;
  output activate_0a;
  input count_0r;
  output count_0a;
  input [3:0] count_0d;
  output adr_0r;
  input adr_0a;
  output [7:0] adr_0d;
  output SE_0r;
  input SE_0a;
  input [7:0] SE_0d;
  output dataRead__0_0r;
  input dataRead__0_0a;
  output [7:0] dataRead__0_0d;
  output dataRead__1_0r;
  input dataRead__1_0a;
  output [7:0] dataRead__1_0d;
  output dataRead__2_0r;
  input dataRead__2_0a;
  output [7:0] dataRead__2_0d;
  output dataRead__3_0r;
  input dataRead__3_0a;
  output [7:0] dataRead__3_0d;
  wire c47_r;
  wire c47_a;
  wire c46_r;
  wire c46_a;
  wire c45_r;
  wire c45_a;
  wire c44_r;
  wire c44_a;
  wire [3:0] c44_d;
  wire c43_r;
  wire c43_a;
  wire c42_r;
  wire c42_a;
  wire [3:0] c42_d;
  wire c41_r;
  wire c41_a;
  wire [7:0] c41_d;
  wire c40_r;
  wire c40_a;
  wire c39_r;
  wire c39_a;
  wire c38_r;
  wire c38_a;
  wire c37_r;
  wire c37_a;
  wire c36_r;
  wire c36_a;
  wire c35_r;
  wire c35_a;
  wire c34_r;
  wire c34_a;
  wire c33_r;
  wire c33_a;
  wire [7:0] c33_d;
  wire c32_r;
  wire c32_a;
  wire c31_r;
  wire c31_a;
  wire c30_r;
  wire c30_a;
  wire [7:0] c30_d;
  wire c29_r;
  wire c29_a;
  wire c28_r;
  wire c28_a;
  wire [7:0] c28_d;
  wire c27_r;
  wire c27_a;
  wire [1:0] c27_d;
  wire c26_r;
  wire c26_a;
  wire c25_r;
  wire c25_a;
  wire [1:0] c25_d;
  wire c24_r;
  wire c24_a;
  wire c23_r;
  wire c23_a;
  wire [7:0] c23_d;
  wire c22_r;
  wire c22_a;
  wire c21_r;
  wire c21_a;
  wire [7:0] c21_d;
  wire c20_r;
  wire c20_a;
  wire c19_r;
  wire c19_a;
  wire [7:0] c19_d;
  wire c18_r;
  wire c18_a;
  wire c17_r;
  wire c17_a;
  wire [7:0] c17_d;
  wire c16_r;
  wire c16_a;
  wire [1:0] c16_d;
  wire c15_r;
  wire c15_a;
  wire [1:0] c15_d;
  wire c14_r;
  wire c14_a;
  wire c13_r;
  wire c13_a;
  wire c12_r;
  wire c12_a;
  wire [1:0] c12_d;
  wire c11_r;
  wire c11_a;
  wire [1:0] c11_d;
  wire c10_r;
  wire c10_a;
  wire [1:0] c10_d;
  wire c9_r;
  wire c9_a;
  wire [7:0] c9_d;
  BrzVariable_8_4_s0_ I0 (c28_r, c28_a, c28_d, c23_r, c23_a, c23_d, c21_r, c21_a, c21_d, c19_r, c19_a, c19_d, c17_r, c17_a, c17_d);
  BrzVariable_2_2_s0_ I1 (c12_r, c12_a, c12_d, c25_r, c25_a, c25_d, c10_r, c10_a, c10_d);
  BrzWireFork_2 I2 (activate_0r, activate_0a, c47_r, c47_a, c35_r, c35_a);
  BrzPassivatorPush_8_1 I3 (c9_r, c9_a, c9_d, c41_r, c41_a, c41_d);
  BrzLoop I4 (c47_r, c47_a, c46_r, c46_a);
  BrzDecisionWait_1 I5 (c46_r, c46_a, c45_r, c45_a, c43_r, c43_a);
  BrzFalseVariable_4_1_s0_ I6 (count_0r, count_0a, count_0d, c45_r, c45_a, c42_r, c42_a, c42_d);
  BrzCase_4_5_s56_11_2c7m8_2c9_2c5m8_2c6m8_2_m4m I7 (c44_r, c44_a, c44_d, c36_r, c36_a, c37_r, c37_a, c38_r, c38_a, c39_r, c39_a, c40_r, c40_a);
  BrzFetch_4_s5_false I8 (c43_r, c43_a, c42_r, c42_a, c42_d, c44_r, c44_a, c44_d);
  BrzContinue I9 (c36_r, c36_a);
  BrzLoop I10 (c35_r, c35_a, c32_r, c32_a);
  BrzFalseVariable_8_1_s0_ I11 (c33_r, c33_a, c33_d, c34_r, c34_a, c30_r, c30_a, c30_d);
  BrzFetch_8_s5_false I12 (c32_r, c32_a, c9_r, c9_a, c9_d, c33_r, c33_a, c33_d);
  BrzSequence_5_s4_SSSS I13 (c34_r, c34_a, c31_r, c31_a, c29_r, c29_a, c26_r, c26_a, c13_r, c13_a, c14_r, c14_a);
  BrzFetch_8_s5_false I14 (c31_r, c31_a, c30_r, c30_a, c30_d, adr_0r, adr_0a, adr_0d);
  BrzFetch_8_s5_false I15 (c29_r, c29_a, SE_0r, SE_0a, SE_0d, c28_r, c28_a, c28_d);
  BrzCase_2_4_s13_0_3b1_3b2_3b3 I16 (c27_r, c27_a, c27_d, c18_r, c18_a, c20_r, c20_a, c22_r, c22_a, c24_r, c24_a);
  BrzFetch_2_s5_false I17 (c26_r, c26_a, c25_r, c25_a, c25_d, c27_r, c27_a, c27_d);
  BrzFetch_8_s5_false I18 (c24_r, c24_a, c23_r, c23_a, c23_d, dataRead__3_0r, dataRead__3_0a, dataRead__3_0d);
  BrzFetch_8_s5_false I19 (c22_r, c22_a, c21_r, c21_a, c21_d, dataRead__2_0r, dataRead__2_0a, dataRead__2_0d);
  BrzFetch_8_s5_false I20 (c20_r, c20_a, c19_r, c19_a, c19_d, dataRead__1_0r, dataRead__1_0a, dataRead__1_0d);
  BrzFetch_8_s5_false I21 (c18_r, c18_a, c17_r, c17_a, c17_d, dataRead__0_0r, dataRead__0_0a, dataRead__0_0d);
  BrzFetch_2_s5_false I22 (c13_r, c13_a, c11_r, c11_a, c11_d, c15_r, c15_a, c15_d);
  BrzFetch_2_s5_false I23 (c14_r, c14_a, c16_r, c16_a, c16_d, c12_r, c12_a, c12_d);
  BrzVariable_2_1_s0_ I24 (c15_r, c15_a, c15_d, c16_r, c16_a, c16_d);
  BrzBinaryFuncConstR_2_2_1_s3_Add_s5_false__m2m I25 (c11_r, c11_a, c11_d, c10_r, c10_a, c10_d);
  BrzEncode_8_4_s15_16_3b12_3b8_3b4 I26 (c40_r, c40_a, c39_r, c39_a, c38_r, c38_a, c37_r, c37_a, c41_r, c41_a, c41_d);
endmodule

module Balsa_Counter (
  activate_0r, activate_0a,
  start_0r, start_0a,
  count_0r, count_0a, count_0d,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output count_0r;
  input count_0a;
  output [3:0] count_0d;
  input initialise;
  wire c16_r;
  wire c16_a;
  wire c15_r;
  wire c15_a;
  wire c15_d;
  wire c14_r;
  wire c14_a;
  wire [3:0] c14_d;
  wire c13_r;
  wire c13_a;
  wire c12_r;
  wire c12_a;
  wire c11_r;
  wire c11_a;
  wire [3:0] c11_d;
  wire c10_r;
  wire c10_a;
  wire [3:0] c10_d;
  wire c9_r;
  wire c9_a;
  wire [3:0] c9_d;
  wire c8_r;
  wire c8_a;
  wire c7_r;
  wire c7_a;
  wire [3:0] c7_d;
  wire c6_r;
  wire c6_a;
  wire [3:0] c6_d;
  wire c5_r;
  wire c5_a;
  wire c4_r;
  wire c4_a;
  wire [3:0] c4_d;
  BrzVariable_4_1_s0_ I0 (c11_r, c11_a, c11_d, c6_r, c6_a, c6_d);
  BrzVariable_4_3_s0_ I1 (c7_r, c7_a, c7_d, c14_r, c14_a, c14_d, c9_r, c9_a, c9_d, c4_r, c4_a, c4_d);
  BrzDecisionWait_1 I2 (activate_0r, activate_0a, start_0r, start_0a, c16_r, c16_a);
  BrzWhile I3 (c16_r, c16_a, c15_r, c15_a, c15_d, c13_r, c13_a);
  BrzBinaryFuncConstR_1_4_3_s8_LessThan_s5_f_m8m I4 (c15_r, c15_a, c15_d, c14_r, c14_a, c14_d);
  BrzSequence_3_s2_ST I5 (c13_r, c13_a, c12_r, c12_a, c8_r, c8_a, c5_r, c5_a, initialise);
  BrzFetch_4_s5_false I6 (c12_r, c12_a, c10_r, c10_a, c10_d, c11_r, c11_a, c11_d);
  BrzBinaryFuncConstR_4_4_1_s3_Add_s5_false__m3m I7 (c10_r, c10_a, c10_d, c9_r, c9_a, c9_d);
  BrzFetch_4_s5_false I8 (c8_r, c8_a, c6_r, c6_a, c6_d, c7_r, c7_a, c7_d);
  BrzFetch_4_s5_false I9 (c5_r, c5_a, c4_r, c4_a, c4_d, count_0r, count_0a, count_0d);
endmodule

module Balsa_InitialSetup (
  activate_0r, activate_0a,
  start_0r, start_0a,
  startCounter_0r, startCounter_0a,
  controlFlash_0r, controlFlash_0a, controlFlash_0d
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output startCounter_0r;
  input startCounter_0a;
  output controlFlash_0r;
  input controlFlash_0a;
  output controlFlash_0d;
  wire c8_r;
  wire c8_a;
  wire c7_r;
  wire c7_a;
  wire c6_r;
  wire c6_a;
  wire c5_r;
  wire c5_a;
  BrzLoop I0 (activate_0r, activate_0a, c8_r, c8_a);
  BrzDecisionWait_1 I1 (c8_r, c8_a, start_0r, start_0a, c7_r, c7_a);
  BrzSequence_3_s2_SS I2 (c7_r, c7_a, c6_r, c6_a, startCounter_0r, startCounter_0a, c5_r, c5_a);
  BrzEncode_1_2_s5_1_3b0 I3 (c6_r, c6_a, c5_r, c5_a, controlFlash_0r, controlFlash_0a, controlFlash_0d);
endmodule

module Balsa_AsynchronousFlashReadout (
  activate_0r, activate_0a,
  start_0r, start_0a,
  controlFlash_0r, controlFlash_0a, controlFlash_0d,
  SE_0r, SE_0a, SE_0d,
  adr_0r, adr_0a, adr_0d,
  dataRead__0_0r, dataRead__0_0a, dataRead__0_0d,
  dataRead__1_0r, dataRead__1_0a, dataRead__1_0d,
  dataRead__2_0r, dataRead__2_0a, dataRead__2_0d,
  dataRead__3_0r, dataRead__3_0a, dataRead__3_0d,
  initialise
);
  input activate_0r;
  output activate_0a;
  input start_0r;
  output start_0a;
  output controlFlash_0r;
  input controlFlash_0a;
  output controlFlash_0d;
  output SE_0r;
  input SE_0a;
  input [7:0] SE_0d;
  output adr_0r;
  input adr_0a;
  output [7:0] adr_0d;
  output dataRead__0_0r;
  input dataRead__0_0a;
  output [7:0] dataRead__0_0d;
  output dataRead__1_0r;
  input dataRead__1_0a;
  output [7:0] dataRead__1_0d;
  output dataRead__2_0r;
  input dataRead__2_0a;
  output [7:0] dataRead__2_0d;
  output dataRead__3_0r;
  input dataRead__3_0a;
  output [7:0] dataRead__3_0d;
  input initialise;
  wire c14_r;
  wire c14_a;
  wire c13_r;
  wire c13_a;
  wire c12_r;
  wire c12_a;
  wire c11_r;
  wire c11_a;
  wire c10_r;
  wire c10_a;
  wire [3:0] c10_d;
  BrzConcur_3 I0 (activate_0r, activate_0a, c14_r, c14_a, c13_r, c13_a, c11_r, c11_a);
  Balsa_InitialSetup I1 (c14_r, c14_a, start_0r, start_0a, c12_r, c12_a, controlFlash_0r, controlFlash_0a, controlFlash_0d);
  Balsa_Counter I2 (c13_r, c13_a, c12_r, c12_a, c10_r, c10_a, c10_d, initialise);
  Balsa_FlashControl I3 (c11_r, c11_a, c10_r, c10_a, c10_d, adr_0r, adr_0a, adr_0d, SE_0r, SE_0a, SE_0d, dataRead__0_0r, dataRead__0_0a, dataRead__0_0d, dataRead__1_0r, dataRead__1_0a, dataRead__1_0d, dataRead__2_0r, dataRead__2_0a, dataRead__2_0d, dataRead__3_0r, dataRead__3_0a, dataRead__3_0d);
endmodule

module Balsa_balsa (
  activate_0r, activate_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  input initialise;
  wire c134_r;
  wire c134_a;
  wire c133_r;
  wire c133_a;
  wire c132_r;
  wire c132_a;
  wire c132_d;
  wire c131_r;
  wire c131_a;
  wire [7:0] c131_d;
  wire c130_r;
  wire c130_a;
  wire [7:0] c130_d;
  wire c129_r;
  wire c129_a;
  wire [7:0] c129_d;
  wire c128_r;
  wire c128_a;
  wire [7:0] c128_d;
  wire c127_r;
  wire c127_a;
  wire [7:0] c127_d;
  wire c126_r;
  wire c126_a;
  wire [7:0] c126_d;
  wire c125_r;
  wire c125_a;
  wire c124_r;
  wire c124_a;
  wire c123_r;
  wire c123_a;
  wire c123_d;
  wire c122_r;
  wire c122_a;
  wire c122_d;
  wire c121_r;
  wire c121_a;
  wire [63:0] c121_d;
  wire c120_r;
  wire c120_a;
  wire [63:0] c120_d;
  wire c119_r;
  wire c119_a;
  wire [63:0] c119_d;
  wire c118_r;
  wire c118_a;
  wire c117_r;
  wire c117_a;
  wire c116_r;
  wire c116_a;
  wire [7:0] c116_d;
  wire c115_r;
  wire c115_a;
  wire c114_r;
  wire c114_a;
  wire c113_r;
  wire c113_a;
  wire [7:0] c113_d;
  wire c112_r;
  wire c112_a;
  wire c111_r;
  wire c111_a;
  wire [63:0] c111_d;
  wire c110_r;
  wire c110_a;
  wire c110_d;
  wire c109_r;
  wire c109_a;
  wire c109_d;
  wire c108_r;
  wire c108_a;
  wire [63:0] c108_d;
  wire c107_r;
  wire c107_a;
  wire [63:0] c107_d;
  wire c106_r;
  wire c106_a;
  wire [63:0] c106_d;
  wire c105_r;
  wire c105_a;
  wire [63:0] c105_d;
  wire c104_r;
  wire c104_a;
  wire [63:0] c104_d;
  wire c103_r;
  wire c103_a;
  wire c102_r;
  wire c102_a;
  wire [63:0] c102_d;
  wire c101_r;
  wire c101_a;
  wire [7:0] c101_d;
  wire c100_r;
  wire c100_a;
  wire c99_r;
  wire c99_a;
  wire [7:0] c99_d;
  wire c98_r;
  wire c98_a;
  wire [7:0] c98_d;
  wire c97_r;
  wire c97_a;
  wire c96_r;
  wire c96_a;
  wire [7:0] c96_d;
  wire c95_r;
  wire c95_a;
  wire c94_r;
  wire c94_a;
  wire c93_r;
  wire c93_a;
  wire [63:0] c93_d;
  wire c92_r;
  wire c92_a;
  wire c92_d;
  wire c91_r;
  wire c91_a;
  wire c91_d;
  wire c90_r;
  wire c90_a;
  wire [63:0] c90_d;
  wire c89_r;
  wire c89_a;
  wire [63:0] c89_d;
  wire c88_r;
  wire c88_a;
  wire [63:0] c88_d;
  wire c87_r;
  wire c87_a;
  wire [63:0] c87_d;
  wire c86_r;
  wire c86_a;
  wire [63:0] c86_d;
  wire c85_r;
  wire c85_a;
  wire [63:0] c85_d;
  wire c84_r;
  wire c84_a;
  wire [7:0] c84_d;
  wire c83_r;
  wire c83_a;
  wire c82_r;
  wire c82_a;
  wire [7:0] c82_d;
  wire c81_r;
  wire c81_a;
  wire c80_r;
  wire c80_a;
  wire [7:0] c80_d;
  wire c79_r;
  wire c79_a;
  wire c78_r;
  wire c78_a;
  wire c77_r;
  wire c77_a;
  wire [63:0] c77_d;
  wire c76_r;
  wire c76_a;
  wire c76_d;
  wire c75_r;
  wire c75_a;
  wire c75_d;
  wire c74_r;
  wire c74_a;
  wire [63:0] c74_d;
  wire c73_r;
  wire c73_a;
  wire [63:0] c73_d;
  wire c72_r;
  wire c72_a;
  wire [63:0] c72_d;
  wire c71_r;
  wire c71_a;
  wire [63:0] c71_d;
  wire c70_r;
  wire c70_a;
  wire [63:0] c70_d;
  wire c69_r;
  wire c69_a;
  wire [63:0] c69_d;
  wire c68_r;
  wire c68_a;
  wire [7:0] c68_d;
  wire c67_r;
  wire c67_a;
  wire c66_r;
  wire c66_a;
  wire [7:0] c66_d;
  wire c65_r;
  wire c65_a;
  wire c64_r;
  wire c64_a;
  wire [7:0] c64_d;
  wire c63_r;
  wire c63_a;
  wire c62_r;
  wire c62_a;
  wire c61_r;
  wire c61_a;
  wire [63:0] c61_d;
  wire c60_r;
  wire c60_a;
  wire c60_d;
  wire c59_r;
  wire c59_a;
  wire c59_d;
  wire c58_r;
  wire c58_a;
  wire [63:0] c58_d;
  wire c57_r;
  wire c57_a;
  wire [63:0] c57_d;
  wire c56_r;
  wire c56_a;
  wire [63:0] c56_d;
  wire c55_r;
  wire c55_a;
  wire [63:0] c55_d;
  wire c54_r;
  wire c54_a;
  wire [63:0] c54_d;
  wire c53_r;
  wire c53_a;
  wire [63:0] c53_d;
  wire c52_r;
  wire c52_a;
  wire [7:0] c52_d;
  wire c51_r;
  wire c51_a;
  wire c50_r;
  wire c50_a;
  wire [7:0] c50_d;
  wire c49_r;
  wire c49_a;
  wire c48_r;
  wire c48_a;
  wire [7:0] c48_d;
  wire c47_r;
  wire c47_a;
  wire c46_r;
  wire c46_a;
  wire c45_r;
  wire c45_a;
  wire [63:0] c45_d;
  wire c44_r;
  wire c44_a;
  wire c44_d;
  wire c43_r;
  wire c43_a;
  wire c43_d;
  wire c42_r;
  wire c42_a;
  wire [63:0] c42_d;
  wire c41_r;
  wire c41_a;
  wire [63:0] c41_d;
  wire c40_r;
  wire c40_a;
  wire [63:0] c40_d;
  wire c39_r;
  wire c39_a;
  wire [63:0] c39_d;
  wire c38_r;
  wire c38_a;
  wire [63:0] c38_d;
  wire c37_r;
  wire c37_a;
  wire [63:0] c37_d;
  wire c36_r;
  wire c36_a;
  wire [7:0] c36_d;
  wire c35_r;
  wire c35_a;
  wire c34_r;
  wire c34_a;
  wire [7:0] c34_d;
  wire c33_r;
  wire c33_a;
  wire c32_r;
  wire c32_a;
  wire [7:0] c32_d;
  wire c31_r;
  wire c31_a;
  wire c30_r;
  wire c30_a;
  wire c29_r;
  wire c29_a;
  wire [63:0] c29_d;
  wire c28_r;
  wire c28_a;
  wire c28_d;
  wire c27_r;
  wire c27_a;
  wire c27_d;
  wire c26_r;
  wire c26_a;
  wire [63:0] c26_d;
  wire c25_r;
  wire c25_a;
  wire [63:0] c25_d;
  wire c24_r;
  wire c24_a;
  wire [63:0] c24_d;
  wire c23_r;
  wire c23_a;
  wire [63:0] c23_d;
  wire c22_r;
  wire c22_a;
  wire [63:0] c22_d;
  wire c21_r;
  wire c21_a;
  wire [63:0] c21_d;
  wire c20_r;
  wire c20_a;
  wire [7:0] c20_d;
  wire c19_r;
  wire c19_a;
  wire c18_r;
  wire c18_a;
  wire [7:0] c18_d;
  wire c17_r;
  wire c17_a;
  wire c16_r;
  wire c16_a;
  wire c16_d;
  wire c15_r;
  wire c15_a;
  wire c14_r;
  wire c14_a;
  wire c13_r;
  wire c13_a;
  wire [63:0] c13_d;
  wire c12_r;
  wire c12_a;
  wire c12_d;
  wire c11_r;
  wire c11_a;
  wire c11_d;
  wire c10_r;
  wire c10_a;
  wire [63:0] c10_d;
  wire c9_r;
  wire c9_a;
  wire [63:0] c9_d;
  wire c8_r;
  wire c8_a;
  wire [63:0] c8_d;
  wire c7_r;
  wire c7_a;
  wire [63:0] c7_d;
  wire c6_r;
  wire c6_a;
  wire [63:0] c6_d;
  wire c5_r;
  wire c5_a;
  wire [63:0] c5_d;
  wire c4_r;
  wire c4_a;
  wire c4_d;
  wire c3_r;
  wire c3_a;
  wire c2_r;
  wire c2_a;
  wire c2_d;
  BrzPassivatorPush_1_1 I0 (c2_r, c2_a, c2_d, c132_r, c132_a, c132_d);
  BrzPassivatorPush_8_1 I1 (c18_r, c18_a, c18_d, c126_r, c126_a, c126_d);
  BrzPassivatorPush_8_1 I2 (c34_r, c34_a, c34_d, c127_r, c127_a, c127_d);
  BrzPassivatorPush_8_1 I3 (c50_r, c50_a, c50_d, c128_r, c128_a, c128_d);
  BrzPassivatorPush_8_1 I4 (c66_r, c66_a, c66_d, c129_r, c129_a, c129_d);
  BrzPassivatorPush_8_1 I5 (c82_r, c82_a, c82_d, c130_r, c130_a, c130_d);
  BrzPassivatorPush_8_1 I6 (c131_r, c131_a, c131_d, c98_r, c98_a, c98_d);
  BrzConcur_9 I7 (activate_0r, activate_0a, c134_r, c134_a, c118_r, c118_a, c100_r, c100_a, c83_r, c83_a, c67_r, c67_a, c51_r, c51_a, c35_r, c35_a, c19_r, c19_a, c3_r, c3_a);
  Balsa_AsynchronousFlashReadout I8 (c134_r, c134_a, c133_r, c133_a, c132_r, c132_a, c132_d, c131_r, c131_a, c131_d, c130_r, c130_a, c130_d, c129_r, c129_a, c129_d, c128_r, c128_a, c128_d, c127_r, c127_a, c127_d, c126_r, c126_a, c126_d, initialise);
  BrzLoop I9 (c118_r, c118_a, c125_r, c125_a);
  BrzSequence_2_s1_S I10 (c125_r, c125_a, c133_r, c133_a, c124_r, c124_a);
  BrzFetch_1_s5_false I11 (c124_r, c124_a, c122_r, c122_a, c122_d, c123_r, c123_a, c123_d);
  BrzContinuePush_1 I12 (c123_r, c123_a, c123_d);
  Balsa_WriteMessage I13 (c122_r, c122_a, c122_d, c121_r, c121_a, c121_d);
  Balsa_StringAppend I14 (c121_r, c121_a, c121_d, c120_r, c120_a, c120_d, c119_r, c119_a, c119_d);
  Balsa_BalsaSimulationTime I15 (c120_r, c120_a, c120_d);
  Balsa_String_s21__3a_20sync_20_27start I16 (c119_r, c119_a, c119_d);
  BrzFalseVariable_8_2_s0_ I17 (c116_r, c116_a, c116_d, c117_r, c117_a, c113_r, c113_a, c113_d, c101_r, c101_a, c101_d);
  BrzFetch_8_s5_false I18 (c100_r, c100_a, c99_r, c99_a, c99_d, c116_r, c116_a, c116_d);
  BrzLoop I19 (c117_r, c117_a, c115_r, c115_a);
  BrzSequence_2_s1_S I20 (c115_r, c115_a, c114_r, c114_a, c103_r, c103_a);
  BrzFetch_8_s5_false I21 (c114_r, c114_a, c113_r, c113_a, c113_d, c98_r, c98_a, c98_d);
  BrzFalseVariable_64_1_s0_ I22 (c111_r, c111_a, c111_d, c112_r, c112_a, c104_r, c104_a, c104_d);
  BrzFetch_64_s5_false I23 (c103_r, c103_a, c102_r, c102_a, c102_d, c111_r, c111_a, c111_d);
  BrzFetch_1_s5_false I24 (c112_r, c112_a, c109_r, c109_a, c109_d, c110_r, c110_a, c110_d);
  BrzContinuePush_1 I25 (c110_r, c110_a, c110_d);
  Balsa_WriteMessage I26 (c109_r, c109_a, c109_d, c108_r, c108_a, c108_d);
  Balsa_StringAppend I27 (c108_r, c108_a, c108_d, c107_r, c107_a, c107_d, c106_r, c106_a, c106_d);
  Balsa_BalsaSimulationTime I28 (c107_r, c107_a, c107_d);
  Balsa_StringAppend I29 (c106_r, c106_a, c106_d, c105_r, c105_a, c105_d, c104_r, c104_a, c104_d);
  Balsa_String_s34__3a_20chan_20_27SE_27_20w_m5m I30 (c105_r, c105_a, c105_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I31 (c102_r, c102_a, c102_d, c101_r, c101_a, c101_d);
  BrzConstant_8_0 I32 (c99_r, c99_a, c99_d);
  BrzLoop I33 (c83_r, c83_a, c95_r, c95_a);
  BrzFalseVariable_8_1_s0_ I34 (c96_r, c96_a, c96_d, c97_r, c97_a, c84_r, c84_a, c84_d);
  BrzFetch_8_s5_false I35 (c95_r, c95_a, c82_r, c82_a, c82_d, c96_r, c96_a, c96_d);
  BrzFalseVariable_64_1_s0_ I36 (c93_r, c93_a, c93_d, c94_r, c94_a, c86_r, c86_a, c86_d);
  BrzFetch_64_s5_false I37 (c97_r, c97_a, c85_r, c85_a, c85_d, c93_r, c93_a, c93_d);
  BrzFetch_1_s5_false I38 (c94_r, c94_a, c91_r, c91_a, c91_d, c92_r, c92_a, c92_d);
  BrzContinuePush_1 I39 (c92_r, c92_a, c92_d);
  Balsa_WriteMessage I40 (c91_r, c91_a, c91_d, c90_r, c90_a, c90_d);
  Balsa_StringAppend I41 (c90_r, c90_a, c90_d, c89_r, c89_a, c89_d, c88_r, c88_a, c88_d);
  Balsa_BalsaSimulationTime I42 (c89_r, c89_a, c89_d);
  Balsa_StringAppend I43 (c88_r, c88_a, c88_d, c87_r, c87_a, c87_d, c86_r, c86_a, c86_d);
  Balsa_String_s35__3a_20chan_20_27adr_27_20_m6m I44 (c87_r, c87_a, c87_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I45 (c85_r, c85_a, c85_d, c84_r, c84_a, c84_d);
  BrzLoop I46 (c67_r, c67_a, c79_r, c79_a);
  BrzFalseVariable_8_1_s0_ I47 (c80_r, c80_a, c80_d, c81_r, c81_a, c68_r, c68_a, c68_d);
  BrzFetch_8_s5_false I48 (c79_r, c79_a, c66_r, c66_a, c66_d, c80_r, c80_a, c80_d);
  BrzFalseVariable_64_1_s0_ I49 (c77_r, c77_a, c77_d, c78_r, c78_a, c70_r, c70_a, c70_d);
  BrzFetch_64_s5_false I50 (c81_r, c81_a, c69_r, c69_a, c69_d, c77_r, c77_a, c77_d);
  BrzFetch_1_s5_false I51 (c78_r, c78_a, c75_r, c75_a, c75_d, c76_r, c76_a, c76_d);
  BrzContinuePush_1 I52 (c76_r, c76_a, c76_d);
  Balsa_WriteMessage I53 (c75_r, c75_a, c75_d, c74_r, c74_a, c74_d);
  Balsa_StringAppend I54 (c74_r, c74_a, c74_d, c73_r, c73_a, c73_d, c72_r, c72_a, c72_d);
  Balsa_BalsaSimulationTime I55 (c73_r, c73_a, c73_d);
  Balsa_StringAppend I56 (c72_r, c72_a, c72_d, c71_r, c71_a, c71_d, c70_r, c70_a, c70_d);
  Balsa_String_s43__3a_20chan_20_27dataRead__m10m I57 (c71_r, c71_a, c71_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I58 (c69_r, c69_a, c69_d, c68_r, c68_a, c68_d);
  BrzLoop I59 (c51_r, c51_a, c63_r, c63_a);
  BrzFalseVariable_8_1_s0_ I60 (c64_r, c64_a, c64_d, c65_r, c65_a, c52_r, c52_a, c52_d);
  BrzFetch_8_s5_false I61 (c63_r, c63_a, c50_r, c50_a, c50_d, c64_r, c64_a, c64_d);
  BrzFalseVariable_64_1_s0_ I62 (c61_r, c61_a, c61_d, c62_r, c62_a, c54_r, c54_a, c54_d);
  BrzFetch_64_s5_false I63 (c65_r, c65_a, c53_r, c53_a, c53_d, c61_r, c61_a, c61_d);
  BrzFetch_1_s5_false I64 (c62_r, c62_a, c59_r, c59_a, c59_d, c60_r, c60_a, c60_d);
  BrzContinuePush_1 I65 (c60_r, c60_a, c60_d);
  Balsa_WriteMessage I66 (c59_r, c59_a, c59_d, c58_r, c58_a, c58_d);
  Balsa_StringAppend I67 (c58_r, c58_a, c58_d, c57_r, c57_a, c57_d, c56_r, c56_a, c56_d);
  Balsa_BalsaSimulationTime I68 (c57_r, c57_a, c57_d);
  Balsa_StringAppend I69 (c56_r, c56_a, c56_d, c55_r, c55_a, c55_d, c54_r, c54_a, c54_d);
  Balsa_String_s43__3a_20chan_20_27dataRead__m11m I70 (c55_r, c55_a, c55_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I71 (c53_r, c53_a, c53_d, c52_r, c52_a, c52_d);
  BrzLoop I72 (c35_r, c35_a, c47_r, c47_a);
  BrzFalseVariable_8_1_s0_ I73 (c48_r, c48_a, c48_d, c49_r, c49_a, c36_r, c36_a, c36_d);
  BrzFetch_8_s5_false I74 (c47_r, c47_a, c34_r, c34_a, c34_d, c48_r, c48_a, c48_d);
  BrzFalseVariable_64_1_s0_ I75 (c45_r, c45_a, c45_d, c46_r, c46_a, c38_r, c38_a, c38_d);
  BrzFetch_64_s5_false I76 (c49_r, c49_a, c37_r, c37_a, c37_d, c45_r, c45_a, c45_d);
  BrzFetch_1_s5_false I77 (c46_r, c46_a, c43_r, c43_a, c43_d, c44_r, c44_a, c44_d);
  BrzContinuePush_1 I78 (c44_r, c44_a, c44_d);
  Balsa_WriteMessage I79 (c43_r, c43_a, c43_d, c42_r, c42_a, c42_d);
  Balsa_StringAppend I80 (c42_r, c42_a, c42_d, c41_r, c41_a, c41_d, c40_r, c40_a, c40_d);
  Balsa_BalsaSimulationTime I81 (c41_r, c41_a, c41_d);
  Balsa_StringAppend I82 (c40_r, c40_a, c40_d, c39_r, c39_a, c39_d, c38_r, c38_a, c38_d);
  Balsa_String_s43__3a_20chan_20_27dataRead__m12m I83 (c39_r, c39_a, c39_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I84 (c37_r, c37_a, c37_d, c36_r, c36_a, c36_d);
  BrzLoop I85 (c19_r, c19_a, c31_r, c31_a);
  BrzFalseVariable_8_1_s0_ I86 (c32_r, c32_a, c32_d, c33_r, c33_a, c20_r, c20_a, c20_d);
  BrzFetch_8_s5_false I87 (c31_r, c31_a, c18_r, c18_a, c18_d, c32_r, c32_a, c32_d);
  BrzFalseVariable_64_1_s0_ I88 (c29_r, c29_a, c29_d, c30_r, c30_a, c22_r, c22_a, c22_d);
  BrzFetch_64_s5_false I89 (c33_r, c33_a, c21_r, c21_a, c21_d, c29_r, c29_a, c29_d);
  BrzFetch_1_s5_false I90 (c30_r, c30_a, c27_r, c27_a, c27_d, c28_r, c28_a, c28_d);
  BrzContinuePush_1 I91 (c28_r, c28_a, c28_d);
  Balsa_WriteMessage I92 (c27_r, c27_a, c27_d, c26_r, c26_a, c26_d);
  Balsa_StringAppend I93 (c26_r, c26_a, c26_d, c25_r, c25_a, c25_d, c24_r, c24_a, c24_d);
  Balsa_BalsaSimulationTime I94 (c25_r, c25_a, c25_d);
  Balsa_StringAppend I95 (c24_r, c24_a, c24_d, c23_r, c23_a, c23_d, c22_r, c22_a, c22_d);
  Balsa_String_s43__3a_20chan_20_27dataRead__m13m I96 (c23_r, c23_a, c23_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m7m I97 (c21_r, c21_a, c21_d, c20_r, c20_a, c20_d);
  BrzLoop I98 (c3_r, c3_a, c15_r, c15_a);
  BrzFalseVariable_1_1_s0_ I99 (c16_r, c16_a, c16_d, c17_r, c17_a, c4_r, c4_a, c4_d);
  BrzFetch_1_s5_false I100 (c15_r, c15_a, c2_r, c2_a, c2_d, c16_r, c16_a, c16_d);
  BrzFalseVariable_64_1_s0_ I101 (c13_r, c13_a, c13_d, c14_r, c14_a, c6_r, c6_a, c6_d);
  BrzFetch_64_s5_false I102 (c17_r, c17_a, c5_r, c5_a, c5_d, c13_r, c13_a, c13_d);
  BrzFetch_1_s5_false I103 (c14_r, c14_a, c11_r, c11_a, c11_d, c12_r, c12_a, c12_d);
  BrzContinuePush_1 I104 (c12_r, c12_a, c12_d);
  Balsa_WriteMessage I105 (c11_r, c11_a, c11_d, c10_r, c10_a, c10_d);
  Balsa_StringAppend I106 (c10_r, c10_a, c10_d, c9_r, c9_a, c9_d, c8_r, c8_a, c8_d);
  Balsa_BalsaSimulationTime I107 (c9_r, c9_a, c9_d);
  Balsa_StringAppend I108 (c8_r, c8_a, c8_d, c7_r, c7_a, c7_d, c6_r, c6_a, c6_d);
  Balsa_String_s44__3a_20chan_20_27controlFl_m9m I109 (c7_r, c7_a, c7_d);
  Balsa_ToString_l31__28numeric_2dtype_20_23_m14m I110 (c5_r, c5_a, c5_d, c4_r, c4_a, c4_d);
endmodule

