/*
    Balsa Verilog test harness
    Created: Mon Jul 27 00:16:29 CEST 2015
    By: sokh@bushmills.nvlsi.no (Linux)
    With balsa-make-impl-test version: 4.0
    Command: balsa-make-impl-test -b --technology example/four_b_rb/sim=modelsim -I . -D AsynchronousFlashReadout-AsynchronousFlashReadoutTb-impl.vcd -t -T -o test-AsynchronousFlashReadoutTb-AsyncFlashReadout-top -i impl-AsynchronousFlashReadoutTb-AsyncFlashReadout test-AsynchronousFlashReadoutTb balsa
*/

`define balsa_simulate
`define balsa_init_time 100
`define balsa_activate_delay 10
`define balsa_response_delay 0.01
`define balsa_sampling_delay 0.01
`define balsa_rtz_delay 0.005
`define balsa_clock_high_delay 50
`define balsa_clock_low_delay 50

`include "/pri/sokh/balsa/share/tech/example/example-cells.v"
`include "impl-AsynchronousFlashReadoutTb-AsyncFlashReadout.v"

`timescale 1ns/1ps

module test;
  reg running;
  reg activate_0r;
  wire activate_0a;
  reg initialise;

  initial begin
    running = 0;
    activate_0r = 0;
    initialise = 1;
    #`balsa_init_time;
    initialise = 0;
    #`balsa_activate_delay;
    running = 1;
    activate_0r = 1;
    @(posedge activate_0a);
    #`balsa_response_delay;
    activate_0r = 0;
    @(negedge activate_0a);
  end

  /* Balsa initialisation tasks */
  initial begin
    $dumpfile ("AsynchronousFlashReadout-AsynchronousFlashReadoutTb-impl.vcd");
    $dumpvars (0, test);
  end
  initial begin
    $BalsaInternType ("bit", "(numeric-type #f 1)");
    $BalsaInternType ("BalsaError", "(enumeration-type #f 3 (\"runtime\" 0) (\"fatal\" 1) (\"error\" 2) (\"warning\" 3) (\"report\" 4))");
    $BalsaInternType ("String", "(builtin-type)");
    $BalsaInternType ("UnaryOperator", "(enumeration-type #f 1 (\"Negate\" 0) (\"Invert\" 1))");
    $BalsaInternType ("BinaryOperator", "(enumeration-type #f 4 (\"Add\" 0) (\"Subtract\" 1) (\"ReverseSubtract\" 2) (\"Equals\" 3) (\"NotEquals\" 4) (\"LessThan\" 5) (\"GreaterThan\" 6) (\"LessOrEquals\" 7) (\"GreaterOrEquals\" 8) (\"And\" 9) (\"Or\" 10) (\"Xor\" 11))");
    $BalsaInternType ("boolean", "(enumeration-type #f 1 (\"false\" 0) (\"true\" 1))");
    $BalsaInternType ("byte", "(numeric-type #f 8)");
    $BalsaInternType ("nybble", "(numeric-type #f 4)");
    $BalsaInternType ("nibble", "(numeric-type #f 4)");
    $BalsaInternType ("sbyte", "(numeric-type #t 8)");
    $BalsaInternType ("snybble", "(numeric-type #t 4)");
    $BalsaInternType ("snibble", "(numeric-type #t 4)");
    $BalsaInternType ("cardinal", "(numeric-type #f 32)");
    $BalsaInternType ("long", "(numeric-type #f 64)");
    $BalsaInternType ("token", "(numeric-type #f 1)");
    $BalsaInternType ("StringJustification", "(enumeration-type #f 1 (\"left\" 0) (\"right\" 1))");
    $BalsaInternType ("StringTokenTail", "(record-type 128 (\"token\" (named-type \"String\")) (\"tail\" (named-type \"String\")))");
    $BalsaInternType ("File", "(builtin-type)");
    $BalsaInternType ("FileMode", "(enumeration-type #f 3 (\"read\" 0) (\"write\" 1) (\"writeUnbuffered\" 2) (\"writeLineBuffered\" 3))");
  end

  Balsa_balsa DUT (
    activate_0r, activate_0a,
    initialise
  );
endmodule
