`timescale 1ps / 1ps

module test_FlashWrapper();

  localparam ADDR_X_WIDTH = 4;
  localparam ADDR_Y_WIDTH = 4;
  localparam DOUT_WIDTH   = 8;
  
  logic SE_Req;
  logic [DOUT_WIDTH-1:0] SE_0a0d;
  logic [DOUT_WIDTH-1:0] SE_0a1d;
  logic adr_Ack;
  logic [ADDR_X_WIDTH+ADDR_Y_WIDTH-1:0] adr_0r0d;
  logic [ADDR_X_WIDTH+ADDR_Y_WIDTH-1:0] adr_0r1d;
  logic activate_Req;
  logic activate_Ack;
  logic start_Req;
  logic start_Ack;
  logic arst;
  
  logic                       controlFlash_0r0d;
  logic                       controlFlash_0r1d;
  logic                       controlFlash_a;
  logic [3:0][DOUT_WIDTH-1:0] dataRead_0r0d;
  logic [3:0][DOUT_WIDTH-1:0] dataRead_0r1d;
  logic [3:0]                 dataRead_a;

// TEMP
  logic [3:0] count_0r0d;
  logic [3:0] count_0r1d;
  logic       count_0a;

      FlashWrapper#(  
                     .ADDR_X_WIDTH  (ADDR_X_WIDTH), 
                     .ADDR_Y_WIDTH  (ADDR_Y_WIDTH), 
                     .DOUT_WIDTH    (DOUT_WIDTH ) 
                   )      
      u_FlashWrapper(
                     .arst              (arst),
                     .controlFlash_0r0d (controlFlash_0r0d),
                     .controlFlash_0r1d (controlFlash_0r1d),
                     .controlFlash_a    (controlFlash_a),
                     .SE_Req            (SE_Req),
                     .SE_0a0d           (SE_0a0d),
                     .SE_0a1d           (SE_0a1d),
                     .adr_0r0d          (adr_0r0d), 
                     .adr_0r1d          (adr_0r1d), 
                     .adr_Ack           (adr_Ack), 
                     .dataRead_0r0d     (dataRead_0r0d),
                     .dataRead_0r1d     (dataRead_0r1d),
                     .dataRead_a        (dataRead_a)
                    );
  
      Balsa_AsynchronousFlashReadout u_Balsa_AsynchronousFlashReadout(
                    .initialise        (arst),
                    .activate_0r       (activate_Req), 
                    .activate_0a       (activate_Ack),
                    .start_0r          (start_Req),
                    .start_0a          (start_Ack),
                    .controlFlash_0r0d (controlFlash_0r0d),
                    .controlFlash_0r1d (controlFlash_0r1d),
                    .controlFlash_0a   (controlFlash_a),
                    .SE_0r             (SE_Req),
                    .SE_0a0d           (SE_0a0d),
                    .SE_0a1d           (SE_0a1d),
                    .adr_0r0d          (adr_0r0d), 
                    .adr_0r1d          (adr_0r1d), 
                    .adr_0a            (adr_Ack), 
                    .dataRead__0_0r0d  (dataRead_0r0d[0]),  
                    .dataRead__0_0r1d  (dataRead_0r1d[0]),  
                    .dataRead__1_0r0d  (dataRead_0r0d[1]),  
                    .dataRead__1_0r1d  (dataRead_0r1d[1]),  
                    .dataRead__2_0r0d  (dataRead_0r0d[2]),  
                    .dataRead__2_0r1d  (dataRead_0r1d[2]),  
                    .dataRead__3_0r0d  (dataRead_0r0d[3]),  
                    .dataRead__3_0r1d  (dataRead_0r1d[3]),  
                    .dataRead__0_0a    (dataRead_a[0]),
                    .dataRead__1_0a    (dataRead_a[1]),
                    .dataRead__2_0a    (dataRead_a[2]),
                    .dataRead__3_0a    (dataRead_a[3])
                   );


      //Balsa_AsynchronousFlashReadout u_Balsa_AsynchronousFlashReadout(
      ////Balsa_Counter u_Balsa_AsynchronousFlashReadout(
      //              .initialise        (arst),
      //              .activate_0r       (activate_Req), 
      //              .activate_0a       (activate_Ack),
      //              .start_0r          (start_Req),
      //              .start_0a          (start_Ack),
      //              //.controlFlash_0r0d (controlFlash_0r0d),
      //              //.controlFlash_0r1d (controlFlash_0r1d),
      //              //.controlFlash_0a   (controlFlash_a),
      //              //.SE_0r             (SE_Req),
      //              //.SE_0a0d           (SE_0a0d),
      //              //.SE_0a1d           (SE_0a1d),
      //              //.adr_0r0d          (adr_0r0d), 
      //              //.adr_0r1d          (adr_0r1d), 
      //              //.adr_0a            (adr_Ack), 
      //              .count_0r0d          (count_0r0d),
      //              .count_0r1d          (count_0r1d),
      //              .count_0a            (count_0r0d | count_0r1d)
      //              );




initial begin

  $timeformat(-6,3," us",0);
  arst = 1'b1;
  activate_Req = 0;
  start_Req = 0;
  #100ns;
  arst = 0;
  #10ns;
  activate_Req = 1'b1;
  #1ns;
  start_Req = 1'b1;
  #100ns;
  
  
end 


endmodule
