`timescale 1ps / 1ps

module test_FlashWrapper();

  localparam ADDR_X_WIDTH = 4;
  localparam ADDR_Y_WIDTH = 4;
  localparam DOUT_WIDTH   = 8;
  
  logic SE_Req;
  logic [DOUT_WIDTH-1:0] SE_Data;
  logic SE_Ack;
  logic adr_Req;
  logic adr_Ack;
  logic [ADDR_X_WIDTH+ADDR_Y_WIDTH-1:0] adr_Data;
  logic activate_Req;
  logic activate_Ack;
  logic start_Req;
  logic start_Ack;
  logic arst;
  
  logic                       controlFlash_r;
  logic                       controlFlash_a;
  logic                       controlFlash_d;
  logic [3:0]                 dataRead_r;
  logic [3:0]                 dataRead_a;
  logic [3:0][DOUT_WIDTH-1:0] dataRead_d;

  logic  count;

      FlashWrapper#(  
                     .ADDR_X_WIDTH  (ADDR_X_WIDTH), 
                     .ADDR_Y_WIDTH  (ADDR_Y_WIDTH), 
                     .DOUT_WIDTH    (DOUT_WIDTH ) 
                   )      
      u_FlashWrapper(
                     .arst             (arst),
                     .controlFlash_r   (controlFlash_r),
                     .controlFlash_a   (controlFlash_a),
                     .controlFlash_d   (controlFlash_d),
                     .SE_Req           (SE_Req),
                     .SE_Data          (SE_Data),
                     .SE_Ack           (SE_Ack),
                     .adr_Req          (adr_Req),
                     .adr_Data         (adr_Data),
                     .adr_Ack          (adr_Ack),
                     .dataRead_r       (dataRead_r),
                     .dataRead_a       (dataRead_a),
                     .dataRead_d       (dataRead_d)
                    );
  
      Balsa_AsynchronousFlashReadout u_Balsa_AsynchronousFlashReadout(
                    .initialise      (arst),
                    .activate_0r     (activate_Req), 
                    .activate_0a     (activate_Ack),
                    .start_0r        (start_Req),
                    .start_0a        (start_Ack),
                    .controlFlash_0r (controlFlash_r),
                    .controlFlash_0a (controlFlash_a),
                    .controlFlash_0d (controlFlash_d),
                    .SE_0r           (SE_Req),
                    .SE_0a           (SE_Ack),
                    .SE_0d           (SE_Data),
                    .adr_0r          (adr_Req), 
                    .adr_0a          (adr_Ack), 
                    .adr_0d          (adr_Data),
                    .dataRead__0_0r  (dataRead_r[0]),  
                    .dataRead__1_0r  (dataRead_r[1]),  
                    .dataRead__2_0r  (dataRead_r[2]),  
                    .dataRead__3_0r  (dataRead_r[3]),  
                    .dataRead__0_0a  (dataRead_a[0]),
                    .dataRead__1_0a  (dataRead_a[1]),
                    .dataRead__2_0a  (dataRead_a[2]),
                    .dataRead__3_0a  (dataRead_a[3]),
                    .dataRead__0_0d  (dataRead_d[0]),
                    .dataRead__1_0d  (dataRead_d[1]),
                    .dataRead__2_0d  (dataRead_d[2]),
                    .dataRead__3_0d  (dataRead_d[3])
                   );



      //Balsa_Counter u_Balsa_AsynchronousFlashReadout(
      //              .initialise      (arst),
      //              .activate_0r     (activate_Req), 
      //              .activate_0a     (activate_Ack),
      //              .start_0r        (start_Req),
      //              .start_0a        (start_Ack),
      //              .count_0r        (count),
      //              .count_0a        (count),
      //              .count_0d        ()
      //             );

initial begin

  $timeformat(-6,3," us",0);
  arst = 1'b1;
  activate_Req = 0;
  start_Req = 0;
  #100ns;
  arst = 0;
  #10ns;
  activate_Req = 1'b1;
  #1ns;
  start_Req = 1'b1;
  #100ns;
  
  
end 


endmodule
