//######################################################################
//##        Copyright (c) 2010 Nordic Semiconductor ASA, Norway 
//######################################################################
//## Created       : 17.09.2014
//## Modified      : $Author: Sonal Khosla 
//## Description   :
//######################################################################

module C2 (
                    input  logic A,
                    input  logic B,
                    input  logic arst,
                    output logic Q   
               );


`ifdef FPGA

   logic ck;  
   logic set;
   logic reset;
   logic resetWire;
   logic C;
  
   HinstAnd2 u_AndGateSet(
    .a(A),
    .b(B),
    .y(set)
   );
  
   HinstAnd2 u_AndGateReset(
    .a(~B),
    .b(~A),
    .y(reset)
   );
   
   assign ck    = 0;
   assign resetWire = reset| arst;
   
  // synopsys async_set_reset "set"
  // synopsys async_set_reset "resetWire"

   always @(set or resetWire) begin 
     if(resetWire)begin
       C = 0;
     end
     else if(set)begin
       C = 1;
     end
//     else begin
//       C <= 0;
//     end
   end

`else

  logic C;

  MC2CNX2_ES34 u_MullerC(
    .Z (C),
    .A (A),
    .B (B),
    .RN (~arst)
  );
  //assign C = !arst ? 1'b0 : A & B ;


`endif

   `ifdef RTL
      assign #2ns Q = C;
    `else
      assign Q = C;
    `endif
     
endmodule



module C3 (
                    input  logic A,
                    input  logic B,
                    input  logic C,
                    input  logic arst,
                    output logic Q   
               );


//`ifdef FPGA

   logic ck;  
   logic set;
   logic reset;
   logic resetWire;
   logic Y;
  
   HinstAnd3 u_AndGateSet(
    .a(A),
    .b(B),
    .c(C),
    .y(set)
   );
  
   HinstAnd3 u_AndGateReset(
    .a(~B),
    .b(~A),
    .c(~C),
    .y(reset)
   );
   
   assign ck    = 0;
   assign resetWire = reset| arst;
   
  // synopsys async_set_reset "set"
  // synopsys async_set_reset "resetWire"

   always @(set or resetWire) begin 
     if(resetWire)begin
       Y = 0;
     end
     else if(set)begin
       Y = 1;
     end
//     else begin
//       Y <= 0;
//     end
   end

//`else
//
//  logic C;
//
//  MC2CNX2_ES34 u_MullerC(
//    .Z (C),
//    .A (A),
//    .B (B),
//    .RN (~arst)
//  );
//  //assign C = !arst ? 1'b0 : A & B ;
//
//
//`endif

   `ifdef RTL
      assign #2ns Q = Y;
    `else
      assign Q = Y;
    `endif
     
endmodule

