/*
    `impl-buffer-toyNetlist.v'
    Balsa Verilog netlist file
    Created: Tue Jun 16 22:55:03 CEST 2015
    By: sokh@bushmills.nvlsi.no (Linux)
    With net-verilog (balsa-netlist) version: 4.0
    Using technology: BorealisTech/dual_b/sim=modelsim:logic=dims
    Command line : (balsa-netlist --technology BorealisTech/dual_b/sim=modelsim:logic=dims -I . -l impl-buffer-toyNetlist.lst -L impl-buffer-toyNetlist.log --simulation-initialise --basename impl-buffer-toyNetlist [buffer])

    Using `simulation-initialise'
    You must set the following preprocessor directives to use this file:
        balsa_simulate: set if you wish to initialise signal values during sim.
        balsa_init_time: duration of forced initialisation

    Using `propagate-globals'
    The design contains the following global nets
		global-signal:  initialise input 1
*/

`timescale 1ns/1ps

module BrzFetch_1_s5_false (
  activate_0r, activate_0a,
  inp_0r, inp_0a0d, inp_0a1d,
  out_0r0d, out_0r1d, out_0a
);
  input activate_0r;
  output activate_0a;
  output inp_0r;
  input inp_0a0d;
  input inp_0a1d;
  output out_0r0d;
  output out_0r1d;
  input out_0a;
  BUFFD1BWP7T I0 (activate_0r, inp_0r);
  BUFFD1BWP7T I1 (inp_0a0d, out_0r0d);
  BUFFD1BWP7T I2 (inp_0a1d, out_0r1d);
  BUFFD1BWP7T I3 (out_0a, activate_0a);
endmodule

module BrzLoop (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  wire nReq_0n;
  supply0 gnd;
  INVD1BWP7T I0 (activate_0r, nReq_0n);
  NR2D1BWP7T I1 (nReq_0n, activateOut_0a, activateOut_0r);
  BUFFD1BWP7T I2 (gnd, activate_0a);
endmodule

module telemr (
  Ar,
  Aa,
  Br,
  Ba,
  initialise
);
  input Ar;
  output Aa;
  output Br;
  input Ba;
  input initialise;
  wire s_0n;
  wire nreset_0n;
  MC2CNX2_ES34 I0 (Aa, Ba, Ar, nreset);
  INVD1BWP7T I1 (initialise, nreset);
  INVD1BWP7T I2 (Aa, s_0n);
  AN2D1BWP7T I3 (Ar, s_0n, Br);
endmodule

module BrzSequence_2_s1_T (
  activate_0r, activate_0a,
  activateOut_0r, activateOut_0a,
  activateOut_1r, activateOut_1a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output activateOut_0r;
  input activateOut_0a;
  output activateOut_1r;
  input activateOut_1a;
  input initialise;
  wire [1:0] sreq_0n;
  BUFFD1BWP7T I0 (activateOut_1a, activate_0a);
  BUFFD1BWP7T I1 (sreq_0n[1], activateOut_1r);
  BUFFD1BWP7T I2 (activate_0r, sreq_0n[0]);
  telemr I3 (sreq_0n[0], sreq_0n[1], activateOut_0r, activateOut_0a, initialise);
endmodule

module dualrail_latch (
  in_0,
  in_1,
  in_a,
  out_0,
  out_1,
  initialise
);
  input in_0;
  input in_1;
  output in_a;
  output out_0;
  output out_1;
  input initialise;
  wire clr;
  RSLATX1 I0 (out_1, out_0, clr, in_1);
  AO22D0BWP7T I1 (in_0, out_0, in_1, out_1, in_a);
  OR2D1BWP7T I2 (in_0, initialise, clr);
endmodule

module BrzVariable_1_1_s0_ (
  write_0r0d, write_0r1d, write_0a,
  read_0r, read_0a0d, read_0a1d,
  initialise
);
  input write_0r0d;
  input write_0r1d;
  output write_0a;
  input read_0r;
  output read_0a0d;
  output read_0a1d;
  input initialise;
  wire store_0n;
  wire store_1n;
  wire ldata_0n;
  wire ldata_1n;
  wire wack_0n;
  wire readReq_0n;
  AN2D1BWP7T I0 (store_1n, readReq_0n, read_0a1d);
  AN2D1BWP7T I1 (store_0n, readReq_0n, read_0a0d);
  BUFFD1BWP7T I2 (read_0r, readReq_0n);
  BUFFD1BWP7T I3 (ldata_0n, store_0n);
  BUFFD1BWP7T I4 (ldata_1n, store_1n);
  BUFFD1BWP7T I5 (wack_0n, write_0a);
  dualrail_latch I6 (write_0r0d, write_0r1d, wack_0n, ldata_0n, ldata_1n, initialise);
endmodule

module Balsa_buffer1 (
  activate_0r, activate_0a,
  i_0r, i_0a0d, i_0a1d,
  o_0r0d, o_0r1d, o_0a,
  initialise
);
  input activate_0r;
  output activate_0a;
  output i_0r;
  input i_0a0d;
  input i_0a1d;
  output o_0r0d;
  output o_0r1d;
  input o_0a;
  input initialise;
  wire c8_r;
  wire c8_a;
  wire c7_r;
  wire c7_a;
  wire c6_r0d;
  wire c6_r1d;
  wire c6_a;
  wire c5_r;
  wire c5_a;
  wire c4_r;
  wire c4_a0d;
  wire c4_a1d;
  BrzVariable_1_1_s0_ I0 (c6_r0d, c6_r1d, c6_a, c4_r, c4_a0d, c4_a1d, initialise);
  BrzLoop I1 (activate_0r, activate_0a, c8_r, c8_a);
  BrzSequence_2_s1_T I2 (c8_r, c8_a, c7_r, c7_a, c5_r, c5_a, initialise);
  BrzFetch_1_s5_false I3 (c7_r, c7_a, i_0r, i_0a0d, i_0a1d, c6_r0d, c6_r1d, c6_a);
  BrzFetch_1_s5_false I4 (c5_r, c5_a, c4_r, c4_a0d, c4_a1d, o_0r0d, o_0r1d, o_0a);
endmodule

