// tb for ToyVerilog

`timescale 1ns/1ps

module test_toyVerilog();
  
  localparam NUM_DATA = 10000;
  
  logic ck;
  logic ckDataIn;
  logic ckDataOut;
  logic arst;
  logic a;
  logic b;
  logic req;
  logic c;
  logic d;
  logic ack;

  
  // ---------------------------------------------
  // ---------------------------------------------
  // -- Local signals:
  // ---------------------------------------------
  int errorCnt;   
  int count = 0;
  int countReceive = 0;
  //logic [9:0] data = 10'b($urandom(1, 0));
  //static logic [NUM_DATA-1:0] data = 10'b1001010100;
  logic data;
  int count_a;
  int count_b;
  int count_c;
  int count_d;
  
  // ----------------------------------------------------------
  // -- Instantiation of DUT, EventMerger:
  // ----------------------------------------------------------

      DUT #()
                            
          u_DUT                
              ( 
              .ck                       (ck),
              .ckDataIn                 (ckDataIn),
              .ckDataOut                (ckDataOut),
              .arst                     (arst),
              .a                        (a),
              .b                        (b),
              .c                        (c),
              .d                        (d),
              .req                      (req),
              .ack                      (ack)
              //.dataRead                 (dataRead)
              );
 
  
  
  // ---------------------------------------------
  // -- Clocking :
  // ---------------------------------------------
  initial begin                                                                                   //testbench clock
        ck   = 1'b 0;
          while (1) begin
            #(20ns/2) ck = ~ck;          
          end
  end
  
 

  //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////---------------------------------------------------------------Testbench------------------------------------------------------------------------------------------////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
   
  initial begin 
    $timeformat (-6, 3, "us", 0);
    errorCnt = 0;  
    arst = 0;
    a=0;
    b=0;
    ack=0;
    ckDataIn   = 1'b 0;
    ckDataOut   = 1'b 0;
    #10ns;
    arst = 1;
    #10ns;
    arst = 0;


  
  
  //ta_sendData(data[count]);
  //ta_receiveData(data[countReceive]);
  data = $urandom_range(0,1);
  fork
    begin
      fork
        begin
          repeat (NUM_DATA) begin
            //ta_sendData(data[count]);
            ta_sendData(data);
            data = $urandom_range(0,1);
            //count++;
          end
        end
        
        begin
          repeat (NUM_DATA) begin
            //ta_receiveData(data[countReceive]);
            ta_receiveData(data);
            //countReceive++;
          end
        end
      join;
    end
    
    
    begin
      count_a = 0;
      forever begin
        @(a);
        count_a++;       
      end
    end
    
    begin
      count_b = 0;
      forever begin
        @(b);
        count_b++;       
      end     
    end
    
    begin
      count_c = 0;
      forever begin
        @(c);
        count_c++;     
        assert (count_c == count_a) else begin
          $error("%t : Glitch detected on line c", $time);
          errorCnt++;
        end
      end
    end
    
    begin
      count_d = 0;
      forever begin
        @(d);
        count_d++;   
        assert (count_d == count_b) else begin
          $error("%t : Glitch detected on line d", $time);
          errorCnt++;
        end
      end
    end
    
  join_any;
  disable fork;

  $display("total errors: %0d", errorCnt);

  $display(" $$(                           $$(                                $$\    ");
      $display(" $$ |                          (__|                               $$ |   ");
      $display(" $$$$$$$(   $$$$$$\  $$$$$$$$(  $$( $$$$$$$(   $$$$$$(   $$$$$$(   $$ |   ");
      $display(" $$  __$$(  (____$$( (____$$  |$$ |$$  __$$( $$  __$$( (____$$(   $$ |   ");
      $display(" $$ |  $$ | $$$$$$$ |  $$$$ _/ $$ |$$ |  $$ |$$ /  $$ | $$$$$$$ | (__|   ");
      $display(" $$ |  $$ |$$  __$$ | $$  _/   $$ |$$ |  $$ |$$ |  $$ |$$  __$$ |       ");
      $display(" $$$$$$$  |($$$$$$$ |$$$$$$$$( $$ |$$ |  $$ |($$$$$$$ |($$$$$$$ |  $$(    ");
      $display(" (_______/  (_______|(________|(__|(__|  (__| (____$$ | (_______|  (__|   ");
      $display("                                             $$(   $$ |                 ");
      $display("                                             ($$$$$$  |                 ");
      $display("                                              (______/                  ");
   $stop;
  end
  
 
 
 
  
  task ta_sendData(data);
    time randomDelay;
    
    randomDelay = $urandom_range(1,50);
    //@(posedge req);
    wait(req);
    a = ~data;
    b = data;
    
    #randomDelay;
    ckDataIn = 1;
    #10ns;
    ckDataIn = 0;
   
    randomDelay = $urandom_range(1,50);  
    //$display("Delay: %d", randomDelay);
    //@(negedge req);
    wait(!req);
    a = 0;
    b = 0;
    #randomDelay;
    ckDataIn = 1;
    #10ns;
    ckDataIn = 0;
    
  endtask
   
  task ta_receiveData(dataReceive);
    time randomDelay;
    
    randomDelay = $urandom_range(1,50);
    //@(posedge c or posedge d);
    wait(c | d);
    assert (c == ~dataReceive) else begin
      $error ("%t: Received data on 0 not same as data sent. Expecting data: %0b, Received data: %0b", $time, ~dataReceive, c);
      errorCnt++;
    end
    assert (d == dataReceive) else begin
      $error ("%t: Received data on 1 not same as data sent. Expecting data: %0b, Received data: %0b", $time, dataReceive, d);
      errorCnt++;
    end
    ack = 1;
    #randomDelay;
    ckDataOut = 1;
    #10ns;
    ckDataOut = 0;
    
    randomDelay = $urandom_range( 1,50);
    //@(negedge c or negedge d);
    wait(!c & !d)
    assert (c == 0) else begin
      $error ("%t: Received data on 0 not same as data sent. Expecting data: 0, Received data: %0b", $time, c);
      errorCnt++;
    end
    assert (d == 0) else begin
      $error ("%t: Received data on 1 not same as data sent. Expecting data: 0, Received data: %0b", $time, d);
      errorCnt++;
    end
    ack = 0;
    #randomDelay;
    ckDataOut = 1;
    #10ns;
    ckDataOut = 0; 
  endtask

endmodule