
module ToyVerilog ( ck, ckDataIn, ckDataOut, arst, initialise, activate_0r, 
        activate_0a, i_0a0d, i_0a1d, o_0r0d, o_0r1d, o_0a, a, b, req, c, d, 
        ack, i_0r_BAR );
  input ck, ckDataIn, ckDataOut, arst, activate_0a, o_0r0d, o_0r1d, a, b, ack,
         i_0r_BAR;
  output initialise, activate_0r, i_0a0d, i_0a1d, o_0a, req, c, d;
  wire   state_0_, N16, n3, n7, n9, n11, n13, n5, n6, n8, n10;

  DFCNQD1BWP7T state_reg_1_ ( .D(n13), .CP(ck), .CDN(n3), .Q(N16) );
  DFCNQD1BWP7T state_reg_0_ ( .D(n11), .CP(ck), .CDN(n3), .Q(state_0_) );
  DFCNQD1BWP7T initialise_reg ( .D(n9), .CP(ck), .CDN(n3), .Q(initialise) );
  DFCNQD1BWP7T activate_0r_reg ( .D(n7), .CP(ck), .CDN(n3), .Q(activate_0r) );
  DFCNQD1BWP7T i_0a1d_reg ( .D(b), .CP(ckDataIn), .CDN(n3), .Q(i_0a1d) );
  DFCNQD1BWP7T i_0a0d_reg ( .D(a), .CP(ckDataIn), .CDN(n3), .Q(i_0a0d) );
  DFCNQD1BWP7T o_0a_reg ( .D(ack), .CP(ckDataOut), .CDN(n3), .Q(o_0a) );
  CKND4BWP7T U3 ( .I(i_0r_BAR), .ZN(n5) );
  CKBD12BWP7T U4 ( .I(n6), .Z(req) );
  CKBD12BWP7T U5 ( .I(n8), .Z(c) );
  CKBD12BWP7T U6 ( .I(n10), .Z(d) );
  CKBD12BWP7T U7 ( .I(n5), .Z(n6) );
  CKBD12BWP7T U8 ( .I(o_0r0d), .Z(n8) );
  CKBD12BWP7T U9 ( .I(o_0r1d), .Z(n10) );
  OR2D0BWP7T U10 ( .A1(state_0_), .A2(N16), .Z(n13) );
  IOA21D0BWP7T U11 ( .A1(N16), .A2(state_0_), .B(n13), .ZN(n11) );
  IOA21D0BWP7T U12 ( .A1(N16), .A2(initialise), .B(n13), .ZN(n9) );
  MAOI22D0BWP7T U13 ( .A1(N16), .A2(state_0_), .B1(N16), .B2(activate_0r), 
        .ZN(n7) );
  INVD0BWP7T U14 ( .I(arst), .ZN(n3) );
endmodule


module dualrail_latch ( in_0, in_1, in_a, out_0, out_1, initialise );
  input in_0, in_1, initialise;
  output in_a, out_0, out_1;
  wire   clr;

  RSLATX1 I0 ( .R(clr), .S(in_1), .Q(out_1), .QN(out_0) );
  AO22D0BWP7T U1 ( .A1(in_0), .A2(out_0), .B1(out_1), .B2(in_1), .Z(in_a) );
  OR2D0BWP7T U2 ( .A1(in_0), .A2(initialise), .Z(clr) );
endmodule


module BrzVariable_1_1_s0_ ( write_0r0d, write_0r1d, write_0a, read_0r, 
        read_0a0d, read_0a1d, initialise );
  input write_0r0d, write_0r1d, read_0r, initialise;
  output write_0a, read_0a0d, read_0a1d;
  wire   store_1n, store_0n, ldata_0n, ldata_1n;

  BUFFD1BWP7T I3 ( .I(ldata_0n), .Z(store_0n) );
  BUFFD1BWP7T I4 ( .I(ldata_1n), .Z(store_1n) );
  dualrail_latch I6 ( .in_0(write_0r0d), .in_1(write_0r1d), .in_a(write_0a), 
        .out_0(ldata_0n), .out_1(ldata_1n), .initialise(initialise) );
  CKAN2D0BWP7T U1 ( .A1(read_0r), .A2(store_0n), .Z(read_0a0d) );
  CKAN2D0BWP7T U2 ( .A1(read_0r), .A2(store_1n), .Z(read_0a1d) );
endmodule


module BrzLoop ( activate_0r, activate_0a, activateOut_0r, activateOut_0a );
  input activate_0r, activateOut_0a;
  output activate_0a, activateOut_0r;


  INR2D0BWP7T U2 ( .A1(activate_0r), .B1(activateOut_0a), .ZN(activateOut_0r)
         );
endmodule


module telemr ( Ar, Aa, Br, Ba, initialise );
  input Ar, Ba, initialise;
  output Aa, Br;
  wire   n1;

  MC2CNX2_ES34 I0 ( .A(Ba), .B(Ar), .RN(n1), .Z(Aa) );
  INVD0BWP7T U1 ( .I(initialise), .ZN(n1) );
  INR2D0BWP7T U2 ( .A1(Ar), .B1(Aa), .ZN(Br) );
endmodule


module BrzSequence_2_s1_T ( activate_0r, activate_0a, activateOut_0r, 
        activateOut_0a, activateOut_1r, initialise, activateOut_1a_BAR );
  input activate_0r, activateOut_0a, initialise, activateOut_1a_BAR;
  output activate_0a, activateOut_0r, activateOut_1r;


  telemr I3 ( .Ar(activate_0r), .Aa(activateOut_1r), .Br(activateOut_0r), .Ba(
        activateOut_0a), .initialise(initialise) );
  INVD0BWP7T U1 ( .I(activateOut_1a_BAR), .ZN(activate_0a) );
endmodule


module BrzFetch_1_s5_false_0 ( activate_0r, activate_0a, inp_0a0d, inp_0a1d, 
        out_0r0d, out_0r1d, out_0a, inp_0r_BAR );
  input activate_0r, inp_0a0d, inp_0a1d, out_0a;
  output activate_0a, out_0r0d, out_0r1d, inp_0r_BAR;
  wire   n1, n3, n5;

  INVD0BWP7T U1 ( .I(n1), .ZN(activate_0a) );
  INVD0BWP7T U2 ( .I(out_0a), .ZN(n1) );
  INVD0BWP7T U3 ( .I(n3), .ZN(out_0r1d) );
  INVD0BWP7T U4 ( .I(inp_0a1d), .ZN(n3) );
  INVD0BWP7T U5 ( .I(n5), .ZN(out_0r0d) );
  INVD0BWP7T U6 ( .I(inp_0a0d), .ZN(n5) );
  INVD0BWP7T U7 ( .I(activate_0r), .ZN(inp_0r_BAR) );
endmodule


module BrzFetch_1_s5_false_1 ( activate_0r, inp_0r, inp_0a0d, inp_0a1d, 
        out_0r0d, out_0r1d, out_0a, activate_0a_BAR );
  input activate_0r, inp_0a0d, inp_0a1d, out_0a;
  output inp_0r, out_0r0d, out_0r1d, activate_0a_BAR;
  wire   n1, n4, n6;

  CKND4BWP7T U1 ( .I(n6), .ZN(out_0r0d) );
  CKND4BWP7T U2 ( .I(n4), .ZN(out_0r1d) );
  INVD0BWP7T U3 ( .I(inp_0a0d), .ZN(n6) );
  INVD0BWP7T U4 ( .I(inp_0a1d), .ZN(n4) );
  INVD0BWP7T U5 ( .I(n1), .ZN(inp_0r) );
  INVD0BWP7T U6 ( .I(activate_0r), .ZN(n1) );
  INVD0BWP7T U7 ( .I(out_0a), .ZN(activate_0a_BAR) );
endmodule


module Balsa_buffer1 ( activate_0r, activate_0a, i_0a0d, i_0a1d, o_0r0d, 
        o_0r1d, o_0a, initialise, i_0r_BAR );
  input activate_0r, i_0a0d, i_0a1d, o_0a, initialise;
  output activate_0a, o_0r0d, o_0r1d, i_0r_BAR;
  wire   c6_r0d, c6_r1d, c6_a, c4_r, c4_a0d, c4_a1d, c8_r, c8_a, c7_r, c7_a,
         c5_r, c5_a;

  BrzVariable_1_1_s0_ I0 ( .write_0r0d(c6_r0d), .write_0r1d(c6_r1d), 
        .write_0a(c6_a), .read_0r(c4_r), .read_0a0d(c4_a0d), .read_0a1d(c4_a1d), .initialise(initialise) );
  BrzLoop I1 ( .activate_0r(activate_0r), .activateOut_0r(c8_r), 
        .activateOut_0a(c8_a) );
  BrzSequence_2_s1_T I2 ( .activate_0r(c8_r), .activate_0a(c8_a), 
        .activateOut_0r(c7_r), .activateOut_0a(c7_a), .activateOut_1r(c5_r), 
        .initialise(initialise), .activateOut_1a_BAR(c5_a) );
  BrzFetch_1_s5_false_0 I3 ( .activate_0r(c7_r), .activate_0a(c7_a), 
        .inp_0a0d(i_0a0d), .inp_0a1d(i_0a1d), .out_0r0d(c6_r0d), .out_0r1d(
        c6_r1d), .out_0a(c6_a), .inp_0r_BAR(i_0r_BAR) );
  BrzFetch_1_s5_false_1 I4 ( .activate_0r(c5_r), .inp_0r(c4_r), .inp_0a0d(
        c4_a0d), .inp_0a1d(c4_a1d), .out_0r0d(o_0r0d), .out_0r1d(o_0r1d), 
        .out_0a(o_0a), .activate_0a_BAR(c5_a) );
endmodule


module DUT ( ck, arst, ckDataIn, ckDataOut, a, b, req, c, d, ack );
  input ck, arst, ckDataIn, ckDataOut, a, b, ack;
  output req, c, d;
  wire   initialise, activate_0r, i_0r, i_0a0d, i_0a1d, o_0r0d, o_0r1d, o_0a,
         n1, n2, n3;

  ToyVerilog u_ToyVerilog ( .ck(ck), .ckDataIn(n2), .ckDataOut(ckDataOut), 
        .arst(arst), .initialise(initialise), .activate_0r(activate_0r), 
        .activate_0a(n3), .i_0a0d(i_0a0d), .i_0a1d(i_0a1d), .o_0r0d(o_0r0d), 
        .o_0r1d(o_0r1d), .o_0a(o_0a), .a(a), .b(b), .req(req), .c(c), .d(d), 
        .ack(ack), .i_0r_BAR(i_0r) );
  Balsa_buffer1 u_Balsabuffer1 ( .activate_0r(activate_0r), .i_0a0d(i_0a0d), 
        .i_0a1d(i_0a1d), .o_0r0d(o_0r0d), .o_0r1d(o_0r1d), .o_0a(o_0a), 
        .initialise(initialise), .i_0r_BAR(i_0r) );
  INVD0BWP7T U1 ( .I(ckDataIn), .ZN(n1) );
  INVD0BWP7T U2 ( .I(n1), .ZN(n2) );
  TIELBWP7T U3 ( .ZN(n3) );
endmodule

