#**************************************************************
# CLOCKS
# - Set clock constraints                                       
#**************************************************************
# Define clocks as near the source as possible.
# Define *ALL* clocks, including spi, oci etc.
# If clocks are muxed together, still define all clock sources and not only on the output of the mux.
# Always define clock uncertainty. Remember to include the uncertainty from the source itself.

# FifoAsyncCl clocks:

#                ck32M/ck16M
# ck32M/ck16M    0.2        

create_clock -name "ck" -p 31.2 -w [list 0 15.6]  [get_port "ck"]
#	     -comment "32 MHz Write clock"
#set_dont_touch_network "ckWrite32M"
#set_clock_transition 0.2 ckWrite32M
#set_clock_uncertainty -setup 0.20 -rise_from [get_clocks "ckWrite32M"] -rise_to [get_clocks "ckWrite32M"]
#set_clock_uncertainty -setup 0.20 -fall_from [get_clocks "ckWrite32M"] -fall_to [get_clocks "ckWrite32M"]
#set_clock_uncertainty -setup 0.80 -rise_from [get_clocks "ckWrite32M"] -fall_to [get_clocks "ckWrite32M"]
#set_clock_uncertainty -setup 0.80 -fall_from [get_clocks "ckWrite32M"] -rise_to [get_clocks "ckWrite32M"]
#set_clock_uncertainty -hold  0.10 [get_clocks "ckWrite32M"]
#
#
#create_clock -name "ckRead32M" -p 31.2 -w [list 0 15.6]  [get_port "ckRead"] \
#-comment "32 MHz Read clock"
#set_dont_touch_network "ckRead32M"
#set_clock_transition 0.2 ckRead32M
#set_clock_uncertainty -setup 0.20 -rise_from [get_clocks "ckRead32M"] -rise_to [get_clocks "ckRead32M"]
#set_clock_uncertainty -setup 0.20 -fall_from [get_clocks "ckRead32M"] -fall_to [get_clocks "ckRead32M"]
#set_clock_uncertainty -setup 0.80 -rise_from [get_clocks "ckRead32M"] -fall_to [get_clocks "ckRead32M"]
#set_clock_uncertainty -setup 0.80 -fall_from [get_clocks "ckRead32M"] -rise_to [get_clocks "ckRead32M"]
#set_clock_uncertainty -hold  0.10 [get_clocks "ckRead32M"]

#**************************************************************
# CLOCKS GROUPS
#**************************************************************

#************************************
set high_fanout_net_threshold 0
#set_ideal_net [get_nets]
## set_ideal_net [all_high_fanout -nets -threshold 100]
#set_ideal_network -no_propagate [all_high_fanout -nets -threshold 100]

#*************************************************************
# Set drive and load constraints                              
#*************************************************************
#-- Drive
set_input_transition 5.0 [all_inputs]

#-- Load
set_load 10 [all_outputs]

#-- Max transition
set_max_transition 2.0 [find design "*"]

#-- Fan-in
# set_max_fanout 5  [all_inputs] 

#set_min_delay 2.0 -from countOut_reg_0_/CP -to countOut_reg_0_/D
#set_min_delay 0.6 -from [get_cell countOut*] -to [get_cell countOut*] 
# The above line uses the names CountOut and not CountOut_reg_0_ . This is done because dc understands names at the rtl level. i.e. CountOut. CountOut_reg_0 are names in the netlist after synthesis.

#set_max_delay 0.6 -from countOut_reg[0] -to countOut_reg[2]
#set_min_delay 2.0 -from countOut_reg[0] -to countOut_reg[2]
#set_max_delay 3.0 -from countOut_reg[0] -to stop_reg
#set_min_delay 1.8 -from countOut_reg[0] -to stop_reg

#set_fix_hold ck

#set_data_check -from  countOut_reg_1_/D -to countOut_reg_0_/D 2
#set_data_check -from countOut_reg[1]/D -to countOut_reg[0]/D 2 -clock ck
#set_min_delay 1 -from stop_reg/Q -to u_MullerCElement/A

#*************************************************************
# IO timing
#*************************************************************

##*************************************************************
## False paths and multicycle paths
##*************************************************************

######
# Add delay in the balsa "Variable" to make the simulation fail

set_attribute u_Balsabuffer1/I0/I3  dont_touch true
set_attribute u_Balsabuffer1/I0/I4  dont_touch true

# Change this delay in the SDF
#(INSTANCE u_Balsabuffer1/I0/I3)   AND I4
#(DELAY
#  (ABSOLUTE
#  (IOPATH I Z (2.057::2.059) (2.060::2.062))   <- Increase this numbers with 2ns

