puts "RM-Info: Running script [info script]\n"

##########################################################################################
# Variables common to all reference methodology scripts
# Script: common_setup.tcl
# Version: J-2014.09 (October 6, 2014)
# Copyright (C) 2007-2014 Synopsys, Inc. All rights reserved.
##########################################################################################

set VC_WORKSPACE [getenv "VC_WORKSPACE"]

set DESIGN_NAME                   "DUT"  ;#  The name of the top-level design

set DESIGN_REF_DATA_PATH          ""  ;#  Absolute path prefix variable for library/design data.
                                       #  Use this variable to prefix the common absolute path  
                                       #  to the common variables defined below.
                                       #  Absolute paths are mandatory for hierarchical 
                                       #  reference methodology flow.

##########################################################################################
# Hierarchical Flow Design Variables
##########################################################################################

set HIERARCHICAL_DESIGNS           "" ;# List of hierarchical block design names "DesignA DesignB" ...
set HIERARCHICAL_CELLS             "" ;# List of hierarchical block cell instance names "u_DesignA u_DesignB" ...

##########################################################################################
# Library Setup Variables
##########################################################################################

# For the following variables, use a blank space to separate multiple entries.
# Example: set TARGET_LIBRARY_FILES "lib1.db lib2.db lib3.db"

set ADDITIONAL_SEARCH_PATH        ""  ;#  Additional search path to be added to the default search path

set TARGET_LIBRARY_FILES          "${VC_WORKSPACE}/library/tcbn55lpbwp7t/liberty/tcbn55lpbwp7t_1V2SS-25C.db \
                                   ${VC_WORKSPACE}/library/TCBN55LPBWP7THVT_ES34/1.0/liberty/TCBN55LPBWP7THVT_ES34_1V0TT25C.db \
                                   ${VC_WORKSPACE}/library/SRLAT/liberty/SR_LATCH_LIB_1V1TT25C.db \
                                  "  ;#  Target technology logical libraries
set ADDITIONAL_LINK_LIB_FILES     ""  ;#  Extra link logical libraries not included in TARGET_LIBRARY_FILES

set MIN_LIBRARY_FILES             ""  ;#  List of max min library pairs "max1 min1 max2 min2 max3 min3"...

#set MW_REFERENCE_LIB_DIRS         "${VC_WORKSPACE}/library/TCBN55LPBWP7THVT_ES34/1.0/milkyway  \
#                                   /n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/cell_frame/tcbn55lpbwp7t \
#                                  " ; #  Milkyway reference libraries (include IC Compiler ILMs here)
#set MW_REFERENCE_LIB_DIRS         "${VC_WORKSPACE}/library/TCBN55LPBWP7THVT_ES34/1.0/milkyway  \

set MW_REFERENCE_LIB_DIRS         "${VC_WORKSPACE}/library/tcbn55lpbwp7t/milkyway/TCBN55LPBWP7T_S2_LIB \
                                   ${VC_WORKSPACE}/library/tcbn55lpbwp7t/milkyway/tcbn55lpbwp7t_iso_lib \
                                   ${VC_WORKSPACE}/library/tcbn55lpbwp7t/milkyway/tcbn55lpbwp7t_LIB \
                                   ${VC_WORKSPACE}/library/tcbn55lpbwp7t/milkyway/TCBN55LPBWP7T_S2_LIB \
                                  "  ; 


set MW_REFERENCE_CONTROL_FILE     ""  ;#  Reference Control file to define the Milkyway reference libs

#set TECH_FILE                     "/n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tsmcn55_5lmT1.tf"  ;#  Milkyway technology file
set TECH_FILE                     "/n/caduser/tools/icc/techfiles/TSMC/tsmc55/CLN55S_5M_3X1Z.20b/tsmcn55_5lmT1_nordic_v1.1.tf"  ;#  Milkyway technology file
set MAP_FILE                      "/n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/star.map_5M"  ;#  Mapping file for TLUplus
set TLUPLUS_MAX_FILE              "/n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/cln55lp_1p05m_and_28k_alrdl_3x1z_cworst.tluplus"  ;#  Max TLUplus file
set TLUPLUS_MIN_FILE              "/n/library/tsmc/55n/libraries/tcbn55lpbwp7t/200b/milkyway/tcbn55lpbwp7t_200a/techfiles/tluplus/cln55lp_1p05m_and_28k_alrdl_3x1z_rcbest.tluplus"  ;#  Min TLUplus file





set MIN_ROUTING_LAYER            ""   ;# Min routing layer
set MAX_ROUTING_LAYER            ""   ;# Max routing layer

set LIBRARY_DONT_USE_FILE        ""   ;# Tcl file with library modifications for dont_use

##########################################################################################
# Multivoltage Common Variables
#
# Define the following multivoltage common variables for the reference methodology scripts 
# for multivoltage flows. 
# Use as few or as many of the following definitions as needed by your design.
##########################################################################################

set PD1                          ""           ;# Name of power domain/voltage area  1
set VA1_COORDINATES              {}           ;# Coordinates for voltage area 1
set MW_POWER_NET1                "VDD1"       ;# Power net for voltage area 1

set PD2                          ""           ;# Name of power domain/voltage area  2
set VA2_COORDINATES              {}           ;# Coordinates for voltage area 2
set MW_POWER_NET2                "VDD2"       ;# Power net for voltage area 2

set PD3                          ""           ;# Name of power domain/voltage area  3
set VA3_COORDINATES              {}           ;# Coordinates for voltage area 3
set MW_POWER_NET3                "VDD3"       ;# Power net for voltage area 3

set PD4                          ""           ;# Name of power domain/voltage area  4
set VA4_COORDINATES              {}           ;# Coordinates for voltage area 4
set MW_POWER_NET4                "VDD4"       ;# Power net for voltage area 4

puts "RM-Info: Completed script [info script]\n"

